2019-08-06  Per Bothner  <per@bothner.com>

	* conigure.ac: Change missing Posix find from error to warning.
	This is an attempt to fix GitLab Continuous Integration.

2018-09-29  Per Bothner  <per@bothner.com>

	* bin/kawa.sh.in: Set kawa.command.pid property.

2018-09-07  Per Bothner  <per@bothner.com>

	* configure.ac: Handle --with-java-source=10 and above.

2018-09-06  Mathieu Lirzin <mthl@gnu.org>

	* autogen.sh: Use autoreconf --install.
	This installs the various autotools helper files in build-aux.

2018-04-15  Per Bothner  <per@bothner.com>

	Fix build for --without-lps4 case.
	* kawa/repl.java: Use reflection to call KawaLanguageServer.main.
	* source-list: Conditionalize KAWA_LANGSERVER_JSOURCES.

2018-04-12  Per Bothner  <per@bothner.com>

	Initial support for LSP (Language Server Proptocol).
	* configure.ac: Support --with-lsp4j and --with-gson.
	* config.classpath: Add lsp4j and gson to classpath.
	* Makefile.am: Related changes.
	* kawa/langserver/KawaLanguageServer.java: New server logic.
	* source-list: Update accordingly.
	* kawa/repl.java: Handle --langserver option.

2018-04-09  Per Bothner  <per@bothner.com>

	* Makefile.am (lib/jline.jar, lib/domterm.jar):
	Remove old symlinks before creating new ones.

2017-11-21  Sudarshan S Chawathe <chaw@eip10.org>

	* gnu/kawa/slib/srfi14.scm: Change non-tail to tail recursion in
	%make-boundary-pairs to avoid stack overflow for large inputs.

2017-11-08  Helmut Eller  <eller.helmut@gmail.com>

	* source-list (GNU_COMMONLISP_LANG_JSOURCES): Add CLReadTable.java.

2017-10-22  Per Bothner  <per@bothner.com>

	Normally convert kawa.sh.in to plain kawa rather than kawa.sh.
	This avoids bin/kawa being a symlink to bin/kawa.sh, which avoids a
	dependency on 'readlink -f' (not supported on Mac) in typical use.
	* configure.ac: Process 'bin/kawa.sh.in' to 'bin/kawa', or bin/kawa.sh'
	when either on Windows or --enable-kawa-frontend.
	* Makefile.am: Use KAWA_SCRIPT variable as appropriate.

2017-10-02  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 3.0.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2017-08-29  Kay Zheng <l04m33@gmail.com>

	* Makefile.am: Use JAVACFLAGS two more places.

2017-08-27  Per Bothner  <per@bothner.com>

	* Makefile.am (distall): Buld kawa.zip.

2017-07-28  Sudarshan S Chawathe  <chaw@eip10.org>

	* gnu/lists/IString.java (SubString): Fix offset for substring of
	substring for istrings; fixes GitLab issue #16.

2017-07-15  Per Bothner  <per@bothner.com>

	* configure.ac: Configure (and make) bin unconditionally.
	This so cgi-servlet is built even if the frontend isn't.

2017-06-10  Per Bothner  <per@bothner.com>

	* configure.ac: Default to Java 8, as intended.

2017-05-03  Per Bothner  <per@bothner.com>

	* build.xml: Various fixes and updates.

2017-04-30  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.93.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2017-04-30  Per Bothner  <per@bothner.com>

	Change source files to default to Java 8.
	* Makefile.am (dist-kawa.jar): Build with Java 8 rather than Java 7.

2017-03-25 Vasantha Ganesh K <vasanthaganesh.k@tuta.io>
	* .gitlab-ci.yml GitLab's CI support

2017-03-19  Sudarshan S Chawathe  <chaw@eip10.org>

	* gnu/mapping/RunnableClosure.java (getResult): Add public
	modifier to enable calling getResult as suggested by manual.

2017-02-24  Per Bothner  <per@bothner.com>

	Various places change @deprecated comment to @Deprecated annotation.
	Java-9 warns about the former and prefer the latter.

2017-01-18  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.91_invoke
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2017-01-15  Per Bothner  <per@bothner.com>

	Fixed a lot of JavaDoc errors.

2017-01-13  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.3.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2017-01-10  Per Bothner  <per@bothner.com>

	* configure.ac: --with-domterm value is "domterm home",
	rather than the jar file.
	* Makefile.am: Update accordingly.
	* config.classpath: Update.

2016-12-09  Per Bothner  <per@bothner.com>

	Moved some files from gnu/kawa/slib to kawa/lib.
	The latter now assume they are compiled using two separate commands.
	* build.xml: Update accordingly.

2016-11-25  Per Bothner  <per@bothner.com>

	* README.md: Convert to Markdown from README.
	This is better for the gitlab Kawa home page.
	* configure.ac: Change automake style to 'foreign' due to missing README.

	* Makefile.am: Update --version output for git.

	* configure.ac: Add --with-docbook-stylesheets option.
	* doc/Makefile.am: Make use of it.

2016-11-22  Per Bothner  <per@bothner.com>

	* Makefile.am: Fixes so 'make install' twice in a row works.

2016-11-20  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.2.1.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2016-11-12  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.2.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2016-11-07  Per Bothner  <per@bothner.com>

	* bin/browse-kawa-manual.in: Move to doc/browse-kawa-manual.
	It's no longer suggested because of the link issue mentioned.
	* Makefile.am: No longer include it in snapshots.
	* configure.ac: Don't configure bin/browse-kawa-manual.in.

2016-11-02  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.1.91.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2016-11-01  Per Bothner  <per@bothner.com>

	* configure.ac: Remove obsolete --with-jline2 option.
	* Makefile.am: Update accordingly.
	* source-list: Update accordingly.

2016-10-29  Per Bothner  <per@bothner.com>

	* source-list: Don't build gnu.kawa.models unless WITH_AWT.
	* Makefile.am (PREPROCESS_AWT): Set (or not) use:java.awt PreProcess
	option, depending on WITH_AWT.
	* configure.ac: Option --with-swing defaults to no if --without-awt.

2016-10-16  Per Bothner  <per@bothner.com>

	* configure.ac: Make maintainer-mode the default.
	Put info files in builddir.
	* Makefile.am (tmp-sources1.list): Also depend on Makefile.am.

2016-10-16  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (generate-simplevector-files)
	(clean-generated-simplevector-files): New targets to generate and
	clean PrimVector.template-based source files.

2016-10-13  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (lib-scm-classes): Update for new libraries (kawa
	process-keywords) and (kawa swing).

2016-09-03  Per Bothner  <per@bothner.com>

	* configure.ac: Recognize --with-java-source=9.

2016-08-14  Per Bothner  <per@bothner.com>

	* Makefile.am: Remove version number for jar file names.
	* kawa.sh.in: Likewise.
	* kawa.sh.in: Use JAVA_HOME if it is set.

2016-07-26  Per Bothner  <per@bothner.com>

	Re-implement conversion to SVG without using external library.
	* configure.ac, config.classpath: Remove --with-vectorgraphics2d option.
	* Makefile.am, bin/kawa.bat.in: Remove use of VectorGraphics2D.

2016-07-20  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (script-factory-scheme, script-factory-xquery): Make
	sure META-INF/services directory exists before writing to
	META-INF/services/javax.script.ScriptEngineFactory file.

2016-07-13  Per Bothner  <per@bothner.com>

	Replace use of JFreeSVG with VectorGraphics2D library.
	The former is strict GPL, which could be a problem.
	* configure.ac: Replace --with-with_jfreesvg by --with-vectorgraphics2d.
	* config.classpath: Update accordingly.
	* Makefile.am: Link in and copy new library.
	* bin/kawa.bat.in: Add new library.

	* Makefile.am (kawa/Version.java): Update check for Subversion.

2016-07-11  Per Bothner  <per@bothner.com>

	* Makefile.am: Some tweaks for faster re-compilation.
	Specifically, don't make javac look at all files when only
	some are changed.  The downside is we could run into command line
	limits more easily, so we use the @filelist method for clean builds.

2016-07-01  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa-snapshot.zip): Add lib/servlet.jar.
	* bin/kawa.sh.in: Simplify - just use run_classpath.
	* config.classpath: Update run_classpath for using links in lib.

2016-07-01  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml: Fix for relocated JEmacs files.

2016-06-26  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa-snapshot.zip): Include the Kawa manual in
	epub3 format, as well as scripts and advice for reading it.

2016-06-24  Per Bothner  <per@bothner.com>

	* source-list: Don't include kawa/Version.java, because it could
	be in either srcdir or builddir, which complicates things.
	* Makefile.am: Update to build Version.class separately.

2016-06-22  Per Bothner  <per@bothner.com>

	* Makefile.am: Make bin/kawa a link to bin/kawa.sh if not using the
	C/readline front-end.

	Generated Makefile.in and configure removed from repository.
	* autogen.sh: Script to generates those files.

	* Makefile.am: Merge the Makefiles of gnu/math, gnu/commonlisp/lang,
	gnu/xquery/lang, gnu/xquery/util, gnu/q2/lang, and kawa into
	source.list and the top-level Makefile.
	(tmp-sources1.list): Build list of source file names for '@' argument
	passed to javac, to limit command-line length.

	* Makefile.am: Pull most of logic from gnu/Makefile.am here.
	This is a step to having fewer Makefiles.
	(source-list): New separate list of files, for inclusion.

2016-06-14  Per Bothner  <per@bothner.com>

	* Makefile.am: Add domterm.jar to kawa.zip.
	* bin/kawa.sh.in: Add dmterm.jar to classpath.

	* configure.ac: Implement new --with-domterm option.
	* config.classpath: Update classpath.

2016-06-03  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.1.9.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

	* Makefile.am (kawa-snapshot.zip): New rule.

2016-05-07  Per Bothner  <per@bothner.com>

	* configure.ac: Support --with-jline3 flag in addition to jline2.
	* Makefile.am: LRelated changes.

	* configure.ac: Convert to kawa.bat.in kawa.bat using configure.
	* Makefile.am (bin/kawa.bat): Comment out rule.

2016-04-17  Per Bothner  <per@bothner.com>

	* Makefile.am: Update uninstall rules so 'make distcheck' works again.

2016-03-12  Per Bothner  <per@bothner.com>

	Enable "binary distributions" using jawa.sh and jline2.
	* Makefile.am (kawa-$(VERSION).zip): New rule.
	The jat files are now in the lib subdirectory.
	* config.classpath: New variable run_classpath does not include jline.
	* configure.ac (run_classpath): New variable.

2016-02-14  Per Bothner  <per@bothner.com>

	Add support for JLine2 as a readline alternative.
	* configure.ac" New --with-jline2 flag.
	(WITH_JLINE2_ARG. WITH_JLINE2): New argument and conditional.
	* config.classpath: Adjust classpath based on --with-jline2 flag.
	* Makefile.am (dist-kawa-@VERSION@.jar): Build jline2 support,
	without requiring it.

2016-01-26  Per Bothner  <per@bothner.com>

	* configure.ac: Fix case when --with-java-source is defaulted.

2015-12-21  Per Bothner  <per@bothner.com>

	* configure.ac: Handle mapping from JAVA_SOURCE to PreProcess
	token at configure time, rather than make time.
	* Makefile.am: Simplify Prepocess handling.
	(JAVA_PREPROCESS_OPTIONS): New variable - selector to PreProcess.
	(selected-java-source): Compare JAVA_PREPROCESS_OPTIONS rather
	than solely JAVA_SOURCE.

	* configure.ac: Move some logic to new file ...
	* config.classpath: ... so it can be shared with bin/configure.ac.

2015-10-28  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.1.1.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2015-10-26  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.1.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2015-09-20  Per Bothner  <per@bothner.com>

	* configure.ac: Fix to avoid bogus calls to chmod.

2015-08-10  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (lib-scm-classes): Add rnrs/arithmetic/bitwise.scm.

2015-07-31  Per Bothner  <per@bothner.com>

	* Makefile.am: Many subclasses of gnu.lists.SimpleVector are now
	auto-generated from PrimVector.template.  Do so.

2015-06-03  Per Bothner  <per@bothner.com>

	* build.xml (kawa.sh): Add dependency on build-settings.
	(clean-build): Remove bin/kawa.sh.

2015-06-02  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (-maybe-select-java{2,4,5,6,7}): Use both "if" and
	"unless" attributes so that only one of the select-java* targets
	gets called.

2015-05-19  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (has-java{2,4,5,6,7,8}): Move out of
	-select-java-non-android up to top level so that they are defined
	in the initial Ant environment.
	(java-classes): Add q2.

2015-05-13  Per Bothner  <per@bothner.com>

	* compile: New file, from gnulib, used by autoconf.

2015-02-27  Per Bothner  <per@bothner.com>

	* build.xml (java-classes): Add kawa/Source*.java.

2015-02-17  Per Bothner  <per@bothner.com>

	* configure.ac: Remove WITH_LIBTOOL macro and --with-libtool option.
	* Make-rules: Remove libtool junk.

	* build.xml (lib-scm-classes): Update to match kawa/lib/Makefile.am.

2015-01-20  Per Bothner  <per@bothner.com>

	* configure.ac: Remove most links, to avoid Windows problems.

	* config.guess: Update to new version, from gnulib.
	* config.sub: Likewise.
	* mkinstalldirs: Likewise.

2014-12-28  Per Bothner  <per@bothner.com>

	* build.scm (slib-scm-classes): Add receive.scm.

2014-12-03  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.0.1.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

2014-12-01  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 2.0.
	* bin/configure.in (AC_INIT): Likewise.
	* build.xml (version.release): Likewise.

	* build.xml (lib-scm-classes): Fix and update filelist.

2014-11-19  Per Bothner  <per@bothner.com>

	* bin/kawa.sh.in: Use KAWA_SHELL instead of SHELL variable.
	* configure.ac: Determine and export KAWA_SHELL.
	* build.xml (kawa.shell): New property.
	(kawa.sh): Substitute KAWA_SHELL based on kawa.shell property.

2014-11-19  Per Bothner  <per@bothner.com>

	* bin/kawa.sh.in: Use SHELL autoconf variable.
	* build.xml (kawa.sh): Substitute SHELL.

	* bin/kawa.sh.in: Simplify so kawa.sh only works for in-place running.
	* Makefile.am (install-binSCRIPTS): Use sed to munge KAWALIB in kawa.sh.
	* build.xml (kawa.sh): Simplify.

2014-11-19  Per Bothner  <per@bothner.com>

	* build.xml (kawa.sh): Build bin/kawa.sh from bin/kawa.sh.in.

2014-11-18  Per Bothner  <per@bothner.com>

	* configure.ac (AC_CONFIG_FILES): Add bin/kawa.sh.
	* Makefile.am (bin/kawa.sh): Remove rule.  Now generated by configure.
	(EXTRA_DST): Add bin/kawa.sh.in.

2014-11-17  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (lib-scm-classes): Add quaternions.scm.

2014-10-28  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add remaining R7RS standard libraries.

2014-10-14  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.90.
	* build.xml (version.release): Likewise.

2014-09-28  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add new R7RS standard libraries.

2014-09-26  Per Bothner  <per@bothner.com>

	* build.xml: 'define-record-type' was moved from gnu.kawa.slib
	to kawa.lib.

2014-08-31  Per Bothner  <per@bothner.com>

	* Makefile.am: Each Makefile from gnu/expr, gnu/mapping, gnu/lists
	and gnu/text were merged into gnu/Makefile.
	* configure.ac: Likewise.

2014-08-28  Per Bothner  <per@bothner.com>

	* Makefile.am: Remove Makefiles from intermediate directories
	gnu/commonlisp gnu/xquery/gnu/q2.
	Fold Makefile in gnu/kawa/xslt into gnu directory.
	* configure.ac: Update accordingly.

2014-08-21  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add parameterize.scm.
	* classes-to-skip-for-runtime: Add some more classes.

	* build.xml (android-classes): Add utils.scm.

2014-08-20  Per Bothner  <per@bothner.com>

	* build.xml: Fix support for enable.android, by adding android.path
	to the build.path.
	* build.properties (android.path): Set defaul value.

	* build.xml (lib-scm-classes): Add case_syntax.scm.

2014-08-04  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add compile_map.scm.

2014-07-22  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add string-cursors.scm.

2014-07-07  Matthieu Vachon <matthieu.o.vachon@gmail.com>

	* build.xml: Add some missing Scheme files.

2014-07-02  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Remove some new classes.

2014-02-27  Per Bothner  <per@bothner.com>

	* Makefile.am (patch-source-list): Add dependency on configure.
	(MAINTAINERCLEANFILES): New macro, bound to patch-source-list.

2014-02-20  Per Bothner  <per@bothner.com>

	* configure.ac: Add missing AC_CANONICAL_HOST.

	* configure.ac: Add test for Posix find, setting FIND variable.
	* Makefile.am (FIND): New variable.  Use it.

	* configure.ac: Separately configure bin, and move code that needs
	a C compiler there, requried only enable_kawa_frontend is set.
	Remove GCJ support.
	* Makefile.am: Likewise.
	* Make-rules: Remove GCJ support.

2014-02-18  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (slib-scm-classes): Add srfi60.scm.

2014-02-06  Per Bothner  <per@bothner.com>

	* build.xml (commonlisp-scm-classes): Make sure to compile
	primitives.lisp.

	* Makefile.am (COMMENT_IN, COMMENT_OUT): Remove unused macros.

2014-01-06  Per Bothner  <per@bothner.com>

	* Makefile.am (dist-kawa-@VERSION@.jar): Configure for Java 7.
	* configure.in: Default JAVA_SOURCE to 7, rather than 6.

	* missing: Get newer version from upstream.

	Change checked-in versions to the JAVA7 version.

2014-01-05  Per Bothner  <per@bothner.com>

	Fold the Makefile.am of gnu/xml, gnu/kawa/xml, gnu/ecmascript,
	gnu/kawa/swingviews, gnu/kawa/swtviews, gnu/kawa/ant, and
	gnu/kawa/sax into gnu/Makefile.am.

	Fold the Makefile.am of gnu/kawa/util, gnu/kawa/reflect,
	gnu/kawa/functions, gnu/kawa/lispexpr, and gnu/kawa/models
	into new gnu/Makefile.am
	* Makefile.am (SUBDIRS): Update accordingly.
	* configure.ac (AC_CONFIG_FILES): Likewise.

2013-12-22  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm-classes): Add missing classes.

2013-10-04  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.14.1.
	* build.xml (version.release): Likewise.

2013-09-28  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.14.
	* build.xml (version.release): Likewise.

2013-09-23  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa-doc-$(VERSION).tar.gz): Update,
	since kawa-tour.texi is now gone.

2013-09-16  Per Bothner  <per@bothner.com>

	* Makefile.am: Add Java8 support.
	(select-java8): New rule.
	* condigure.ac: Add Java8 support.
	* build.xml: Likewise.

2013-06-16  Per Bothner  <per@bothner.com>

	* configure.ac (AC_CONFIG_FILES): Remove kawa/lang/Makefile
	and kawa/standard/Makefile.

2013-03-23  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa/Version.java): Add $(srcdir) reference.

2013-01-13  Per Bothner  <per@bothner.com>

	* configure.in: Renamed to ...
	* configure.ac: ... new name, following current preferred autoconf
	practice.
	* Makefile.am (kawa/Version.java): Update accordingly.

2012-12-14  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml: Use filelist instead of fileset to force compilation
	order for Scheme source files.

2012-12-12  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.13.1.
	* build.xml (version.release): Likewise.

2012-12-08  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.13.
	* build.xml (version.release): Likewise.

2012-11-21  Per Bothner  <per@bothner.com>

	* configure.in: Try harder to find jfxrt.jar.

	* Makefile.am (+DISTCLEANFILES): New macro - add selected-java-source.
	(selected-java-source, set-selected-java-source): Change
	selected-java-source to be in current directory, not srcdir.

2012-07-28  Per Bothner  <per@bothner.com>

	* configure.in: Don't default to with-httpserver or Java6
	if configured for Android.

2012-07-10  Per Bothner  <per@bothner.com>

	* build.xml (xml-classes): Added Xutils.scm.

2012-07-03  Per Bothner  <per@bothner.com>

	* build.xml: Some cleanups for with-awt dependeny, which
	should benefit Android.

2012-05-31  Per Bothner  <per@bothner.com>

	* configure.in: Change argument to --with-javafx to be actual jfxrt.jar
	though also supporting old meaning.
	Also a fix for servlet path.

2012-05-30  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.12.1.
	* build.xml (version.release): Likewise.

2012-05-28  Per Bothner  <per@bothner.com>

	* Makefile.am (dist-kawa-@VERSION@.jar): Build with javafx support.
	* configure.in: Related changes.

2012-05-24  Jacques Herry

	* build.xml (jar): Fix.

2012-05-25  Per Bothner  <per@bothner.com>

	* configure.in (WITH_SERVLET_ARG): New variable.
	* Makefile.am (dist-kawa-@VERSION@.jar): Include serlet jar's
	location in build classpath.

	* Makefile.am: Use CLASSPATH_SEPARATOR for the sake of CygWin.

2012-05-20  Jacques Herry

	* build.xml: Fix to build META_INFO/services.

2012-05-20  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml: "Inline" named filesets lib-scm and slib-scm to their
	point of use, fixing a problem where the filesets depend on
	with-swing, which is used before it is set in build-settings.

2012-05-13  Per Bothner  <per@bothner.com>

	* build.xml: Add ScriptEngineFactory support for discovering
	JSR-223 script engines (Scheme and optionally XQuery).
	Also, improvements in handling of enable-xml.

2012-05-10  Per Bothner  <per@bothner.com>

	* build.xml: Add dependencies on with-swing property.
	(java-classes): Always compile gnu/kawa/models.

2012-04-08  Per Bothner  <per@bothner.com>

	* AUTHORS: Point to Acknowledgement section of doc/kawa.texi.

2012-02-02  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.12.
	* build.xml (version.release): Likewise.

2011-09-24  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (-maybe-select-java7): New target.

2011-08-04  Per Bothner  <per@bothner.com>

	* configure.in (with_XQTS): Fix setter to be Posix-compatible.

2011-07-30  Per Bothner  <per@bothner.com>

	* configure.in (ON_WINDOWS): New automake-conditional.
	* build.xml: Rules for building kawa.bat on Windows.

2011-07-28  Per Bothner  <per@bothner.com>

	* build.xml: Add support for enable-javafx and javax.home properties,
	to build Kawa with JavaFX support.

2011-07-27  Per Bothner  <per@bothner.com>

	* configure.in: add support for JavaFX 2.x.
	(--with-javafx): New command-line flag.
	(WITH_JAVAFX): New conditional.
	* Makefile.am (JAVAFX_SUBDIRS): New macro.
	* classes-to-skip-for-runtime: Add some classes.

	* Make-rules (CLASSPATH_ENV): Add quotes.

2011-07-21  Per Bothner  <per@bothner.com>

	Add support for using configure+make (autotools) on Cygwin.
	* configure.in: Use AC_CANONICAL_HOST, not AC_CANONICAL_TARGET.
	(CLASSPATH_SEPARATOR): New substitution variable.
	* Make-rules (CLASSPATH): New variable.  Make Cygwin-safe.
	(java-classes.stamp): Use -classpath option rather than CLASSPATH.
	(KAWA_COMPILER): Likewise.

	* Makefile.am (kawa-@VERSION@.jar, kawart-@VERSION@.jar):
	Instead of using fnd output directly in command line (which might
	thus come too large, especially on cygwin), use file-list file.
	(classes.list, classes-rt.list): New helper files and targets.
	(-MOSTLYCLEANFILES): Update accordingly.

2011-02-08  Jamison Hope <jrh@theptrgroup.com>

	*  build.xml (slib-scm): Add srfi14.scm.

2011-01-24  Jamison Hope <jrh@theptrgroup.com>

	* build.xml (lib-scm):  Add rnrs/lists.scm.

2011-01-19  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes to skip.

2010-12-26  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml: Set includeantruntime on javac commands - mostly to false.

2010-11-20  Per Bothner  <per@bothner.com>

	* build.xml (slib-scm): Add SRFI-41 files in gnu.kawa.slib.

2010-11-14  Per Bothner  <per@bothner.com>

	* configure.in (AC_CONFIG_FILES): Add gnu/q2/testsuite/Makefile.

2010-11-10  Per Bothner  <per@bothner.com>

	* build.xml: Make use of new kawac task.

2010-11-04  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.11.
	* build.xml (version.release): Likewise.

2010-10-28  Per Bothner  <per@bothner.com>

	* build.xml (slib-scm): Also compile enums.scm.

2010-10-27  Jamison Hope  <jrh@theptrgroup.com>

	* build.xml (slib-scm): Update for new scm files.

2010-10-11  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes to skip.

2010-09-29  Per Bothner  <per@bothner.com>

	* build.xml: Make use of <condition> with else clause.
	Move setting of preprocess-HttpServer into build-setting target.
	(check-for-HttpServer): Remove target.
	(select-java7): Depend on build-settings rather than build-tools.

2010-09-20  Per Bothner  <per@bothner.com>

	* build.xml: Add enable-android support.
	(android-classes): New target.

	* build.xml: Change various targets to depend on build-settings
	rather than build-tools.

	* build.xml: Change some targets to "internal" by prefixing
	their names with '-'.

2010-08-28  Per Bothner  <per@bothner.com>

	* build/xml (select-java7): New target.

	* Makefile.am (select-java7, selected-java-source):
	Add missing jdk7 support.
	* configure.in: Map --with-java-source to JAVA_SOURCE=7 - not 6.

2010-08-27  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add some new classes.

2010-08-26  Per Bothner  <per@bothner.com>

	Replace ExpWalker expression-visitor API by new ExpVisitor.
	Lots of little changes; a few big ones - see gnu/expr/ChangeLog.

2010-07-23  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.10.
	* build.xml (version.release): Likewise.

2010-07-19  Per Bothner  <per@bothner.com>

	* build.xml: Pass +enable:XML or -enable:XML to PreProcess as needed.

	* build.xml (slib-scm): Include srfi13.scm.

2010-05-24  Per Bothner  <per@bothner.com>

	* Makefile.am (PREPROCESS_XML): New mecro.
	(USE_HTTPSERVER): Rename to PREPROCESS_HTTPSERVER.
	(do-preprocess): Use new macros.

2010-05-19  Per Bothner  <per@bothner.com>

	* configure, aclocal.m4, **/Makefile.in: Re-generate.

2010-04-19  Per Bothner  <per@bothner.com>

	* build.xml: Update to auto-select Java5 and Java6, including
	HttpServer.

2010-04-18  Per Bothner  <per@bothner.com>

	Add support for using the com.sun.net.httpserver web server.
	* configure.in(--with-httpserver): New option.
	(WITH_HTTPSERVER): New conditional.
	* Makefile.am: Conditionalize pre-processing on WITH_HTTPSERVER.

2010-04-10  Per Bothner  <per@bothner.com>

	* configure.in: New --java-source option '6compat5': Compile assuming
	a Java 6 compiler, but so .jar (with most features) can run on Java5.
	This implies compiling with -target 1.5.
	* Makefile.am: Various fixes for 'distclean'.
	(dist-kawa-@VERSION@.jar): Build --with-java-source=6compat5.

2010-01-07  Per Bothner  <per@bothner.com>

	* **/Makefile.in, aclocal.m4: Regenerate using automake 1.11.1.

2009-08-31  Per Bothner  <per@bothner.com>

	* Makefile.am (kawart-@VERSION@.jar): Add missing $(srcdir).

2009-08-27  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm): Update for new source files.

	* Makefile.am (all): Also build kawart-@VERSION@.jar.

2009-08-27  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes.

2009-08-24  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes.

2009-08-13  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes.

2009-08-12  Per Bothner  <per@bothner.com>

	* classes-to-skip-for-runtime: Add more classes and patterns.

2009-08-10  Per Bothner  <per@bothner.com>

	* Makefile.am (kawart-@VERSION@.jar): New rule.
	* classes-to-skip-for-runtime: New file.

	* Makefile.am (kawa-@VERSION@.jar): Minor optimization/simplification.

2009-08-06  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.9.10.
	* build.xml (version.release): Likewise.

2009-06-02  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm): Add unicode.scm.

2009-05-31  Per Bothner  <per@bothner.com>

	* build.scm: Update to also compile regex.scm and pregexp.scm.

2009-05-17  Per Bothner  <per@bothner.com>

	* Makefile.am (dist-kawa-@VERSION@.jar): Make copy of dist sources,
	to allow re-condifure, even when "$srcdir" is ".".
	Build with Java6 compiler, with target 5, and --with-javax.script,
	to allowing running under Java5, but with scripting on Java6.

	* configure.in (--with-java.script): New flag.
	(WITH_JAVAX_SCRIPT): New conditional.
	* Makefile.am: Add META-INF/services/javax.script.ScriptEngineFactory
	to kawa jar file when WITH_JAVAX_SCRIPT is selected.

2009-03-16  Per Bothner  <per@bothner.com>

	* build.xml (lib-scm, slib-scm: Update for new modules.
	(slib-scm-classes): Use fileset slib-scm rather than slib-scm-list.
	(slib-scm-list): Remove duplicate filelist.

2009-01-14  Per Bothner  <per@bothner.com>

	* configure.in: Add configure switches-enanle-xquery.
	Add conditionals ENABLE_XQUERY and WITH_ANDROID.
	* Makefile.am (SUBDIRS): Make use of new conditonals.

2008-12-23  Per Bothner  <per@bothner.com>

	* configure.in: New --with-android option.
	* Makefile.am: Add "android" as new JAVA_SOURCE version.
	(set-selected-java-source): Fix minor problem which causes error
	message selected-java-source is missing.

2008-11-19  Per Bothner  <per@bothner.com>

	* configure.in: Use AC_CHECK_TOOL to find GCJ, rather than
	LT_AC_PROG_GCJ, since the latter seems to be gone now.

2008-01-26  Per Bothner  <per@bothner.com>

	* configure.in: The default for --with-java-source is now 5.
	* Makefile.am: The default binary builds now require Java 5.

2007-11-01  Per Bothner  <per@bothner.com>

	* build.xml (run): Set fork to true, since otherwise we can't
	"run" under NetBeans.  (It gets a SecurityException.)
	* nbproject: Preliminary support for developing using NetBeans.

2007-03-15  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.9.3.
	This is so Marc Feeley's "snow' can detect a working version.
	* build.xml (version.release): Likewise.

2007-01-30  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.9.2.
	* build.xml (version.release): Likewise.

2007-01-23  Per Bothner  <per@bothner.com>

	* configure.in (WITH_GCJ_NO_DBTOOL): New conditional.

2007-01-22  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.9.1.
	* build.xml (version.release): Likewise.

2007-01-21  Per Bothner  <per@bothner.com>

	No longer ship libtool.  By default we don't use libtool any more
	but there is a non-default option to use libtool from our path.
	* configure.in (--with-libtool): New option.
	Otherwise remove libtool-related macros.
	* Make-rules: For building with gcj, create .o files rather than
	.lo files, unless WITH_LIBTOOL.
	* ltmain.sh: Remove file.
	* Makefile.am (EXTRA_DIST): Remove ltmain.sh.

	* kawa.cmd: Remove unused file.

2007-01-20  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.9.0.
	* build.xml (version.release): Likewise.

2007-01-11  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa-doc-$(VERSION).tar.gz): Don't build
	doc/internals.xml since it has been moved to the web site.

2007-01-09  Per Bothner  <per@bothner.com>

	* configure.in: Make --disable-jemacs the default.
	(--enable-brl): New non-default flag.
	* build.xml (brl-classes): Split new target off from xml-classes.
	(enable-brl): New property.
	(enable-jemacs): Make default false.
	* build.properties (enable-jemacs, enable-brl): Update to match.
	* Makefile.am: Conditionalize on ENABLE_JEMACS and ENABLE_BRL.
	* gnu/jemacs/*/Makefile.am: Remove condionalization on
	ENABLE_JEMACS, since handled in top-level Makefile.
	
2007-01-08  Per Bothner  <per@bothner.com>

	* Makefile.am, build.xml: Moved the mapping from "source-version" to
	"PreProcess feature list" to the single location (PrePorcess.java), so
	we don't need to duplicate it Makefile.am and build.xml.

2007-01-05  Per Bothner  <per@bothner.com>

	* configure.in: If JAVA_SOURCE is 1|2|3 default with_sax2 to "no".

2007-01-04  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.8.95.
	* build.xml (version.release): Likewise.

2007-01-02  Per Bothner  <per@bothner.com>

	* kawa/ChangeLog: New file.

2007-01-02  Per Bothner  <per@bothner.com>

	* kawa/GuiConsole.java (<init>): Update to use Path.
	* kawa/TelnetRepl.java (serve): Likewise.
	* kawa/GuiInPort.java (<init>): Likewise.
	* kawa/standard/load.java (apply): Generalize from String name.
	(apply2); Update accordingly.
	* kawa/standard/require.java (lookupModuleFromSourcePath): Allow
	base name (i.e. current getFileName() result) to be null.

2006-12-30  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Use InetAddress.getByName(null)
	instead of "localhost".  This avoid a problem on FC6 when localhost
	is missing in /etc/hosts and seems like the Right Thing anyway.

2006-12-29  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java: Update for move of uriSchemeLength
	from InPort to Path. 

	* Makefile.am (JAVA4_FEATURES, NO_JAVA4_FEATURES): Set/clear
	use:java.nio flag.

2006-12-20  Per Bothner  <per@bothner.com>

	* configure.in (--with-gcj): New option.
	(WITH_GCJ_DBTOOL): New AM_CONDITIONAL.
	Change some defaults depending on other options.
	* Makefile.am (install-jar): Run gcj-dbtool, if so configured.
	* Make-rules (EXTRA_DBTOOL_GCJFLAGS): New macro.  
	Compile with -findirect-dispatch only if WITH_GCJ_DBTOOL.

	* Make-rules: Remove kawa1 hooks - use '$(JAVA) kawa.repl' to compile.
	(GCJFLAGS): Add -findirect-dispatch.
	* configure.in: Add AC_DISABLE_STATIC.

2006-12-17  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Use 'define' rather than 'putt' to
	define variables from the command line.  The former works better
	when main() is inoked fter start-up, as is done by 'qalbum -R'.

2006-12-15  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (setLine): Moved to Compilation.
	Compiling with gcj complained about an ambiguity and it seems
	just as clean to move it to avoid the problem.

	* build.xml: Update for XMLParser changes.

2006-12-14  Per Bothner  <per@bothner.com>

	* configure.in (SAX2_PREPROCESS): New substiution varible.
	* Makefile.m (JAVA4_FEATURES, NO_JAVA4_FEATURES): Define preprocess
	variable SAX2 depending on whether --with-sax2 was specified.

2006-12-12  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run): Only special handling of SyntaxException if
	it's the same SourceMessages - rather than say from an fn:doc.

2006-12-11  Chris Wegrzyn <chris.wegrzyn@gmail.com>

	* kawa/standard/syntax_case.java (rewriteForm): Make sure input form
	is nested inside LetExp used to implement syntax-case.
	This fixes Savannah bug #18105 "with-syntax causes
	NullPointerException during compilation but not in repl".

2006-12-11  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (scanClassDef, rewriteForm): Handle
	SyntaxForm around keywords.  Fixes Savannah bug #18504.

2006-12-09  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java: Remove unneded import.
	* kawa/lang/PairPat.java: Likewise.
	* kawa/lang/ListRepeatPat.java: Likewise.
	* kawa/lang/VarListPat.java: Likewise.
	* kawa/repl.java: Remove unused local variables.

	* build.xml: Update handling of XMLParser.java to match that of make.

2006-12-06  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (rewriteForm, scanClassDef): Handle
	SyntaxForm in member definition.

2006-12-05  Per Bothner  <per@bothner.com>

	* configure.in: Make --with-sax the default.

	* Makefile.am (dist-kawa-@VERSION@.jar): Fix various bitrot.

	* kawa/repl.java: Update copyright year printed by --version to 2007.

	* Makefile.am (kawa/Version.java): Use svnversion command.

	* Makefile.am (selected-java-source): Handle JAVA_SOURCE = 6.

2006-12-04  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java: Update for require.importDefinitions.
	* kawa/Shell.java (run): Update for Language.run changes.
	* kawa/standard/require.java (importDefinitions): Some refactoring so
	we can pass the ModuleInfo from XQParser so we use the same info
	without trying to load the wrong file.  Combine two methods to one.
	(lookupModuleFromSourcePath): New static helper method.

	* kawa/repl.java (compilationDirectory): Removed static field, replaced
	by non-static field in ModuleManager.
	(processArgs): Use ModuleManager's new setCompilationDirectory method.

	* kawa/standard/load.java (pply): Don't temporarily setBaseUri.

	* Makefile.am (patch-source-list): Change pattern so we catch
	files that only use #ifndef and not #ifdef,

	* configure.in (WITH_XQTS): Previous change not quite right.

2006-12-02  Per Bothner  <per@bothner.com>

	* configure.in (WITH_XQTS): Default to false.

2006-12-01  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.8.91.
	* build.xml (version.release): Likewise.

	* configure.in: Add support for JAVA_SOURCE=6.
	* Makefile.am (select-java6): New rule, which sets JAVA6 and
	use:java.text.Normalizer.

2006-11-27  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (lookup): New hasNamespace.
	* kawa/standard/require.java (importDefinitions): Inline getDefine.
	Do check for duplicate declaration using getNamespaceOf.
	Use ScopeExp.duplicateDeclarationError.

2006-11-22  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRules.java: Rename Consumer methods append->write.
	* kawa/lang/Promise.java: Likewise.
	* kawa/lang/Lambda.java: Likewise.
	* kawa/lang/SyntaxPattern.java: Likewise.
	* kawa/lang/AnyPat.java: Likewise.
	* kawa/lang/PairPat.java: Likewise.
	* kawa/lang/Macro.java: Likewise.
	* kawa/lang/EqualPat.java: Likewise.
	* kawa/lang/ListPat.java: Likewise.
	* kawa/lang/ListRepeatPat.java: Likewise.
	* kawa/lang/Syntax.java: Likewise.
	* kawa/lang/VarListPat.java: Likewise.

2006-11-20  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRules.java (print): Update since parameter is
	now a Consumer.
	* kawa/lang/Promise.java (print): Likewise.
	* kawa/lang/Lambda.java (print): Likewise.
	* kawa/lang/AnyPat.java (print): Likewise.
	* kawa/lang/PairPat.java (print): Likewise.
	* kawa/lang/EqualPat.java (print): Likewise.
	* kawa/lang/ListPat.java (print): Likewise.
	* kawa/lang/ListRepeatPat.java (print): Likewise.
	* kawa/lang/VarListPat.java (print): Likewise.
	* kawa/lang/Macro.java (print): Likewise.
	* kawa/lang/Syntax.java (print): Likewise.
	* kawa/lang/SyntaxPattern.java (print): New method.
	* kawa/lang/Pattern.java: Now implements Printable.

2006-11-19  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java: Remove redundant 'implements Printable'.
	* kawa/standard/location.java: Likewise.
	* kawa/standard/let.java: Likewise.
	* kawa/standard/define.java: Likewise.
	* kawa/standard/define_variable.java: Likewise.
	* kawa/standard/define_alias.java: Likewise.
	* kwa/standard/fluid_let.java: Likewise.
	* kawa/standard/begin.java: Likewise.
	* kawa/standard/let_syntax.java: Likewise.
	* kawa/standard/set_b.java: Likewise.

2006-11-13  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRules.java: Update for SourceLocation changes.
	* kawa/lang/Lambda.java: Likewise.
	* kawa/lang/SyntaxPattern.java: Likewise.
	* kawa/lang/Eval.java: Likewise.
	* kawa/lang/Macro.java: Likewise.
	* kawa/standard/object.java: Likewise.
	* kawa/standard/require.java: Likewise.
	* kawa/standard/define_class.java: Likewise.
	* kawa/standard/define_autoload.java: Likewise.
	* kawa/repl.java: Likewise.
	* kawa/lang/Translator.java: Likewise.
	(setLine, setLine): Generalize/simplify.

2006-10-26  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java: Error rather than warning on
	duplicate declaration.

	* configure.in (AC_INIT): Set version to 1.8.90.
	* build.xml (version.release): Likewise.

	* kawa/standard/Scheme (initScheme): Update class for 'html' prefix.

	* kawa/repl.java (processArgs): Use Symbol.parse to process
	parameter initialization.

2006-10-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (scanForm): Call rewrite to search lexical
	scope, so we can also indirectly set macroScope.
	This fixes Savannah bug #17993 "Unbound location exception when
	require-d syntax calls some procedures".

2006-10-15  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Set Language.requirePedantic static
	if --pedantic flag was seen.

2006-10-14  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (scanBody): Fix and simplify handling
	of SyntaxForm when we need to makeList by asking recursive call
	to make the list. This fixes Savannah bug #17984 "Compile time
	error in expansion of hygienic macros ending in literals".

2006-09-26  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): If we find a matching propertyField,
	break instead of continue.

2006-09-18  Per Bothner  <per@bothner.com>

	* configure.in (WITH_XQTS): New AM_CONDITIONAL.

2006-09-14  Per Bothner  <per@bothner.com>

	* build.xml (java4-features): Don't use org.w3c.dom.Node by default.

2006-09-13  Per Bothner  <per@bothner.com>

	* Shell.java (xmlPrinterClasses): Update for changed XMLPrinter
	constructors.

	* Shell.java (run): Call flush.

2006-09-12  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Som re-arranging.
	If we have a FieldLocation, use it's instance to set contextDecl.
	(checkMemberContext): Inline into caller and remove.

2006-09-08  Per Bothner  <per@bothner.com>

	* Translator.java (reqrite): Catch missing (un-compiled) class when
	loading a field - could be a missing require declaration.

2006-09-06  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java: Remove unused import(s).
	* kawa/standard/try_catch.java: Likewise.
	* kawa/standard/module_static.java: Likewise.
	* kawa/standard/require.java: Likewise.
	* kawa/lang/Translator.java: Likewise.
	* kawa/standard/char_ready_p.java: Likewise.
	* kawa/lang/Translator.java (rewrite): Remove unused local(s).
	* kawa.repl (compileFiles): Likewise.
	* kawa/standard/define_syntax.java (scanForm): Remove unused local.
	* kawa/standard/require.java: Likewise.
	
2006-09-03  Per Bothner  <per@bothner.com>

	* kawa/lang/loadcompiled.java: Remove unused class.
	* kawa/lang/Makefile.am: Update accordingly.
	* kawa/standard/read.java: Removed class, replaced by function read
	in kawa/lib/ports.scm.
	* kawa/standard/Makefile.am: Update accordingly.
	* kawa/standard/read_line.java: No longer extend ProcedureN.
	(numArgs, applyN, apply0, apply1, apply2): Remove methods.
	* kawa/standard/callcc.java (callcc): New static final field.
	* kawa/standard/Scheme.java: Appropriate updates.

	* kawa/standard/atan.java: Removed class, replaced by function atan
	in kawa/lib/numbers.scm.
	* kawa/standard/string2number.java: Removed class, replaced by function
	string->number in kawa/lib/numbers.scm,
	* kawa/standard/Makefile.am: Update accordingly.
	* kawa/standard/Scheme.java (initScheme): Update accordingly.

2006-08-23  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Change type paraneter
	to className String.  Handle appropriate exceptions.
	Various tweaks to handle cycles etc.
	(scanForDefinitions): Update accordingly.

	* kawa/standard/require.java (importDefinitions): Minor simplification.
	Also, don't make instance decl private if immediate.
	Set column number of alias decl, in addition to line number.

2006-08-16  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa/Version.java): If .svn/entries exists, extract
	SVN revision number and date and add that to the Kawa version string.
	(CLEANFILES): Move kawa/Version.java from -MAINTAINERCLEANFILES.
	(MAINTAINERCLEANFILES): Remove since no longer needed.

2006-08-08  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (scanForDefinition): Handle extended
	'(require [CLASS] "SOURCE")' syntax.
	(importDefinitions): New overloaded method, handles above new cases.
	Parse module if appropriate.
	(importDefinitions): Handle non-compiled class.
	Remove most special handling of immediate mode.

	* configure.in (--with-XQTS): New flag.
	(XQTS_PATH): New substitution variable.

2006-06-28  Per Bothner  <per@bothner.com>

	* kawa/standard/TracedProcedure.java (curIndentSym): Use new
	Symbol.makeUninterned method.
	* Makefile.am: New (always-disabled) PreProcess macro JAXP-QName.

2006-06-23  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (check_if_Syntax): Inherit macroScope
	if from current TemplateScope.

2006-06-21  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (runString): Call the other run method so that
	getOutputConsumer gets called.

2006-06-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair): Remove no-longer-needed
	and non-working handling of xml namespaces.
	(remove): Remove old AutoloadProcedure special handling.
	(asXmlNamespace): Remove unneeded method.
	* kawa/standard/Scheme.java (initSchame): Change "html" definition.

2006-06-09  Per Bothner  <per@bothner.com>

	* kawa/lang/Record.java: No longer implement gnu.mapping.NameMap.

	* kawa/repl.java (compileFiles): Print line number if unexpected
	exception.

2006-06-05  Per Bothner  <per@bothner.com>

	* kawa/standard/export.java (scanForDefinitions): Set and later restore
	current position on exach Pair, for more precise error messages.
	Also, put in partial support for SyntaxForm inputs.

2006-05-31  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run): Update to use new ModuleExp.evalModule call.
	This handles printing of errors - and now also warnings.
	Plus remove redundant runUntilDone.
	* kawa/lang/Eval.java (evalBody): Update ModuleExp.evalModule call.
	* kawa/standard/load.java (loadSource): Likewise.

	* kawa/standard/load.java (loadCompiled): Use WrapedException.

2006-05-25  Per Bothner  <per@bothner.com>

	* kawa/standard/try_catch.java: Remove unneded import.
	* kawa/standard/with_compile_options.java: Likewise.

	* build.xml: Major simplification, since the modules in kawa/lib
	can be named in any order in the compilation command.

2006-05-25  Per Bothner  <per@bothner.com>

	Handle module dependencies and cycles.
	* kawa/lang/CompileFile.java (compile_to_files): Remove method.
	* kawa/repl.java (compileFiles): New method.
	(processArgs): Simplify by using compileFiles.
	* kawa/lang/Eval.java (evalBody): Add now-needed cast.
	* kawa/lang/Translator.java (pendingForm): New field.
	(lookup): Replace call to lookupGlobal, which creates new Declaration
	if needed, with call to ModuleExp.lookup, which doesn't.
	(scanForm): Special-case check for begin Syntax.
	(scanForm): Handle deferred processing created by require or begin.
	(finishModule):: Simplification - don't need to check IS_UNKNOWN.
	(resolveModule): Handle any deferred pending imports.
	* kawa/standard/require.java (scanForDefinitions): If we're in the
	PROLOG_PARSING state, defer handling until the next pass.
	(importDefinitions): New parameter list.
	Check for cycles, and if so pushPendingImport.
	Various tweaks to handle the case when no class has been generated yet.

2006-05-25  Per Bothner  <per@bothner.com>

	* kawa/lang/Syntax.java (scanForm): Slightly better error message,
	in case the ErrorEsp is erroneously compiled or evaluated.

	* kawa/lang/SyntaxTemplate.java (execute): Simplify debug logic.

2006-05-25  Per Bothner  <per@bothner.com>

	* kawa/lang/Syntax.java (scanForm): Slightly better error message,
	in case the ErrorEsp is erroneously compiled or evaluated.

	* kawa/lang/SyntaxTemplate.java (execute): Simplify debug logic.

2006-05-23  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRule.java: Remove unneeded import.
	* kawa/standard/IfFeature.java: Likewise.
	* kawa/standard/load.java: Likewise.
	* kawa/standard/set_b.java: Likewise.
	* kawa/standard/sleep.java: Likewise.
	* kawa/standard/syntax.java: Likewise.
	* kawa/standard/try_catch.java: Likewise.
	* kawa/lang/SyntaxTemplate.java (currentScope): Remove unused field.
	* kawa/standard/location.java: Likewise.
	* kawa/standard/prim_method.java: Likewise.
	* kawa/standard/set_b.java: Likewise.
	* kawa/lang/SyntaxTemplate.java: Use static syntax for static call.
	* kawa/standard/with_compile_options.java: Likewise.
	* kawa/lang/Eval.java: Remove unused local variable.
	* kawa/lang/Lambda.java
	* kawa/lang/Record.java: Likewise.
	* kawa/lang/SyntaxRules.java: Likewise.
	* kawa/lang/SyntaxTemplate.java: Likewise.
	* kawa/standard/define.java: Likewise.
	* kawa/standard/define_class.java: Likewise.
	* kawa/standard/object.java: Likewise.
	* kawa/standard/string2number.java: Likewise.

2006-05-21  Per Bothner  <per@bothner.com>

	* kawa/standard/IfFeature.java (hasFeature): Remove old testing junk. 

	* kawa/standard/module_name.java (scanForm): Don't set STATIC_SPECIFIED
	on module Declaration - confused FindCapturedVars.capture.

2006-05-19  Per Bothner  <per@bothner.com>

	* kawa/standard/define_autoload.java (process): Handle Symbols.

	* kawa/lang/Lambda.java (nameKeyword): New constant field.
	(rewriteAttrs): Handle name: keyword.

2006-05-06  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Implementations of 'string',
	'quantity->number', 'quantity->unit', 'make-quantity' now in kawa.lib.
	* kawa/standard/make_quantity.java: Remove file.
	* kawa/standard/quantity2number.java: Likewise.
	* kawa/standard/quantity2unit.java: Likewise.
	* kawa/standard/string_v.java: Likewise.
	* Makefile.am: Update accordingly.

2006-05-02  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Do setLine on new ReferenceExp.

2006-05-01  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (read): Remove unused method.
	(getLexer): Remove - use super version.
	(createReadTable): Update called method name.
	* kawa/standard/read.java (apply1): Update ScmRead -> LispReader.

2006-04-26  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (make(Declaration)): Set capturedScope.
	* kawa/standard/define_syntax.java (scanForm): If immediate, generate
	a call to set the capturedScope.
	* kawa/standard/location.java (rewrite): Revert 2006-04-21 change.
	Instead follow aliases before setting can-read/can-write flags.

2006-04-21  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Don't needlessly
	clear simple flag for alias declaration.
	* kawa/standard/location.java (rewrite): Mark declaration as non-simple.

2006-04-19  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Check exported
	decl's isPrivate rather than field name.  More robust in that it works
	even if imported module hasn't been compiled yet.

2006-04-14  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Get "caar", "cadr" etc from
	kawa.lib.lists rather than kawa.standard.cxr.
	* kawa/standard/cxr.java: Remove file.
	* kawa/standard/Makefile.am: Update accordingly.

2006-04-14  Per Bothner  <per@bothner.com>

	Various macro fixes.  Most important, quasisyntax sub-templates inherit
	a shared TemplateScope.
	* kawa/lang/PatternScope.java (push): Set outer scope.
	* kawa/lang/TemplateScope.java (make): New factory methods.
	* kawa/lang/SyntaxTemplate.java (execute): Use passed-in TemplateScope
	rather than allocating it.
	If DEBUGGING, check if vars is null.
	* kawa/lang/SyntaxRules.java (expand): Need to allocate TemplateScope
	here before passing it to SyntaxTemplate.execute.
	* kawa/lang/Translator.java (templateScopeDecl): New field.
	* kawa/standard/let_syntax.java (rewrite): Set setCapturedScope
	on new macros.
	* kawa/standard/syntax.java (rewriteForm): Genrate code to allocate
	and use TemplateScope, using templateScopeDecl.

	* kawa/standard/let_syntax.java (rewrite): Set name of macro.

2006-04-10  Dean Ferreyra <dferreyra@igc.org>
            Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Handle new
	--debug-{error,warning}-prints-stack-trace arguments,
	(printOptions): List them.
	
2006-04-06  Dean Ferreyra <dferreyra@igc.org>

	* kawa/lang/SyntaxTemplate.java: Fix typo in error message.

2006-03-26  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVA4_FEATURES, NO_JAVA4_FEATURES): New feature flag
	use:java.util.regex.

2006-03-25  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Bind 'slot-ref'
	to new SlotGet.slotRef field.

2006-03-24  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (instance): Make public, so it can
	be compiled as a literal.

2006-03-23  Per Bothner  <per@bothner.com>

	* kawa/standard/map.java (inline): Also inline on new ApplyExp.

2006-03-17  Per Bothner  <per@bothner.com>

	* kawa/standard/define_member_alias.java (scanForDefinitions):
	Minor optimization.

2006-03-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (exp2Type): May need to InlineCalls on
	type-specifier - for example for PREFIX:<>.

2006-03-13  Per Bothner  <per@bothner.com>

	* configure.in: Define JAVACFLAGS, and default it to -g.
	* Make-rules: Remove redundant JAVACFLAGS macro.

2006-03-12  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (scanClassDef): Move rewrite of
	list of sypertypes to ...
	(rewriteClassDef): ... here.

2006-03-11  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java (expand): Never call Translator.namespaceResolve
	- which had become a no-op in this context.
	(DATUM_DEPTH): Remove constant.
	Replace most uses by QUOTE_DEPTH.
	(expandColonForms): New protected method.
	(expand_pair): Do namespace resolution on $lookup$ forms only if
	expandColonsForms is true.
	* kawa/standard/syntax.java (expandColonForms): New method.
	This fixes a problem where colon forms in syntax forms got quoted,
	instead than being handled when the syntax template was expanded.

2006-03-03  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Define "duration" function.
	(createReadTable): Define "duration" reader constructor function.

2006-02-22  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVADOC_FLAGS): Pass -use to javadoc.

2006-02-19  thomas kirk  <tk@research.att.com>
	    Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (loadCompiled): Get main class from
 	ZipLoader.loadAllClasses rather than using LambdaExp.fileFunctionName.
	This fixes Savannah bug #15725.
	(loadSource): Don't set module name to LambdaExp.fileFunctionname.

2006-02-19  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Use ClassMethods.getMethods
	rather than ClassMethods.apply to we can pass in 'caller'.
	It also does less useless work.

	* kawa/lang/Translator.java (rewrite): When searching lexical scope,
	also seach fields of methods of this class and super-types.
	* kawa/standard/object.java (rewriteClassDef): Call setTypes earlier,
	so we can search for inherited fields and methods.
	Remove old incomplete code for matching fields and methods.

2006-02-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Handle reference to method name
	by create a GetNamedExp.

	* kawa/standard/map.java (inline): If evaluating procedure doesn't
	have side-effects, do so inside loop, which may allow inlining.

2006-02-15  Per Bothner  <per@bothner.com>

	* COPYING: Change to use X11/MIT license.
	* gnu/*/COPYING: Remove redundant files.

	* configure.in: Oops.  Partly go back to original handling
	of --{with,enable}-servlet.

2006-02-14  Per Bothner  <per@bothner.com>

	* kawa/standard/define.java (scanForm): Fix oops in previous check-in.

	* kawa/lang/Quote.java (expand_pair): Use GetNamedPair.combineName
	to resolve '($lookup$ part1 'part2) to 'part1:part2 - as in source.
	* kawa/lang/Translator.java (namespaceResolve): Likewise.
	Remove no-longer needed code to resolve actual namespace declaration.

	* kawa/standard/define.java (scanForm): Fix wrong test for a function
	definition - which failed when the name was a Symbol.
	* kawa/standard/define.java: Fix incorrect comment.

2006-02-13  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java (expand_pair): Translate (%lookup$ PART1 'PART2)
	to 'PART1:PART2.
	 * kawa/lang/Translator.java (namespaceResolve): Remove two overloads.
	(namespaceRewriteResolve): Remove method.  Just inline it.
	(rewrite): Remove a namespaceResolve call.
	Always inline getNamedPart.
	* kawa/standard/Scheme.java (getNamedPartDecl): New static field.
	(makeApply): Change return type. Check if function is getNamedPartDecl.
	* kawa/standard/define.java (scanForn): Always call tr.namespaceResolve.
	* kawa/standard/define_syntax.java (scanForm): Likewise.

	* configure.in: Fix recent breakage in --{with,enable}-servlet.
	Also make a simplification.

2006-02-12  Per Bothner  <per@bothner.com>

	* configure.in:  Fix/simplify handling with --with-awt and --with-swing.

2006-02-10  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_body): No longer need to call
	mustCompileHere().

	* kawa/lang/Lambda.java (rewriteFormals): For anonymous functions
	do setSourceLocation.

	* kawa/standard/syntax_case.java (rewriteClauses): Fix to use
	correct PrimProcedure constructor, taking a Language.

2006-02-09  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody): No longer need to
	mustCompleHere.

	* kawa/lang/Eval.java (evalBody): Use new pushNewModule method.

	* kawa/standard/map.java (inline): Use existing IsEq from Scheme.

2006-02-07  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): The R5RS functions
	integer?, max, min, gcd, lcm, logand, logior, logxor are now
	implemented in Scheme in kawa.lib.numbers.
	(define_proc): Remove two no-longer-needed methods.
	* kawa/standard/gcd.java: Remove no-longer-needed file.
	* kawa/standard/integer_p.java: Likewise.
	* kawa/standard/lcm.java: Likewise.
	* kawa/standard/logand.java: Likewise.
	* kawa/standard/logior.java: Likewise.
	* kawa/standard/logxor.java: Likewise.
	* kawa/standard/max.java: Likewise.
	* kawa/standard/min.java: Likewise.
	* Makefile.am: Update accordingly.

2006-02-06  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair): Update checking for xml
	namespaces to match namespace changes.
	(namespaceResolve, namespaceRewriteResolve): New/rewritten methods.
	(scanForm): Do namespaceRewriteResolve first.
	* kawa/standard/Scheme.java (applyToArgs, setApplyToArgs,
	applyFieldDecl): New static fields.
	(makeApply): New method, overrides LispLanguage.
	(createReadTable): Change postfixLookupOperator to ':'.
	* kawa/standard/define.java (scanForm): Some changes to handle
	namespace resolution.  Set type of functions to Procedure.
	* kawa/standard/export.java (scanForDefinitions): Since namespace
	prefixes are now in the regular namespace, we no longer need
	to export 'namespace:PREFIX'.
	* kawa/standard/location.java (makeProcLocation$V): Remove needless
	ApplyToArgs application.
	* kawa/standard/set_b.java (rewriteForm): Check for ApplyToArgs.

2006-02-06  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (scanClassDef): Specify that method
	Declarations have Procedure type.

2006-02-03  Per Bothner  <per@bothner.com>

	* kawa/standard/cxr.java (caar, cadr, etc): New static fields.
	(cxr): New constructor.
	(program): Make private.
	(apply1, set1): No longer need to call program, since done by <init>.
	* kawa/standard/Scheme.java (initScheme): Modify definitions of
	caar, cadr, etc to use nwe static fields.

2006-02-02  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Update copyright year printed
	when giving the --version flag.

	* kawa/standard/Scheme.java (initScheme): Declare 'namespace' function.
	(createReadTable): Declare 'namespace' reader constructor.

2006-01-12  Per Bothner  <per@bothner.com>

	* build.xml: Update directory containing HTTP.scm.

2006-01-11  Per Bothner  <per@bothner.com>

	* Makefile.am (SUBDIRS): Add new directory gnu/kawa/swtviews.
	(JAVADOC_PACKAGES): Add new package gnu.kawa.swtviews.
	* configure.in (AC_CONFIG_FILES): Add gnu/kawa/swtviews/Makefile.

	* kawa/repl.java (propertyFields): Add "display:toolkit".

	* kawa/standard/require.scm (featureMap): Define swing-gui feature.

2006-01-10  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Declare resource-uri.

	* kawa/repl.java (processArgs): The debugPrintExpr flag was moved from
	ModuleExp to Compilation.

	* kawa/standard/require.scm (featureMap): HTTP was moved.
	* Makefile.am (SUBDIRS): No longer conditionalize on ENABLE_SERVLET.
	Instead, always do gnu/kawa/servlet.  However, rearrange so it done
	later, since it now includes HTTP.scm.

2006-01-07  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java (consX$V): New static helper method.
	(expand_pair): Use new consX$V method rather than compiled
	method in gnu.kawa.slib.srfi1.  The latter caused an awkward
	dependency which broke quasi-quotation under Common Lisp.
	(consXType): Remove no-longer-needed field.

	* kawa/standard/Scheme.java (getNamedType): Declare <URI> type.
	(initScheme): Declare resolve-uri function, and module-uri syntax,

2006-01-04  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (apply): Use new URI_utils methods.

2005-12-31  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme): Declare URI function.
	(createReadTable): Declare URI as a reader constructor.

	* kawa/lang/Quote.java: Un-tab-ify conditional code.
	* kawa/lang/SyntaxTemplate.java: Likewise.

2005-12-30  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run): Fix bug which prevented getOutputConsumer
	from being run for a repl, thus giving incorrect output.

	* kawa/standard/require.java (featureMap): Add "srfi-10" as an alias.
	* kawa/standard/Scheme.java (createReadTable): Handle "#," syntax.

2005-12-22  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxPattern.java (translate): Set source position
	on pattern Declarations.

2005-12-11  Per Bothner  <per@bothner.com>

	Remember URL of loaded file, so it can be passed to ArrayClassLoader.
	* kawa/Shell.java (run): Take extra URL argument.
	(runFile): Handle skipLines even if read from stdin.
	* kawa/repl.java (processArgs): Update evalModule call.
	* kawa/lang/Eval.java (evalBody): Likewise.
	* kawa/standard/load.java (loadSource): New URL parameter.
	(apply): Get URL and pass it to loadSource.

	* kawa/lang/Lambda.java (rewriteBody): Temporarily set curLambda.
	* kawa/standard/object.java (rewriteInit): Set line of initializing
	SetExp to that of Declaration - rather than current Translator position.

2005-12-10  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (apply): Add extra argument.
	Skip that many lines.
	(apply2): Update to match.
	* kawa/Shell.java (runFile): Also add extra skipLines argument.
	* kawa/repl.java: Update runFile callers.
	(processArgs): Handle new --script and --scriptN options.

	* kawa/standard/load.java (apply): Remove some hacks to map "class name"
	to filename, and special .scm handling.
	In return, we now allow general URLs in addition to filename.
	(loadSource(String,Environment)): Remove static method.

2005-12-05  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (createReadTable): Use '\\' for
	postfixLookupOperator instead of '`'.

2005-12-04  Per Bothner  <per@bothner.com>

	Handle Syntactic sugar to map OBJECT`NAME to ($lookup$ OBJECT 'NAME).
	* kawa/standard/Scheme.java (initScheme): Define "$lookup$" function.
	(createReadTable): Bind '`' to postfixLookupOperator.

	* kawa/lang/Translator (rewrite_pair): Be a little more conservative
	with xml names: Only map to make-element if prefix matches.

	* kawa/standard/Scheme.java (initScheme): Define define-xml-namespace.
	(html): Define as an xml-namespace.
	* kawa/lang/Translator (asXmlNamespace): New method.
	(rewrite_pair):  Translate application of xml-names to make-element.

2005-12-03  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java (rewrite): Fix error message.

	* kawa/lang/Translator.java (namespaceResolve): Combine code paths
	to reduce code duplication.

	* kawa/lang/Translator.java (namespaceResolve): Use new makeExp method.

2005-11-30  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody): Set/reset curMethodLambda
	if we're in a top-level methods and supertype has been specified.
	* kawa/standard/thisRef.java (rewriteForm): Allow (this) in a top-level
	function whose module has the super-type explicitly specified.  In
	that case create a matching Declaration, if needed.

2005-11-29  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java: Make various methods non-static, and make
	some methods/fields protected so derived class can use it.
	(leaf): New wrapper around QuoteExp construction, for overriding.
	(expand_pair): Extend unqute and unquote-splicing to allow multiple
	arguments, to match Alan Bawden's suggestion (1999).
	(append$V): New method, to handle SyntaxForm wrappers.
	* kawa/lang/Translator.java (matches): New variant takes SyntaxForm.
	* kawa/standard/Scheme.java (initScheme): Define quasisyntax.
	Re-arrange R5RS vs syntax-case macros.
	(createReadTable): Define #` as quasisyntax.
	* kawa/standard/syntax.java: Change to extend kawa.lang.Quote.
	This provides quasisyntax support.
	(wrap, convert): Remove unused methods.  (Was also unused before.)

	* kawa/standard/define_alias.java (scanForDefinitions): Handle
	SyntaxForm unwrapping.

2005-11-28  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (compile_to_files): Set top-level
	class name only if passed in.
	
2005-11-27  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (loadCompiled): Used WrappedException.

2005-11-23  Per Bothner  <per@bothner.com>

	* kawa/standard/module_name (scanForm): Do the SyntaxForm handling
	in case this is called in a macro.
	Allocate Compilation's mainClass if not set yet.
	Create a private Declaration if the name is a symbol.

	* kawa/standard/prim_method.java (constructor): Remove static field.
	(rewrite): Remove no-longer-used support for invokespecial.
	* kawa/standard/Scheme.java: New generate-temporaries procedure.
	primitive-constructor was moved to kawa.lib.reflection.

	* kawa/standard/constant_fold.java (checkConstant): Allow for
	Declaration with UNKNOWN flag or constant value.

2005-11-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteForm): New method, so we can set
	the line/column number to the actual lambda expression.

2005-11-20  Per Bothner  <per@bothner.com>

	* Make-rules (java-classes.stamp, scm-classes.stamp,
	clisp-classes.stamp, elisp-classes.stamp):
	Also touch kawa-jar.stamp in top-dir.
	* Makefile.am: Remove JAP_DEPS_XXX macros.
	(kawa-@VERSION@.jar): Depend on kawa-jar.stamp instead of JAR_DEPS.
	(MOSTLYCLEANFILES): Remome *.stamp - specifically kawa-jar.stamp.

	* Makefile.am (SUBDIRS): Enter jemacs/swing/swt dirs unconditionally.
	(JEMACS_SUBDIRS, JEMACS_SWING, JEMACS_SWT, SWINGVIEWS_SUBDIRS):
	Remove no-longer-needed macros.
	* configure.in: New --enable-jemacs option - default off,
	to avoid accidental includion of GPL'd code.
	New --enable-echo2, currently unused.
	Change --with[out]-swing to default to 'with'.
	Add ENABLE_JEMACS and ENABLE_ECHO2 automake conditionals.
	Remove SWING_SELECTED, AWT_SELECTED, XML_SELECTED, extra_java variables.
	* kawa/Makefile.am: Use WITH_AWT conditional.

2005-11-18  Per Bothner  <per@bothner.com>

	Fixes Savannah bug #14097: problem with (this) syntax within
	define-syntax.
	* kawa/lang/Translator.java (curMethodLambda): New field.
	* kawa/standard/object.java (rewriteClassDef, rewriteInit):
	Save, set and restore curMethodLambda.
	* kawa/standard/thisRef.java: Don't search static scope chain for
	a class-method, since that may be weird when expanding macros.
	Instead, use curMethodLambda.

2005-11-17  Per Bothner  <per@bothner.com>

	* kawa/standard/define_class.java (scanForDefinitions): Use new
	ClassExp constructor.
	Don't set STATIC_SPECIFIED for simple class since that needlessly
	prohibits "inner" classes accessing external data.
	Set name of ClassExp now rather than during rewrite.
	* kawa/standard/object.java (rewriteForm): Don't need to setSimple.
	(rewriteClassDef): Call ClassExp's new setClassName method.
	Call ClassExp's setTypes and declareParts methods here.

2005-11-16  Per Bothner  <per@bothner.com>

	* kawa/standard/module_name.java (rewriteForm): Replace method by
	scanForm method, since we want to set class names in the first pass.
	
	* kawa/repl.java (compilationPrefix): Remove field.
	We now use Compilation.classPrefixDefault.
	(processArgs): Update accordingly.
	* kawa/lang/CompileFile.java (compile_to_files): Remove prefix
	parameter.  Set classname after we've parsed file, using classPrefix.
	* kawa/standard/define_autoload.java (scanFile): Use classPrefix.
	* kawa/standard/module_name.java (rewriteForm): Use classPrefix.
	If name has a package prefix, set classPrefix.
	* kawa/standard/require.java (scanForDefinitions): Use classPrefix.

2005-11-08  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.8.1alpha.
	* build.xml (version.release): Likewise.

2005-11-03  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (namespaceResolve): Also check dynamic
	environment.  Needed to handle define-namespace in repl.

2005-10-27  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (compile_to_files): Call resolve.
	* kawa/lang/Translator.java (finishModule): Move final actions to ...
	(resolveModule): ... new method.
	(firstForm): New field, instead of finishModule parameter.
	* kawa/lang/Eval.java (evalBody): Update for modified firstModule.

2005-10-27  Per Bothner  <per@bothner.com>

	* build.xml: Kludgy update for gnu/kawa/srfi for new files.

2005-10-24  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java: Declare test-begin.

	* kawa/standard/Scheme.java: Declare define-for-syntax, syntax-source,
	syntax-line, syntax-column macros.

	* kawa/standard/IfFeature.java (hasFeature): Look for a magic
	"%provide%"+NAME variable, as defined by the new provide macro.
	* kawa/standard/Scheme.java: Declare (provide ...) macro.

2005-10-20  Per Bothner  <per@bothner.com>

	* kawa/standard/IfFeature.java (hasFeature): We also have features
	srfi-16 and srfi-39.

	* kawa/standard/require.java (featureMap): Add srfi-35, srfi-35,
	and aliases.

2005-10-19  Per Bothner  <per@bothner.com>

	* kawa/standard.Scheme.java: Define syntax-error macro.

2005-10-18  Per Bothner  <per@bothner.com>

	* Makefile.am JAVADOC_ANT_JARS, JAVADOC_ECLIPSE_JARS): Update/fix.
	(javadoc-cvs.log): Make script more robust wrt empty file lists.

2005-10-16  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (featureMap): Add 'srfi-69,'hash-table.
	* build.xml (slib-scm): Add srfi69.scm, testing.scm.

2005-10-13  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (rewriteClassDef): If method name is
	"*init*" (i.e. a constructor) set the return type to void.
	Also complain if a non-simple class.
	Also set line number of method.
	* kawa/lang/Lambda.java (rewriteAttrs): Complain if explicit
	return type seen for "*init* method.

	* kawa/lang/Lambda.java (rewrite): Remove redundant method.
	(rewrite(Object,Translator)): Update accordingly,
	* kawa/lang/Lambda.java (rewrite(Object,Translator)):
	Set line of LambdaExpr from pair.

	* kawa/lang/Lambda.java (rewriteBody): If returnType specified, wrap
	body in coercion even if it is a BeginExp.
	However, don't do so it returnType is void_type.

2005-10-06  Per Bothner  <per@bothner.com>

	* Makefile.am (select-javaXX): Also search inherited $CLASSPATH -
	though last.

2005-10-05  Per Bothner  <per@bothner.com>

	* Makefile.am (select-javaXX): Add "." to CLASSPATH so we find the
	PreProcess class.

2005-10-05  Jim White  <jim@pagesmiths.com>

	* build.xml (lib-scm-4): Add parameters.scm.

2005-09-28  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Update copyright printed by --version.

	* Makefile.am: Fold +JAVA2 into JAVA4_FEATURES macro.

2005-09-27  Per Bothner  <per@bothner.com>

	* kawa/standard/location.java (rewrite): Do setCanRead and setCanWrite
	on variable captured by a location.
	Fixes Savannah bug #14640: internal compile error when using "location".

	* Makefile.am:  Define new PreProcess flag: use:java.net.URI.
	* build.xml: Likewise.

	* kawa/standard/load.java (apply): If relative, resolve against
	base uri here only, and not in loadSource.
	(loadSource): Make private.  Remove 'relative' parameter.
	Don't do any uri-resolving - assume caller has done that.
	If the result is still relative, assume it's a elative file name.
	Fixes Savannah bug #14397: load-relative doesn't work.

2005-09-26  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT): Set version to 1.8.
	* build.xml (version.release): Likewise.

2005-08-15  thomas kirk  <tk@research.att.com>

	* kawa/standard/Scheme.java (initScheme): define 'runnable'
	* kawa/GuiConsole.java (<init>): access Future environment with
	call to environment() rather than field access.

2005-08-17  Per Bothner  <per@bothner.com>

	* Makefile.am (JAR_DEPS_XML): Also depend on gnu/kawa/xml's stamp file.

2005-08-09  Per Bothner  <per@bothner.com>

	* kawa/lang/eval.Java (eval, evalBody): Update to use startFromContext,
	getFromContextand cleanupFromContext methods from CallContext.
	Fixes Savannah bug #14071: Problem with use of eval in a repl.

2005-08-09  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVADOC_FLAGS): Remove (comment out) macro.

	* Makefile.am (set-selected-java-source): Fix thinko.

2005-08-03  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (namespaceResolve): Add a followAliases
	to handle imported classes.

	* kawa/lang/Translator.java (namespaceResolve): Return expressions that
	creates a ClassMethodProc, when appropriate.
	* kawa/standard/Scheme.java (lookupBuiltin): No point at this time
	in handling Symbols with uri starting "class:".
	* kawa/standard/set_b.java (rewriteForm): Optimize (TYPE:MEMBER ...)
	forms using ClassMethodProc rewrite form.

	* kawa/standard/Scheme.java (initScheme): Update field name used
	slot-set!.

2005-08-03  Chris Dean  <ctdean@sokitomi.com>

	* kawa/standard/Scheme.java (initScheme): Define new
	define-private-namespace function.

2005-07-29  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (namespaceResolve): If prefix is bound in
	the current environment to a ClassType, add "class:" prefix to name.

2005-07-27  Per Bothner  <per@bothner.com>

	* Makefile.am (set-selected-java-source): New rule - set
	selected-java-source but only if changed.
	(select-java1, select-java2, select-java4, select-java4x, select-java5):
	Use new set-selected-java-source rule, which works with read-only files.

	* Makefile.am (dist-hook): Default is now select-java4.

	* configure.in (AC_INIT): Set version to 1.8beta.
	* build.xml (version.release): Likewise.

2005-07-25  Per Bothner  <per@bothner.com>

	* kawa/standard/fluid-let.java (rewrite): Revert thinko in previous
	change.

2005-07-23  Per Bothner  <per@bothner.com>

	* kawa/standard/fluid-let.java (rewrite):  Push/pop position
	for better error messages.

2005-07-23  Alex Milowski  <alex@milowski.org>

	* kawa/standard/fluid-let.java (rewrite): Handle SyntaxForm.

2005-07-23  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (*print-base*, *print-radix*,
	*print-right-margin*, *print-miser-width*): New fluid variables.

	* kawa/GuiConsole.java (<init>): New shared parameter.
	Use to call InheritingEnvironment's setIndirectDefines.
	(actionPerformed): Update for modified Environment inheritance.

	* kawa/standard/TracedProcedure.java (applyN): setWithSave and
	setRestore now require an extra CallContext parameter.

2005-07-21  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (<init>): Default constructor now calls
	geNewEnvironment, to match old documentation/advice.
	Also sets the environ field.
	New non-default constructor called from clinit.

	* kawa/repl.java (propertyFields): New static table.
	(processArgs): Process arguments of the form 'NAME=VALUE'.

2005-07-20  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run): Set and restore default Language.

	* kawa/standard/Scheme.java (r4Environment, r5Environment,
	kawaEnvironment): Make final, and allocate in static block.

2005-06-29  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (numEqu, numGrt, numGEq, numLss, numLEq):
	New static fields for the numeric compare functions.
	(initScheme): Re-define numeric comparisions using new fields.

2005-06-27  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (checkMemberContext): New method.
	(rewrite): Call checkMemberContext.
	* kawa/standard/set_b.java (rewriteFrom): Set context Declaration.
	Fixes Savannah bug #4881.

2005-06-26  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (processAccesses): Call new capture method
	in LambdaExp to force field to get allocated.
	* kawa/standard/syntax_case.java (rewriteClauses): Handle SyntaxForm
	in input form.

	* kawa/lang/SyntaxTemplate.java (convert_template): Convert '(... ...)'
	to '...' as in other syntax-case implementations.

2005-06-04  Per Bothner  <per@bothner.com>

	* kawa/Shell.java: Update for AbstractFormat move to gnu.lists.
	* kawa/standard/Scheme.java: Likewise.

	* kawa/Shell.java (getOutputConsumer): Check for AbstractFormat
	instead of removed FormatToConsumer.
	(run): Likewise update types.
	* kawa/standard/Scheme.java (writeFormat, displayFormat): Change type.
	(getFormat): Change return type to AbstractFormat.

	* kawa/standard/Scheme.java: Redefine write and display as functions
	in kawa.lib.ports, since DisplayForm no longer extends Procedure.
	For same reason, don't call setname on writeFormat and displayFormat.

2005-05-27  Christian Surlykke <christian@surlykke.dk>

	* build.xml: Make mappers insider uptodate elements take build.dir
	property into account.
	* build.properties: Use basedir in template for build.dir property.

2005-06-02  Per Bothner  <per@bothner.com>

	Handle re-exporting declarations imported from a module.
	* kawa/lang/Macro.java (getCapturedScope): Use new findFromInstance
	method from ModuleInfo.
	* kawa/lang/TemplateScope.java (macroContext): New field.
	* kawa/lang/SyntaxTemplate.java (execute): Set TemplateScope's
	macroContext field from Translator's macroContext field.
	* kawa/lang/Translator.java (macroContext): New field.
	(getBinding): Inline into check_if_Syntax and remove.
	(check_if_Syntax): Simplify and change to only lookup lexical
	declaration.  However, also set macroContext.
	(rewrite_pair, scanForm): Use new check_if_Syntax.
	(rewrite): If scope is TemplateScope, set context of ReferenceExp
	from macroContext, if needed.
	* kawa/standard/require.java (importDefinitions): Change parameter.
	Don't search up super chain.  Use new ModuleInfo.setupModuleExp,
	and then iterate over resulting decls, rather than over fields.
	Silently skip if we duplicate existing decl with same alias base.
	Don't do makeDeclInModule2 in second pass since already done
	by setupModuleExp.  However, search for suitable xxx$instance
	declaration.
	(makeModule): Remove unused method.
	(makeDeclInModule1, makeDeclInModule1): Move to ModuleInfo.

	* kawa/standard/define.java (scanForm): Push/pop source location
	around define call for better error messages.

2005-05-29  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody): If not STATIC_SPECIFIC for class
	method then add the implicit this parameter.
	* kawa/standard/thisRef.java (rewriteForm): Look for implicit this
	parameter.
	* kawa/standard/object.java: Rewrite handling of init forms, since
	we want them to be in the scope of the init methods.  One reason is
	so we can bindg (this) to the implicit thuis parameter,
	(rewriteInit): New private method.
	(makeInitMethod): Remove method.
	This fixes Savannah bug #10806.

2005-05-27  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (loadSource): "Inline" call to CompileFile's
	read method, and set PARSE_IMMEDIATE flag.

2005-05-27  Dean Ferreyra <dferreyra@igc.org>

	* kawa/lang/Eval.java (evalBody): Need to set immediate flag.

2005-05-27  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Simplify immediate
	mode to share more logic with non-immediate mode.

	* kawa/standard/require.java (makeDeclInModule2): Don't
	setCapturedScope; it's wrong and may trash correct scope
	set in makeDeclInModule1.

	* kawa/standard/define_syntax.java (scanForm): We can now simplify
	the immediate and static cases to match the normal case.

	* kawa/standard/require.java (importDefinitions): Cast getRunInstance
	result to void, to avoid it being in the expression result.

2005-05-19  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody): Split up call to Compilation's
	push method into pieces and interleave them with default argument
	rewrite, so the latter are done using the correct scope.
	Fixes Savannah bug #10613.

2005-05-18  Per Bothner  <per@bothner.com>

	* Makefile.am (select-java1, select-java2, select-java4, select-java4x,
	select-java5): Define new PreProcess key use:java.lang.CharSequence.
	* kawa/lang/Quote.java: Use use:java.util.IdentityHashMap, instead of
	JAVA2 - which was wrong since IdentityHashMap is new in JDK 1.4.
	* kawa/lang/SyntaxTemplate.java: Likewise.
	* kawa/standard/syntax.java: Likewise.

2005-05-18  Per Bothner  <per@bothner.com>

	* kawa/TelnetRepl.java (serve): Get current Environment directly.
	* kawa/lang/AutoloadProcedure.java (load): Use new getLangEnvironment.

2005-05-17  Per Bothner  <per@bothner.com>

	* kawa/standard/fluid_let.java (rewrite): Look for lexical binding.

2005-05-13  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java (expand_pair): Rewrite to avoid deep recursion
	(and possible StackOverflow) on long lists.

2005-05-10  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Don't follow FieldLocation
	if not inlineOk as that may fail compiling a lambda context.

2005-05-06  Per Bothner  <per@bothner.com>

	* kawa/GuiConsole.java: Some updates for changed environment handling.
	* kawa/Shell.java (run): Remove one overloaded method.
	* kawa/repl.java (processArgs): Update accordingly.
	* kawa/lang/Eval.java(evalBody): Don't change current Environment.
	* kawa/lang/Translator.java (<init>): Use current Environment for env.
	* kawa/standard/Scheme.java (getNewEnvironment): Remove method.
	(<clinit>): Don't getNewEnvironment.
	(lookupBuiltin): New method, based on code from ScmEnv.
	* kawa/standard/ScmEnv.java: No longer needed - functionality
	merged into Scheme's lookupBuiltin.
	* kawa/standard/Makefile.am: Update accordingly.

	* kawa/MessageArea.java (write): Do setCaretPosition.

2005-04-21  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java: Use new contextDecl/setContextDecl
	accessors instead of accessing context field directly.

2005-04-20  Per Bothner  <per@bothner.com>

	Solidify support for re-exporting imported declarations.
	* kawa/lang/Translator.java (processAccesses): If decl is refernced
	by an exported macro, than it must be non-simple.
	* kawa/standard/require.java (importDefinitions): Recognize and
	create declarations for MODULE_REFERENCEs.
	(makeDeclInModule): Split into ...
	(makeDeclInModule1, makeDeclInModule2): ... two new methods.

	* kawa/standard/require.java (scanForDefinitions): Use matches
	method of Translator to check for 'NAME.

2005-04-19  Per Bothner  <per@bothner.com>

	* NEWS: Resurrect, since required by GNU/automake standards,
	but (at least for now) only a reference to the news.html web-page.

2005-04-18  Per Bothner  <per@bothner.com>

	* Makefile.am: Split JAVA4 PreProcess name into two features:
	use:java.lang.CharSequence and use:java.lang.Throwable.getCause.

	* Make-rules ($(OFILES_DIR)/$(PACKAGE_FNAME).lo:  Instead of -I flags,
	use $(CLASSPATH_ENV).	
	
	* kawa/standard/syntax.java (convert): Syntax fix for not-JAVA2.

2005-04-17  Per Bothner  <per@bothner.com>

	* configure.in (configure.in):  Support --with-java-source=4 and 4x.
	The default is now --with-java-source=4.
	Make -with-awt the default, even if --with-gcj.
	* Makefile.am (select-java4, select-java4x): New rules.
	(select-java-source): Handle '4' and '4x'.

	* Makefile.am (JEMACS_SUBDIRS): List gnu/jemacs subdirs rather than
	gnu/jemacs.  Move stuff from gnu/jemacs/Makefile.am.
	* configure.in (AC_CONFIF_FILES): Remove gnu/jemacs/Makefile.

2005-04-16  Per Bothner  <per@bothner.com>

	* NEWS: Remove file; replaced by html web-page
	http://www.gnu.org/software/kawa/news.html.
	* Makefile.am (instanll-html), README: Update accordingly.

2005-04-08  Per Bothner  <per@bothner.com>

	* kawa/standard/export.java (scanForDefinitions): Translate
	'namespace:NAME' to '$Namespace$NAME'.

2005-04-04  Per Bothner  <per@bothner.com>

	* Makefile.am (javadoc-cvs.log): New rule for updating javadoc.

2005-04-03  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVADOC_PACKAGES): Add a number of new packages.
	(JAVADOC_FLAGS): Update - we use more memory, at least on jdk 1.4.
	(install-javadoc-html): Add extra jars to CLASSPATH, for newpackages -
	Eclipse, ant, and servlets.

	* kawa/MessageArea.java: Fix javadoc problem.

	* kawa/package.html: New file, for javadoc.
	* kawa/lang/package.html: Likewise.
	* kawa/standard/package.html: Likewise.

	* kawa/lang/SyntaxForm.java: Fix javadoc errors.
	* kawa/lang/SyntaxTemplate.java: Likewise.

2005-04-02  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (featureMap): Add 'srfi-64,'testing.

	* kawa/lang/Eval.java (evalBody): Save/set/restore current Compilation.

	* kawa/lang/Eval.java (eval): New static field.
	* kawa/standard/Scheme.java (repl): New static field.
	(initScheme): Use defProcStFld for 'eval' and 'repl'.

2005-03-31  Dean Ferreyra <dferreyra@igc.org>
	    Per Bothner  <per@bothner.com>

	* kawa/standard/module_static.java: Recognize (module-static 'init-run).

2005-03-29  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (scanForm): Don't need set save/set/restore
	current Compilation, since it's now done in LispLangauge.parse.
	* kawa/standard/require.java (makeModule): Get current Language
	directly, rather than via current Compilation.
	(makeDeclInModule): Handle non-static FieldLocation alias; now
	works since getDeclaration creates context.  Use vdecl, not fdecl.
	Only setDontDereference if referenced field is indirect.
	Set constant flag if appropriate.

	* kawa/standard/Scheme.java (builtin): Remove pointless synchronized.

2005-03-28  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java: Initalize various static fields,
	including 'instance', in a static block, so they can be final.
	(initScheme): Make private.  Remove unused proc and syn variable.
	(nullEnvironment): Initialize in <clinit>, rather than initScheme.
	* kawa/GuiConsole.java (main): Update to use Scheme.getInstance().

2005-03-25  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (find):  No longer do 'run'.
	(importDefinitions): SET EARLY_INIT on both instance and alias decls.
	No longer set DEFER_DECL_BASE.
	We now find/create the module instance at initialization time, but
	'find' no longer does 'run', so emit coe to call 'run'.
	(makeDeclInModule): If value is FieldLocation, do getDeclaration.
	This re-fixes Savannah bug #11822.

2005-03-23  Per Bothner  <per@bothner.com>

	* kawa/standard/sleep.java: Now no longer extends Procedure1.
	(apply1): Renamed to static function sleep.
	* kawa/standard/with_input_from_file.java: Remove; rewritten in Scheme.
	* kawa/standard/with_output_to_file.java: Likewise.
	* kawa/standard/Makefile.am (java_sources): Update accordingly.
	* kawa/standard/Scheme.java: Update appropriately.
	Fix some defProcStFld that should be defSntxStFld.

2005-03-22  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (writeFormat, displayFormat): Do setName.

2005-03-20  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (define_syntax): Remove - no longer used.

	* kawa/standard/define_autoload.java) <init>: Pass Syntax name in.
	(define_autoload, define_autoloads_from_file): New static fields.
	* kawa/standard/export.java (module_export): Likewise.
	* kawa/standard/module_compile_options.java
	(module_compile_options): Likewise.
	* kawa/standard/module_extends.java (module_extends): Likewise.
	* kawa/standard/module_implements.java (module_implements): Likewise.
	* kawa/standard/module_name.java (module_name): Likewise.
	* kawa/standard/module_static.java (module_static): Likewise.
	* kawa/standard/syntax_error.java (syntax_error); Likewise.
	* kawa/standard/with_compile_options.java (with_compile_options):
	Likewise.
	* kawa/standard/Scheme.java: Change define_syntax -> defSntxStFld.

	* kawa/standard/define_class.java: New constructor.
	(define_class, define_simple_class): New static "instance" fields.
	* kawa/standard/constant_fold.java (constant_fold): Likewise.
	* kawa/standard/fluid_let.java (fluid_let): Likewise.
	* kawa/standard/object.java (objetSyntax): Likewise.
	* kawa/standard/define_unit.java (define_unit, define_base_unit):
	Likewis.
	* kawa/standard/prim_method.java (virtual_method, static_method,
	interface_method, constructor, op1): Likewise.
	* kawa/standard/Scheme.java: Update to use defSntxStFld.

	* kawa/standard/begin.java (begin): New static "instance" field.
	* kawa/standard/define.java (defineRaw): Likewise.
	* kawa/standard/define_alias.java (define_alias): Likewise.
	* kawa/standard/define_member_alias.java (define_member_alias):
	Likewise.
	* kawa/standard/define_syntax.java (define_macro, define_syntax):
	Likewise.
	* kawa/standard/define_variable.java (define_variable): Likewise.
	* kawa/standard/let_syntax.java (let_syntax, letrec_syntax): Likewise.
	* kawa/standard/location.java (location): Likewise.
	* kawa/standard/require.java (require): Likewise.
	* kawa/standard/set_b.java (set): Likewise.
	* kawa/standard/syntax.java (syntax): Likewise.
	* kawa/standard/syntax_case.java (syntax_case):: Likewise.
	* kawa/standard/syntax_rules.java (syntax_rules): Likewise.
	* kawa/standard/Scheme.java: Use new static instances to replace some
	define/define_syntax calls by defSntxStFld.

2005-03-18  Per Bothner  <per@bothner.com>

	* build.xml: Pass --module-static-run instead of --module-static.
	Compile kawa/lib/*.scm in proper order, adding prim_syntax.scm,
	and --warn-undefined-variable.

	* kawa/standard/Scheme.java (lambda): New static field.
	* kawa/standard/try_catch.java (rewrite): Rewritw catch-clause first
	to LambdaExp, rather than LetExp, before converting to CatchClause.
	Fixes Savannah bug #11540.

2005-03-17  Per Bothner  <per@bothner.com>

	* ltmain.sh: New version of cvs libtool (2.1a).
	* Make-rules (scm-classes.stamp): Use --module-static-run
	instead of --module-static.
	* aclocal.m4, configure, */Makefile.in: Re-geneate.

	* kawa/repl.java (processArgs): Don't setDefaultLanguage until
	default Environment has been set.

2005-03-16  Per Bothner  <per@bothner.com>

	* kawa/repl.java (previousLanguage): New static field.
	(getLanguageFromFilenameExtension, getLanguage, processArgs): Use
	previousLanguage to avoiding calling Language.getDefaultLanguage
	before that is working.
	* kawa/standard/Scheme.java (createReadTable): New method.
	* kawa/standard/Scheme.java <init>): Don't setDefaultLanguage here.

2005-03-16  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Handle new --module-static-run flag.
	* kawa/standard/require.java (importDefinitions): Skip fields whose
	name ends in "$instance" - except to optimize 'dofind'.

2005-03-11  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Don't set alias's
	type to typeFieldLocation, since getType should be post-indirection.
	(makeDeclInModule): Likewise, if field is a Location, decl type
	is Object. not a Location.

2005-03-07  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java: Update package of DefineNamespace.

	* kawa/standard/read_line.java (apply2): Update WrongType call.

2005-03-06  Per Bothner  <per@bothner.com>

	* ltmain.sh: New from CVS (patched) libtool 2.1a.
	* acinclude.m4, libtool.m4: Removed.
	* Makefile.am (EXTRA_DIST): Remove libtool.m4.
	* Makefile.in, configure, aclocal.m4: Re-generated.
	* configure.in: Updat AC_PROG_LIBTOOL to LT_INIT.
	* missing: New version from automake-1.9.
	* */Makefile.in: Re-generated.

2005-03-04  Per Bothner  <per@bothner.com>

	* kawa/repl.java: Update Interpreter->Language various places.
	* kawa/Shell.java: Likewise.
	* kawa/GuiConsole.java: Likewise.
	* kawa/TelnetRepl.java: Likewise.
	* kawa/lang/Lambda.java: Likewise.
	* kawa/lang/AutoloadProcedure.java: Likewise.
	* kawa/lang/CompileFile.java: Likewise.
	* kawa/standard/Scheme.java: Likewise.
	* kawa/standard/define_autoload.java: Likewise.
	* kawa/standard/define_syntax.java: Likewise.
	* kawa/standard/load.java: Likewise.
	* kawa/standard/not.java: Likewise.
	* kawa/standard/require.java: Likewise.
	* kawa/standard/syntax.java: Likewise.

	* kawa/standard/require.java (importDefinitions): Change to use
	FieldLocation.  Better handling of non-static modules and re-export.
	Don't set 'base' of fdecl (since it might be shared); instead create
	a ReferenceExp alias with a 'context'.
	(makeDeclInModule): Various tweaks.
	* kawa/lang/Translator.java (rewrite): Use FieldLocation.

2005-03-03  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (kawaEnvironment): More precise type.
	* kawa/standard/ScmEnv.java (<init>): Parameter is SimpleEnvironment,
	to match superclass parameter.

	* kawa/standard/Scheme.java: Remove definition of 'emacs' fnction - it
	doesn't work for Scheme, and causes order-dependency awkwardness when
	compiling CommonLisp/ELisp.

	* Makefile.am (SUBDIR): Some re-ordering to reduce dependencies.
	Specifically, jemacs and commonlisp import scheme functions, including
	ones in gnu.kawa.slib, so we sant to compile them later.

	* kawa/standard/Scheme.java: Function 'children' has been moved.

2005-02-24  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java registerEnvironment):
	Use new setDefaults method.

	* kawa/repl.java (getInterpreterFromFilenameExtension): Change return
	type and name to getLanguageFromFilenameExtension.
	(getInterpreter): Also change return type and rename to getLanguage.

2005-02-23  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote.java: Add an option to not namespace-expand.
	(quote): Add overload.  Change to not namespace-expand.
	* kawa/lang/Macro.java (expand): If ! hygienic, use Quote.quote to
	in-depth remove SyntaxForm, rather than only doing it shallowly.

	* kawa/lang/Translator.java (namespaceResolve): Only coerce String,
	FString, and Symbol with empty emptyspace to namespace uri.
	Specifically, don't coerce a <ClassType> at this point.

2005-02-20  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewrite(LambdaExp,Object,Translator): Rename
	to rewriteFormals, and add TemplateScope parameter.
	Make type of local templateScope more precise.
	(rewrite(LambdaExp,Object,Object,Translator,TemplateScope)): New.
	* kawa/standard/define.java (scanForm): Update rewrite->rewriteFormals.
	* kawa/lang/SyntaxForm.java (scope): Make type of field more precise.
	(<init>): Make private.
	(makeWithTemplate): Return argument if we don't have a SyntaxForm.
	* kawa/lang/SyntaxTemplate.java (execute, executeToList): Make
	templateScope parameter more precise.
	* kawa/standard/let.java (rewrite): Likewise for templateScope local.
	* kawa/standard/object.java (scanClassDef): Simplify - we don't need
	to remember template scopes here.
	(rewriteClassDef): See added comment.

	* kawa/standard/location.java (makeProcLocation$V): Can now simplify
	if proc is a LocationProc.

	* kawa/standard/require.java (importDefinitions): Remove duplicate
	setAlias and setIndirectBinding calls.

2005-02-17  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (makeAlias, makeRenamedAlias): Merge former
	into latter.  Set setDontDereference flag.
	(define): Use modified makeRenamedAlias.

2005-02-16  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (rewriteClassDef): If an input sub-form
	is a SyntaxForm remember that, and use it to setCurrentScope.
	Fixes Savannah PR 11822.
	(rewriteClassDef): Also use SyntaxForm to rewrite init forms.
	(scanClassDef): Fix some bugs in handling of init forms.

	* kawa/standard/define_class.java (scanForDefinitions): Handle the
	case that the input form is wrapped in a SyntaxForm.

2005-02-15  Per Bothner  <per@bothner.com>

	Use ModuleInfo to make sure 'run' is only done once, even if immediate.
	* kawa/standard/requier.java (find(String)): Use ModuleInfo.find.
	(find(ClassType, Environment), find(Class, Environment)): Remove.
	(importDefinitions): If instance is needed, manage it with ModuleInfo.
	If run is needed in immediate mode, use ModuleInfo's getRunInstance
	so run gets run only once, and at run-time, not compile-time.

2005-02-12  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (expand): Add extra test since Expression
	now extends Procedure.
	* kawa/standard/define.java (scanForm): Use setSymbol since
	setName(Object) was removed from LambdaExp.
	* kawa/standard/object.java (scanClassDef): Likewise.

	* kawa/standard/Scheme.java: Declare 'make-parameter' and
	'parameterize' from SRFI-39.

	* kawa/standard/location.java (class LocationProc): Moved class to
	new file gnu/mapping/LocationProc.java.

	* kawa/standard/define.java: Use different SetExp constructor,
	to avoid setting the 'binding' field, which will become private.
	* kawa/standard/define_class.java: Likewise.
	* kawa/standard/define_unit.java:  Likewise.
	* kawa/standard/object.java: Likewise.
	* kawa/standard/define_variable.java: Use SetExp's setBinding method.
	* kawa/standard/set_b.java: Likewise.

2005-02-07  Per Bothner  <per@bothner.com>

	* build.xml: Also compile srfi37.scm.  Compile DefineRecordType.scm
	before srfi37.scm, which makes use of define-record-type.

	* kawa/lang/Translator.java (namespaceResolve): If Uri is bound to
	a constant ClassType create a ClassMethodProc.
	Fixes the second test-case for Savannah bug #11822.

	* kawa/standard/Scheme.java: Change class-methods to use defProcStFld.

	* kawa/standard/require.java (makeDeclInModule): Set value to
	reference to appropriate Declaration if StaticFieldLocation.
	Fixes Savannah bug #11822 - but only for macros in static modules.

	* kawa/standard/require.java (find(String)):  Move 'run' call to ...
	(find(Class, Environment)): ... here to also do run at compile-time.

2005-01-31  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (namespaceResolve): Treat unbound
	identifier <name> as equivalent to "class:name".

2005-01-30  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (compile_to_files): Don't generate
	error message - that's handled in Compilation.compile.
	* Shell.java (run): Print messages in all catch clauses.

2005-01-29  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (featureMap): Add srfi-37 and args-fold.

	* kawa/standard/ScmEnv.java (lookupExtend): Inline call to
	ClassMethods.apply, but don't throw an Exception.

	* kawa/lang/Quote.java: Rename LispInterpreter -> LispLanguage.
	* kawa/lang/Translator.java: Likewise.
	* kawa/standard/Scheme.java: Likewise.  Extend LispLanguage.

2005-01-28  Per Bothner  <per@bothner.com>

	* Makefile.am (patch-source-list): Sort the result, for stability.

2005-01-26  Per Bothner  <per@bothner.com>

	* kawa/standard/with_compile_options.java (scanForm):  Put back a
	statement that should not have been deleted in 01-22 change.

2005-01-25  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java: Update Interpreter -> Language.
	* kawa/lang/Eval.java: Likewise.

2005-01-22  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (scanBody): New parameter makeList, to
	specify whether we return a list or push result on formStack.
	(rewrite_body): Fix scanBody call.
	(makeBody): Revert 01-12 change because it breaks top-level.
	* kawa/standard/begin.java (scanForm):  Use tr.scanForm option to
	create a list, and return a scanned for for later rewrite.
	Alternative fix to problem fixed by 01-12 change.
	* kawa/lang/Eval.java (evalBody): Update scanForm call.
	* kawa/standard/with_compile_options.java (scanForm): Update calls to
	tr.scanForm. Let Translator create list rather than doing it here.

	* kawa/standard/Scheme.java (scheme_counter): Remove static field.
	(getNewEnvironment): Use inherited env_counter instead.

	* configure.in: Make AC_PROG_LIBTOOL unconditional, since needed
	for bin/cgi-servlet.

2005-01-18  C. Brian Jones  <cbj@gnu.org>

	* configure.in: Added BYTECODE_VERSION.
	[Per: changed to be the same as VERSION]
	* Makefile.am: Added targets for bytecode.jar, install-bytecode-jar.
	* gnu/bytecode/jar-manifest: New file.

2005-01-16  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (makeDeclInModule): Clear the value
	of the imported decl if it isn't constant.

2005-01-12  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (namespaceResolve(String)): Don't look
	for class matching prefix here.
	(namespaceResolve(String,boolean)): If JAVA2, look for class matching
	prefix without initializing the class.

	* kawa/lang/Translator.java (makeBody): Don't make AppendValues call
	here since it causes Scheme begin at top-level to mis-behave.

2005-01-10  Per Bothner  <per@bothner.com>

	* config.guess: Update to newer version, from libtool 1.5.10.
	* config.sub: Likewise.
	* ltmain.sh: Update to libtool 1.5.10.

	* configure.in: More little fixes and updates.

	* configure.in: Ran autoupdate over file to update to current autoconf
	syntax, followed by some manual fixups of AC_CONFIG_LINK.

	* Makefile.am (select-java1, select-java2, select-java5): Fix sed
	pattern to work with BSD sed (as on OS X) as well as GNU sed.

2005-01-08  Per Bothner  <per@bothner.com>

	* build.xml (build-tools): Also compile gnu/kawa/util/PreProcess.java.
	(select-java1, select-java2, select-java5): Rewrite to use PreProcess.

	* kawa/lang/Macro.java (setExpander): Remove unused field.
	* kawa/standard/define_syntax.java (setExpanderMethod): Likewise.

	* kawa/standard/define_syntax.java (makeHygienic, makeNonHygienic):
	New Procedure fields replace makeMethod, makeNonHygienicMethod.
	(scanForm): New new fields.

	* kawa/standard/define_syntax.java (scanForm): Use new ThisExp
	factory method makeGivingContext so we can eval this ApplyExp
	in the current Compilation.  This fixes Savannah bug #11508.

	* kawa/standard/require.java (importDefinitions): If immediate
	note the instance value as a constant.  Don't compile a dofind call.

2005-01-07  Per Bothner  <per@bothner.com>

	* Makefile.am (patch-source-list): Filter with sed out initial "./".
	(select-java1, select-java2, select-java5): Use new PreProcess class.

	* build.xml: Add support for #ifndef JAVA5.

	* kawa/lang/Macro.java: Remove unneeded imports.
	* kawa/lang/CompileFile.java: Likewise.
	* kawa/lang/SyntaxTemplate.java: Likewise.
	* kawa/lang/Translator.java: Likewise.
	* kawa/standard/syntax_case.java: Likewise.
	* kawa/lang/Lambda.java: Reference static method using class name,
	to avoid ecj warning.
	* kawa/lang/Quote.java: Likewise.

2005-01-03  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxPattern.java (translate): Pass correct SyntaxForm.
	(literalIdentifierEq): Finish implementation.

	* kawa/lang/SyntaxRules.java (expand): Recover robustly if there
	was an error defining the macro.

	* kawa/lang/Translator.java (makeAlias, makeRenamedAlias): Some
	code moving to reduce duplication..

2005-01-02  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVATOP): Remove unused macro.

	* Makefile.am: Update "select" rules to use new "preprocessor" syntax.
	* build.xml: Likewise.

	* kawa/lang/Quote.java, kawa/lang/SyntaxTemplate.java,
	kawa/standard/syntax.java: Change "select" (preprocessor) syntax.

2004-12-29  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions): Avoid some
	needless work in immediate mode.

2004-12-27  Per Bothner  <per@bothner.com>

	* kawa/standard/define_syntax.java (scanForm): Use new isStatic().

	* Makefile.am (SUBDIRS): "Inline" SUBDIRS from gnu and gnu/kawa.
	(install-html): Don't do into now Makefile-free gnu directory.
	* configure.in (AC_OUTPUT): Update accordingly.

2004-12-26  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxPattern.java (literalIdentifierEq,
	getLiteralsList): New static methods.
	(translate): Use literalIdentifierEq.
	* kawa/standard/syntax_rules.java: (rewriteForm): Use new
	SyntaxPattern.getLiteralsList method.
	* kawa/standard/syntax_case.java: (rewriteForm): Likewise.

	* kawa/lang/SyntaxRule.java (<init>): Take extra SyntaxForm parameter.
	* kawa/lang/SyntaxTemplate.java: Likewise.
	(convert_template): Pass extra SyntaxForm parameter.
	* kawa/standard/syntax.java: Fix to pass null SyntaxForm.
	* kawa/standard/define_syntax.java (scanForDefinitions): Replace by ...
	(scanForm): New method.  Fix lacking handling of SyntaxForm.
	* kawa/lang/SyntaxRules.java (<init>):  Likewise.

2004-12-24  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java: New syntax "include-relative".
	The "include" syntax was moved.

	* kawa/lang/SyntaxForm.java (makeWithTemplate): New static function.

	* kawa/lang/SyntaxPattern.java (allocVars): New helper method.
	* kawa/lang/Translator.java (matchArray): New field, moved
	here from syntax_case.work.
	* kawa/standard/syntax_case.java: Fix bugs when nested syntax-cases.

	* kawa/standard/Scheme.java; Define "include", "syntax-object->datum",
	"datum->syntax-object", "with-syntax".

2004-12-23  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (setLineOf): Do nothing if QuoteExp.

2004-12-22  Per Bothner  <per@bothner.com>

	* Makefile.am: Partially convert pre-processor syntax, for JAXP
	version selection: use #ifdef, #ifndef, #else.  Updates rules.
	* build.xml: Update select-java1, select-java2, select-java5.

	* kawa/lang/SyntaxTemplate.java: Fix comment syntax so it doesn't
	break under 'make select-java1' -> 'make select-java2'.
	* kawa/lang/Translator.java (syntaxError): Moved to Compilation.
	* kawa/standard/Scheme.java: Update classes for 'make-element' and
	'make-attribute'.

2004-12-20  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): "Filter" through Quote.quote.
	* kawa/lang/Quote.java: Merge with quasiquote.java to handle both
	quasiquote and regular quote. Check for cycles.
	* kawa/standard.Scheme (initScheme): Update 'quote' and 'quasiquote'.

	* kawa/lang/Translator.java (selfEvauatingSymbol): New method.
	(matches, getBinding, rewrite_pair, rewrite): Use new method.
	* kawa/standard/quasiquote.java: Remove no-longer-used class.
	* kawa/standard/Makefile.am: Update accordingly.

2004-12-19  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxTemplate.java: New handling of ellipsis,
	needed to correctly process forms like (template ... ...).
	(BUILD_REPEAT): Remove constant.
	(BUILD_DOTS): New constant.
	(print_template_program, convert_template): Update accordingly.
	(execute_car):  Gnerealize to executeToList.  Handle BUILD_DOTS.

	* kawa/lang/SyntaxTemplate.java (convert_template):  Extra isVector
	paremater, since argument to BUILD_VECTOR must be true list.

	* kawa/lang/SyntaxTemplate.java (convert_template): Check for cycles.
	
	* kawa/lang/SyntaxPattern.java (match): Add optional debug output.

	* kawa/standard/Scheme.java (initScheme): Define 'case-lambda'.

2004-12-18  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRules.java (<init>):  Allow an empty list in
	syntax-rules, since R%RS does.

	* kawa/lang/SyntaxTemplate.java (BUILD_VECTOR): Simplify implemenation.
	(BUILD_VEC_REPEAT): Remove non-longer-used constant.
	(print_template_program): Update accordingly.
	(convert_template, execute): Vector handling is now trivial.

2004-12-08  Per Bothner  <per@bothner.com>

	* kawa/repl.java: Update for new Environment handling.
	* kawa/lang/AutoloadProcedure.java (load): No longer handle autoload
	of ModuleBody.
	* kawa/lang/AutoloadSyntax.java: Likewise.
	* kawa/standard/load.java: Small updates.
	* kawa/standard/location.java: Update for changed ProcLocation.
	* kawa/standard/require.java: Rewrite for new Environment handling.
	* kawa/standard/fluid_let.java: Don't set type, since it's no
	longer a typeFluidBinding, but an indirect binding.
	Clear noted value, since it may be changed unpredictably.

	* kawa/standard/Scheme.java (defSntxStFld): Removed - now redundant.
	(initScheme): Update.  Use defSntStFld many places.
	* kawa/standard/ScmEnv.java: No longer search "extra" Environments.
	(extra, numExtras): Removed fields.
	(addExtra, get): Removed method.
	(lookupExtend): New method.
	(ScmEnvConstraint): Remove local class.
	* kawa/standard/TracedProcedure.java: Use new Location handling.
	* kawa/standard/define.java (scanForm): Use new Translator.define.
	* kawa/standard/define_alias.java: Set line number.
	* kawa/standard/define_autoload.java: Remove the unused ability to
	specify an autoload type.

	* kawa/lang/Macro.java: Handle hygiene even without (require).
	(getCapturedScope, setCapturedScope, makeNonHygienic): New methods.
	* kawa/lang/SyntaxForm.java: New implements Externalizable.
	* kawa/lang/TemplateScope.java: New class.
	* kawa/lang/Makefile.am: Update accordingly.
	* kawa/lang/SyntaxTemplate.java (execute): Create TemplateScope.
	* kawa/lang/Translator.java: Numerous updates.
	* kawa/standard/define_class.java: Handle hygiene.
	* kawa/standard/define_syntax.java: Support new macro handling.
	* kawa/standard/define_variable.java: Set decl's IS_DYNAMNIC flag.

	* kawa/standard/object.java: Use rewrite_car to set line numbers.

	* kawa/standard/define_syntax.java: Don't special-case for rule
	being a QuoteExp.  Pass 'instance' value when create Macro.

2004-12-07  Per Bothner  <per@bothner.com>

	* Makefile.am (EXTRA_DIST): Don't include old makekawa.bat.
	* acinclude.m4: Remove unused LIBGCJ_CONFIGURE rule.

	* configure.in:  Set version to 1.7.91.
	* build.xml (version.release):  Set to 1.7.91.

2004-12-02  Per Bothner  <per@bothner.com>

	* kawa/standard/force.java: Converted to Scheme and removed.
	* kawa/standard/make_future.java: Likewise.
	* kawa/standard/Makefile.am: Update accordingly.
	* kawa/standard/Scheme.java: Update accordingly.
	Also use defProcStFld for 'as' and 'throw'.

2004-11-16  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (defSntxStFld): New method.
	(initScheme): Replace many uses of define_syntax by defSntxStFld.

	* kawa/standard/throw_name.java (throwName): New static field.
	* kawa/standard/call_with_values.java (callWithvalues): Likewise.
	* kawa/standard/Scheme.java (initScheme): Replace most define_field
	calls by defprocStFld, and the rest by define_syntax, Also replace
	many define_proc by defProcStFld.

2004-11-15  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxTemplate.java: Change "opcode" of template_program
	from 2 bits to 3 bits.  Rearrange them some.
	(BUILD_VAR_CAR): New opcode.
	(pattern_nesting): Rename to patternNesting. Low-order bit encodes
	if match is car of saved Pair.
	(get_var, execute_car): New helper methods.
	* kawa/lang/PatternScope.java (pattern_nesting): Renamed likewise.
	* kawa/lang/SyntaxPattern.java (MATCH_ANY_CAR): New opcode.
	(translate): Take a "context" parameter so we can tell when to
	emit MATCH_ANY_CAR.
	(match_car): New function.
	(disassemble, match): Handle MATCH_ANY_CAR.
	* kawa/lang/SyntaxRules.java: Updated for renamed pattern_nesting.

	* kawa/lang/Lambda.java (rewrite): Use Translator.setLine method.

	* kawa/lang/Macro.java (expand): If result is not PairWithPosition,
	copy position from input form.

	* kawa/lang/Translator.java (setLine): New static convenience method.
	* kawa/standard/define.java (scanForm): Use it.

	* kawa/standard/syntax_case.java: Remove unused local.

2004-11-14  Per Bothner  <per@bothner.com>
	
	* kawa/standard/char_ready_p.java: No longer extend Procedure0or1.
	(apply0, apply1): Remove methods.

	* kawa/standard/Scheme.java (r4Environment, r5Environment): Make
	public, so they can be accessed from kawa.lib.misc.
	* kawa/standard/scheme_env.java: Remove.
	* kawa/standard/Makefile.am: Update accordingly.

	* kawa/standard/Scheme.java: The functions dynamic-wind, char-ready?,
	scheme-report-environment and moved to different classes.
	* kawa/standard/Scheme.java: Incompletely convert to use defProcStFld.

2004-11-11  Jim White  <jim@pagesmiths.com>

	* build.xml: Update select-java1, select-java2, and add select-java5.
	Search for BEGIN JAVA|BEGIN JAXP instead of maintaining an
	explicit lists of files to modify.

2004-11-10  Per Bothner  <per@bothner.com>

	* Makefile.am (selected-java-source): Depend on Makefile.

	* kawa/standard/and_or.java: Removed.
	* kawa/standard/Makefile.am (java_sources): Remove and_or.java.
	* kawa/standard/Scheme.java: Use definition of 'or' with macro
	define in kawa.lib.std_syntax.

2004-11-08  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxPattern.java (translate): Change MATCH_LENGTH
	encoding for non-pure lists.
	(match): Fix MATCH_LENGTH and MATCH_LREPEAT handling.
	* kawa/lang/SyntaxTemplate.java (BUILD_VECTOR): Since no repetition
	uses a var_no of 0, add one to var_no for a repeated variable.
	* kawa/lang/Translator.java (listLength): Minor optimization.

2004-11-06  Per Bothner  <per@bothner.com>

	* kawa/lang/Syntax.java (rewriteForm, scanForm): New methods.
	* kawa/lang/SyntaxForm.java (form, scope): Make fields public.
	(tr): Remove field.
	(make, toString, fromDatum, fromDatumIfNeeded, rewrite, rewriteBody,
	isIdentifier, freeIdentifierEquals): New methods.
	* kawa/lang/SyntaxPattern.java: New class extends Pattern. It encodes
	a pattern from syntax-case/syntax-rules in a "program".
	* kawa/lang/SyntaxTemplate.java: New class.
	* kawa/lang/SyntaxRule.java: Now a skeleton that inherits from
	SyntaxTemplate.
	* kawa/lang/SyntaxRules.java: Major re-write.
	* kawa/lang/PatternScope.java: New class.
	* kawa/lang/Makefile.am: Add new classes.

	* kawa/lang/PairPat.java (match): Remove no-lobger-useful SyntaxForm
	support.
	* kawa/lang/Quote.java (rewrite): Strip off SyntaxForm.
	* kawa/lang/Translator.java: Major rewrite to handle SyntaxForm.
	Some methods renamed.  Scan methods now use the new formStack,
	rather than a freshly-allocated Vector.  Some new helper routines.
	* kawa/lang/Macro.java: Don't keep track of captured identifiers
	individually, but instead use a single 'capturedScope'.
	(hygienic): New field to handline hygienic and non- differently.
	* kawa/lang/Eval.java (evalBody): Update for new scan protocol.
	* kawa/lang/AutoloadSyntax.java: Update to define scanForm.
	* kawa/lang/Lambda.java: Handle incoming SyntaxForms.

	* kawa/standard/require.java: Create a new ModuleExp for imported
	fields.  Set Macro's capturedScope to it, rather than each Declaration.
	* kawa/standard/set_b.java:  Simplify by just calling rwrite on LHS.
	* kawa/standard/syntax.java: New class.
	* kawa/standard/syntax_case.java: Rewrite.
	* kawa/standard/syntax_error.java (error): New static method.
	* kawa/standard/let.java: Re-write.
	* kawa/standard/let_syntax.java: Likewise.
	* kawa/standard/IfFeature.java: No longer extends Syntax.
	Just contains static help methods.
	* kawa/standard/begin.java (scanForDefinitions): Replace by scanForm.
	* kawa/standard/define.java: Re-shuffle.  Simplify parsing by
	using define-syntax.  OTOH, have to deal with SyntaxForm.
	* kawa/standard/define_class.java: Handle SyntaxForm - incompletely.
	* kawa/standard/define_syntax.java: Also use for %define-macro.
	* kawa/standard/ifp.java: Removed - now implemented in prim_syntax.scm.
	* kawa/standard/object.java: Handle SyntaxForm - incompletely.
	* kawa/standard/try_catch.java: No longer implement Syntax.
	* kawa/standard/synchronizd.java:  Removed - now in prim_syntax.scm.
	* kawa/standard/try_finally.java: Likewise.
	* kawa/standard/with_compile_options.java: Handle SyntaxForms.
	* kawa/standard/Makefile.am: Update accordingly.
	* kawa/standard/Scheme.java: Various updates.

2004-11-06  Per Bothner  <per@bothner.com>

	* Make-rules: New automake doesn't seem to set DIST_SOURCES from
	SOURCES, so undefine SOURCES and define DISTFILES explicitly.

	* configure.in: New --with-java-source flag, sets @JAVA_SOURCE@.
	* Makefile.am (java1-java2-files): Rename to patch-source-list and
	generailize to also look for JAVA5 and JAXP conditionals.
	(selected-java-source, select-java5, dist-hook): New rules.
	
	* Makefile.am (makekawa.bat): Remove bit-rotted rule.

2004-10-27  Per Bothner  <per@bothner.com>

	* Shell.java (counter): Remove static field.
	(run): Use ModuleExp.interactiveCounter instead of counter field.

2004-10-23  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite): Use new QuoteExp.getInstance.
	(rewrite_body): Initialize variables using #!undefined, not #!null.
	* kawa/standard/Scheme.java (initScheme):  letrec in now in kawa/lib.
	* kawa/standard/letrec.java: Removed, no longer needed.
	* kawa/standard/Makefile.am (java_sources): Remove letrec.java.

	* Make-rules:  Remove bogus 'clean' rule.

2004-09-05  Per Bothner  <per@bothner.com>

	* kawa/standard/ifp.java (allowElseList): New flag.
	(<init>): New constructor.
	(rewrite):  Rewrite.

	* kawa/lang/ListPat.java (match):  Check that list isn't too long.
	Based on a patch (8/19) from Dominique Boucher
	<dominique.boucher@nuecho.com>.

2004-08-24  Per Bothner  <per@bothner.com>

	* kawa/standard/readchar.java (readChar, peekChar): New static fields.
	* kawa/standard/Scheme.java (initScheme):  Use new static fields.

	* kawa/standard/Scheme.java (initScheme):  Functions open-input-file,
	pen-output-file, and call-with-output-string now in kawa.lib.ports.
	* kawa/standard/open_input_file.java:  Remove - no longer needed.
	* kawa/standard/open_output_file.java:  Likewise.
	* kawa/standard/call_with_output_string.java:  Likewise.
	* kawa/standard/Makefile.am:  Update accordingly.

2004-08-23  Per Bothner  <per@bothner.com>

	* configure.in (--with-swt):  New option.
	(WITH_SWT):  New conditional.
	(AC_OUTPUT):  Add gnu/jemacs/swt/Makefile.

2004-08-04  Christian Surlykke <christian@surlykke.dk>

	* build.xml: Added jemacs-swt-classes task.

2004-08-10  Per Bothner  <per@bothner.com>

	* configure.in: Change conf_classpath so the pathsep comes after
	the added entry.
	* Make-rules (CLASSPATH_ENV):  Change accordingly.
	(scm-classes.stamp, clisp-classes.stamp, elisp-classes.stamp):
	Use CLASSPATH_ENV, so --with-servlet jar gets searched.
	* Makefile.am (dis-kawa-@VERSION@.jar):  Update to use --with-servlet.

2004-08-09  Per Bothner  <per@bothner.com>

	* Make-rules (DIST_SOURCES):  Remove unused macro.

	* configure.in:  Replace --enable-servlet by --with-servlet[=jar].
	Default enable_servlet from with_servlet.
	(conf_classpath):  New variable, set from --with-servlet.
	Use AC_HELP_STRING.
	* Make-rules (CLASSPATH_ENV):  Use autoconf variable @conf_classpath@.

2004-08-08  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Don't set decl if no uri.

2004-08-08  Per Bothner  <per@bothner.com>

	* kawa/lang/CalledContinuation.java (values):  A continuation
	can take multiple values.
	* kawa/lang/Continuation.java:  Extend MethodProc, not ProcedureN.
	(<init>):  Change to take a CallContext.
	(apply1, applyN):  Remove methods.
	(apply):  New method.
	* kawa/standard/call_with_values.java (apply):  Use checkN.
	* kawa/standard/callcc.java:  Extend MethodProc, not Procedure1.
	(apply(Procedure), apply1):  Remove methods.
	(numArgs, match1, apply):  New methods.
	* kawa/standard/load.java (loadCompiled):  Always assume ModuleBody.

2004-08-08  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadProcedure.java (load):
	ModuleBody is not always Runnable.

	* kawa/lang/Translator.java (pushPositionOf):  Trivial optimization.

2004-08-07  Per Bothner  <per@bothner.com>

	* kawa/standard/cxr.java:  Use new WrongType constructors.
	* kawa/standard/make.java:  Likewise.
	* kawa/standard/read.java:  Likewise.
	* kawa/standard/readchar.java:  Likewise.
	* kawa/standard/vector_append.java:  Likewise.
	* kawa/standard/append.java:  Likewise.
	(append):  New static field.
	* kawa/standard/Scheme.java:  Redefined 'append' to use new field.

2004-08-06  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java:  New longer implements Procedure2.
	(apply2): Convert to Scheme and move to kawa.lib.system.
	(read):  Use WrappedException instead of GenericFile.
	* kawa/standard/Scheme.java:  Change location of compile-file.

2004-08-03  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (counter):  New field.
	(run):  Increment and append counter to generated class name.

2004-07-31  Per Bothner  <per@bothner.com>

	* kawa/repl.java:  Update copyright year printed by --version.

2004-07-27  Chris Dean  <ctdean@sokitomi.com>

	* kawa/repl.java: Print out compilation options

2004-07-20  Per Bothner  <per@bothner.com>

	* kawa/GuiConsole.java:  Remove unused import statements.
	* kawa/GuiInPort.java:  Likewise.
	* kawa/MessageArea.java:  Likewise.
	* kawa/Shell.java:  Likewise.
	* kawa/lang/AnyPat.java:  Likewise.
	* kawa/lang/CompileFile.java:  Likewise.
	* kawa/lang/EqualPat.java:  Likewise.
	* kawa/lang/Lambda.java:  Likewise.
	* kawa/lang/ListRepeatPat.java:  Likewise.
	* kawa/lang/PairPat.java:  Likewise.
	* kawa/lang/SyntaxRule.java:  Likewise.
	* kawa/lang/Translator.java:  Likewise.
	* kawa/lang/loadcompiled.java:  Likewise.
	* kawa/standard/Scheme.java:  Likewise.
	* kawa/standard/atan.java:  Likewise.
	* kawa/standard/call_with_values.java:  Likewise.
	* kawa/standard/define_autoload.java:  Likewise.
	* kawa/standard/define_member_alias.java:  Likewise.
	* kawa/standard/letrec.java:  Likewise.
	* kawa/standard/logior.java:  Likewise.
	* kawa/standard/make_future.java:  Likewise.
	* kawa/standard/max.java:  Likewise.
	* kawa/standard/min.java:  Likewise.
	* kawa/standard/module_extends.java:  Likewise.
	* kawa/standard/module_implements.java:  Likewise.
	* kawa/standard/module_name.java:  Likewise.
	* kawa/standard/object.java:  Likewise.
	* kawa/standard/open_output_file.java:  Likewise.
	* kawa/standard/prim_method.java:  Likewise.
	* kawa/standard/quantity2number.java:  Likewise.
	* kawa/standard/quantity2unit.java:  Likewise.
	* kawa/standard/scheme_env.java:  Likewise.
	* kawa/standard/syntax_error.java:  Likewise.
	* kawa/standard/throw_name.java:  Likewise.
	* kawa/standard/try_finally.java:  Likewise.
	* kawa/standard/vector_append.java:  Likewise.
	* kawa/standard/with_input_from_file.java:  Likewise.
	* kawa/standard/with_output_to_file.java:  Likewise.
	* kawa/standard/define.java:  Use static syntax to access
	static fields/methods.
	* kawa/standard/define_class.java:  Likewise.
	* kawa/standard/define_member_alias.java:  Likewise.
	* kawa/standard/define_syntax.java:  Likewise.
	* kawa/standard/define_unit.java:  Likewise.
	* kawa/standard/define_variable.java:  Likewise.
	* kawa/standard/object.java:  Likewise.

2004-07-19  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme (initScheme):  The functions rationalize,
	sqrt, exact->inexact and inexact->exact are now in kawa.lib.numbers.
	* kawa/standard/exact2inexact.java:  Removed class.
	* kawa/standard/inexact2exact.java:  Likewise.
	* kawa/standard/rationalize.java:  Likewise.
	* kawa/standard/sqrt.java:  Likewise.
	* Makefile.am:  Update accordingly.

2004-06-21  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (throwsKeyword):  New constant.
	* kawa/lang/Lambda.java (rewrite):  Do pushPositionOf and
	popPositionOf around each parameter for better error messages.
	(rewriteAttrs):  Handle throws specification.

2004-05-10  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (scanClassDef, rewriteClassDef):  Improved
	line number setting.
	(scanClassDef):  Error if duplicate init forms.

	* kawa/standard/object.java (scanClassDef):  Remove clinits local.
	(rewriteClassDef):  Remove clinits form returned array.
	(scanClassDef) Don't rewrite init-form: expression yet.
	(rewriteClassDef):  Extra pre-pass to rewrite init-form: forms first.
	Fixes bug #8837.

2004-05-06  Per Bothner  <per@bothner.com>

	* kawa/standard/cxr.java (count):  Replace field by high-order
	16 bits, so that setting mask+count is atomic.

	* kawa/standard/cxr.java (program):  Fix race condition.
	Partly fixes bug #8817.

2004-04-22  Per Bothner  <per@bothner.com>

	* build.xml  (build.selectjava):  Add gnu/lists/FString.java

2004-04-17  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Fix typo.
	Fixes bug #7666.

	* configure.in: Fix help text typo reported by Pete Chown.
	Fixes bug #7851.

2004-03-08  Per Bothner  <per@bothner.com>

	* kawa/standard/define_syntax.java (rewriteForm): Do setProcedureDecl
	and setFuncDef, for the sake of 'defmacro' used in Common Lisp.

	* kawa/standard/define_class.java (rewrite):  Move setSimple call ...
	(scanForDefinitions):  ... to here.
	
	* kawa/standard/load.java (loadSource):  Don't call beginDocument
	or endDocument.

	* build.xml (build.selectjava):  Add gnu/mapping/Symbol.java
	and gnu/text/Char.java.

2004-03-03  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (bind):  Remove method.
	(make):  Call Declaration's setSyntax instead of bind.
	(<init>(Object,Expression)):  Remove constructor.
	* kawa/standard/define_syntax.java (scanForDefinitions):  Defer
	allocation of new Macro until rewrite time.
	(rewrite):  Simpler and cleaner logic.  We don't note the value of
	Declaration as being a constant Macro when it isn't.
	* kawa/standard/let_syntax.java (rewrite):  Add call to noteValue,
	since Macro constructor no longer does it.
	* kawa/standard/require.java (importDefinitions):  Call noteValue and
	setSynax for Macro declaration in place of Macro's removed bind.

2004-02-21  Per Bothner  <per@bothner.com>

	* build.xml (build.selectjava):  Add gnu/math/RealNum.java.

2004-02-15  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewrite):  Refactor so rewrite can be called
	at scan time, while rewriteBody can be called at rewrite time.
	(rewriteAttrs):  New method handles access and allocation attributes.
	(rewrite(LambdaExp, Object, Translator), skipAttrs):  New methods.
	* define.java (scanForDefinitions):  Do first part of lambda.rewrite
	here (but not rewriteBody), to get parameter and result types.
	* kawa/standard/define_alias.java (rewrite):  Move processing
	to scanForDefinitions.
	* kawa/standard/object.java (accessKeyword):  New constant.
	(allocationKeyword):  Make public.
	(scanClassDef):  New method, for "scan-time" processing.
	Process access: specifier for fields.
	Call rewriteAttrs for methods.
	(rewriteClassDef):  Method for "rewrite-time" processing.
	Call skipAttrs for methods,
	(rewriteForm):  Update to call scanClassDef and then rewriteClassDef,
	* kawa/standard/define_class.java (scanForDefinitions):
	Call object's scanClassDef.
	(rewriteForm):  Call objects's rewriteClassDef.

2004-02-15  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_car):  Make public.
	(rewrite_pair):  Use LispInterpreter's makeApply (overridden by q2).
	(rewrite):  Rewrrite value of LangExp.

	* kawa/standard/prim_method.java (exp2Type):  Remove method.
	(rewrite): Use Translator's exp2Type.
	* kawa/standard/define.java (rewrite):  Use Translator's exp2Type.
	* kawa/standard/let.java (rewrite):  Likewise.
	* kawa/standard/letrec.java (rewrite):  Likewise.
	* kawa/standard/module_extends.java (rewriteForm):  Likewise.
	* kawa/standard/module_implements.java (rewriteForm):  Likewise.
	* kawa/standard/try_catch.java (rewrite):  Likewise.

	* kawa/lang/Translator.java (exp2Type):  If unknown type return
	pointer_type rather than null.

2004-02-13  Per Bothner  <per@bothner.com>

	* gnu/kawa/Makefile.am (SUBDIRS):  Add q2.
	* configure.in:  Add gnu/q2/Makefile gnu/q2/lang/Makefile.

2004-01-09  Per Bothner  <bothner@bothner.com>

	* kawa/repl.java:  Use new Environment setGlobal method.
	* kawa/standard/Scheme.java (registerEnvironment):  Update setCurrent
	to setGlobal.

2003-12-24  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (importDefinitions):  Fix thinko -
	we were comparing the wrong type against typeProcedure.

2003-12-20  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (initKeyword):  New constant field.
	(instanceKeyword, classKeyword):  Removed constant fields.
	(matches):  New helper function.
	(rewriteClassDef):  Evaluate init-form: expression in outer scope.
	Alloc init: EXPR where EXPR is evaluated in class scope.
	Handle init forms for static fields.
	Allow alternative forms 'OPTION and "OPTION" for option names.
	Allow unnamed dummy fields with init: for initialization-type actions.

2003-12-20  Per Bothner  <per@bothner.com>

	* kawa/lang/SyntaxRule.java (translate_template):  Some constants
	have moved from Interpreter to LispInterpreter.  Update for that.
	* kawa/standard/Scheme.java (initScheme):  Likewise.

2003-11-25  Per Bothner  <per@bothner.com>

	* Makefile.in (install-javadoc-html):  Only delete html files.
	(Specifically, we don't want to delete CVS directories.)

2003-11-21  Per Bothner  <per@bothner.com>

	* kawa/standard/call_with_input_file.java:  Removed.
	* kawa/standard/call_with_output_file.java:  Removed.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/Scheme.java:  For call-with-input-file and
	call-with-output-file use new implementations in kawa.lib.ports.

2003-11-20  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Better error robustness.

2003-11-14  Per Bothner  <per@bothner.com>

	* kawa/standard/string_append.java:  Removed class.
	* kawa/standard/Makefile.am:  Update accordingly.

2003-11-09  Chris Dean  <Chris.Dean@sokitomi.com>

	* kawa/standard/Scheme.java (LispInterpreter): Definition for
	string-append/shared; redefine string-append.

2003-11-08  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Use new Interpreter.parse convention.

2003-11-05  Per Bothner  <per@bothner.com>

	* kawa/standard/define.java (rewriteForm):  Complain if not in <body>.

	* kawa/standard/define_variable.java (scanForDefinitions, rewriteForm):
	Fix various problems.
	* kawa/standard/Scheme.java (<init>):  Use define_syntax for
	'define-variable'.

2003-11-02  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Replace call to old 'parse' method
	by call to 'parse' with different parameter list.
	* kawa/lang/CompileFile.java (read):  Replace 'parseFile' call
	by call to new 'parse' method.
	* kawa/lang/Eval.java (evalBody):  Inline LispInterpreter.makeModuleExp
	here, so we can get rid of it.

2003-10-30  Per Bothner  <per@bothner.com>

	* configure.in:  Add link to gnu/xquery/testsuite/auction.xml.in.

2003-10-28  Per Bothner  <per@bothner.com>

	* Make-rules (DONT_EDIT_SUBS):  Move to gnu/xml/Makefile.am.

2003-10-21  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.7.90.
	* build.xml (version.release):  Set to 1.7.90.

2003-10-19  Per Bothner  <per@bothner.com>

	* kawa/lang/Eval.java (evalBody):  Need to pass Interpreter
	to new Translator.
	* kawa/lang/Translator.java (<init>):  Take Interpreter.
	Remove unused constructors.
	(resolve):  Moved to super class Compilation.

	* kawa/standard/module_compile_options.java:  New class extends Syntax.
	* kawa/standard/with_compile_options.java:  New class extends Syntax.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/Scheme.java:  Define '"module-compile-options'
	and 'with-compile-options'.

2003-10-18  Jim White  <jim@pagesmiths.com>

	* build.xml:  Handle gnu/kawa/models and gnu/kawa/swingviews.

2003-10-16  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadSyntax.java (load):  Give Syntax object a name.

	* kawa/repl.java (processArgs):  Try arguments in Compiletion.options.

2003-10-12  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair):  Check if decl's
	constant value is a Syntax rather than using IS_SYNTAX flag.

	* kawa/standard/Scheme.java (Scheme):  Update isEq initialization.

2003-10-09  Per Bothner  <per@bothner.com>

	* kawa/standard/read.java (apply1):  Use Procedure's getName
	method rather than the deprecated name.

2003-10-08  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Use define_field to
	define 'values-append', since it allows better optimization.

	* kawa/standard/require.java (scanForDefinitions):  Split most into
	new method importDefinitions - used for XQuery modules.
	(importDefinitions):  New static method.  Take module namespace.
	Note if decl is a procedure decl.

	* kawa/standard/Scheme.java (<init>):  Specify field for "ash".

	* kawa/lang/SetFieldProc.java:  Use Values.empty directly instead of
	via Interpreter.voidObject.

2003-10-02  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java, kawa/standard/load.java,
	kawa/standard/sleep.java:  Use Values.empty directly instead of
	Interpreter's voidObject field
	* kawa/repl.java, kawa/standard/string2number.java:  Use Boolean
	FALSE/TRUE directly instead of via Scheme or Interpreter field.

2003-09-23  Per Bothner  <per@bothner.com>

	* build.xml (build.selectjava):  Add FVector.java and LList.java.

2003-09-14  Per Bothner  <per@bothner.com>

	* configure.in (AC_LINK_FILES):  Add gnu/xquery/testsuite/outline.xml.

2003-09-08  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Resolve hygiene using
	getOriginalRef *before* resolving namespace prefix.
	Fixes Savannah bug #5113.

2003-09-03  Per Bothner  <per@bothner.com>

	* kawa/repl.java (processArgs): Set Compilation.defaultCallConvention.

2003-08-20  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Change definitions
	of positive? and modulo.
	* kawa/standard/modulo.java:  Remove - implemented in kawa.lib.numbers.
	* kawa/standard/positive_p.java:  Likewise.
	* kawa/standard/Makefile.am (java_sources):  Update accordingly.

	* kawa/standard/string2number.java (parse):  Pass new exactness
	parameter.

2003-08-06  Per Bothner  <per@bothner.com>

	* kawa/standard/TracedProcedure.java (indentation):  Initialize using
	Symbol.unInterned, matching 2003-03-15 gnu/mapping/Symbol.java change.

2003-08-03  Per Bothner  <per@bothner.com>

	* configure.in:  Add AC_LINK_FILES for report1.xml.in.

2003-08-01  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody):  Use new setCoercedReturnValue
	helper method in Convert.

2003-07-22  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Add Makefiles in gnu/kawa/models
	and gnu/kawa/swingviews.

2003-07-15  Chris Dean  <Chris.Dean@sokitomi.com>

	* kawa/standard/Scheme.java (initScheme): Add invoke-special.

2003-07-13  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Do followAliases
	when checking for a namespace-using name.

2003-07-10  Chris Dean  <Chris.Dean@sokitomi.com>

	* kawa/standard/syntax_rules.java (rewriteForm):  Allow Keywords among
	the literals

2003-06-14  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVADOC_PACKAGES):  Add gnu.kawa.sax, gnu.jemacs.swing.

	* kawa/lang/Eval.java (apply):  Use CallContext's getNextArg
	method rather than getArgAsObject, which will be deprecated. 

2003-06-06  Jim White  <jim@pagesmiths.com>

	* build.xml:  Add gnu/ecmascript.  Add gnu/jemacs/swing.
	Name change to XStrings.scm.
	Check for Servlet 2.3 API for enable-servlet (HttpServletResponse
	.resetBuffer and HttpServletRequest.getRequestURL are only since 2.3).
	Init of tmp directory moved so that clean will work ok. 

	* build.xml:  Make system.scm get compiled after vectors.scm.
	
2003-06-03  Per Bothner  <per@bothner.com>

	* Makefile.am (distall):  Add more stuff.

	* kawa/standard/IfFeature.java (scanForDefinitions):  Call scan_form
	on single form.  Fixes bug reported by Sven.Hartrumpf@FernUni-Hagen.de.

2003-06-01  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.7.
	* build.xml (version.release):  Set to 1.7.

	* kawa/standard/IfFeature.java (scanForDefinitions):  New method.

	* Makefile.am (dist-kawa-@VERSION@.jar):  Add --with-sax2 to configure.

2003-06-01  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Specify field name for
	vector-append.  Fixes bug reported by Sven.Hartrumpf@FernUni-Hagen.de.

2003-05-31  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (loadSource):  Don't call BaseUri.resolve
	if name is absolute.

2003-05-31  Vladimir Tsichevski  <wowa@jet.msk.su>

	* configure.in: Fix documentation typo AWT -> SAX2.

2003-05-31  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Use define_field instead of
	define_proc for define-procedure builtins for partial inlining.

2003-05-22  Per Bothner  <per@bothner.com>

	* kawa/lang/EqualPat.java (match):  Generalize 2003-04-21 fix
	to handle arbitrary String/Symbol pairs.  Fixes bugs reported
	05-19 by Sven Hartrumpf and 05-22 by Bruce Lewis.

	* kawa/standard/IfFeature.java (hasFeatureX):  Remove debug kludge.

	* kawa/standard/IfFeature.java (hasFeature):  Add new SRFIs.
	* kawa/standard/IfFeature.java (hasFeature):  Add 'kawa' feature.

	* kawa/standard/define.java (scanForDefinitions, rewriteForm):
	Handle names that are Symbols as well as Strings.  Fixes bug reported
	05-22 by Bruce Lewis "renamed identifiers in defines in macros" .

2003-05-18  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.7beta1.
	* build.xml (version.release):  Set to 1.7beta1.

	* Makefile.am (MAINTAINERCLEANFILES):  Add Version.java.

	* kawa/standard/letrec.java (rewrite):  Do setDefining on SetExp.

2003-05-17  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (setLineOf):  New method.
	(rewrite_with_position):  Use setLineOf.
	(rewrite_body):  Call pushPositionOf, popPositionOf.
	Call setLineOf on result.
	* kawa/kawa/Lambda.java (rewriteBody):  Don't allow a return type
	to be specified with just a string literal.
	If converting result, set line position of modified body.

2003-05-09  Per Bothner  <per@bothner.com>

	* configure.in:  Remove --with-java-collections arg and related crud.
	* build.xml (build.preprocessed):  Remove gnu/lists and QName.
	Remove no-longer-needed will-collections crud.
	* build.properties:  Remove with-collections.

	* build.xml (build.selectjava):  Add new gnu/lists classes.

2003-05-04  Per Bothner  <per@bothner.com>

	* build.xml (build.selectjava):  Add ListItems.java and
	IteratorItems.java.
	(build.preprocessed):  Remove CallContext.java and Focus.java.

	* Makefile.am (java1-java2-files):  New rule.

2003-05-03  Per Bothner  <per@bothner.com>

	* build.xml:  Remove no-longer needed support for "references".
	* build.properties:  Likewise.
	* Make-rules:  Remove WITH_JAVA_REFERENCES conditionals.
	* configure.in:  Drop --without-java-references argument.

2003-04-29  Jim White  <jim@pagesmiths.com>

	* build.xml:  Support for JAVA1 <-> JAVA2 source conversion.
	(select-java1, select-java2, check-for-java2, select-java1-auto,
	select-java2-auto, select-java-auto):  New targets.

2003-04-30  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Intern name before lookup.

2003-04-25  Per Bothner  <per@bothner.com>

	* Makefile.am (select-java1, select-java2):  New rules to convert
	basebase to Java1-compliant and back again.

2003-04-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (getOriginalRef):  New method.
	(matches, getBinding, rewrite):  Use getOriginalRef.

	* kawa/lang/EqualPat.java (match):  Add a kludge to for '::'.
	Fixes bug reported 04-11 by Vladimir Tsichevski <wowa@jet.msk.su>.

	* kawa/lang/SyntaxRules.java (<init>):  Better debugging output.

	* kawa/lang/AutoloadProcedure.java:  Call Procedure's getName
	method instead of deprecated name method.
	* kawa/lang/CompileFile.java:  Likewise.
	* kawa/standard/TracedProcedure.java:  Likewise.
	* kawa/standard/cxr.java:  Likewise.
	* kawa/standard/readchar.java:  Likewise.

2003-04-19  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (lexical):  Now in Compilation.
	(<init>):  Update accordingly.
	(push(ScopeExp), pop(ScopeExp), push(Declaration)):  Subsumed
	by version in Compilation.
	(pop(Declaration)):  Removed - never used.
	
2003-04-18  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadSyntax.java (toString):  New method.
	(print):  Use toString.

	* kawa/lang/Translator.java (environ):  Remove field.
	(lexical):  Replacement field.
	(<init>):  Allocate lexical instead of environ.
	(lookup, getBinding, rewrite):  Update.
	(matches):  Update for new hygiene handling.
	(rewrite_body):  Combine overloaded methods into one.
	Inline the effect of push - but don't push decls twice.
	(shadowStack):  Remove field.
	(pushDeclStart, popDecls, pushDecls, popBinding):  Removed methods.
	(finishModule, push, pop):  Update accordingly.
	* kawa/standard/Scheme.java (getNamespaceOf):  New method.
	* kawa/standard/set_b.java (rewrite):  Update to use new NameLookup.
	* kawa/lang/SyntaxRules.java (expand):  Likewise.

2003-04-14  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (capturedDeclarations):  Change type.
	(captureDecls):  Allocate capturedDeclarations as Declaration array.
	* kawa/lang/SyntaxRules.java (<init>):  Update accordingly.
	(expand):  Create an aliad Declaration, and push that in the
	Translator lexical scope, instead of the original symbol.
	* kawa/lang/Translator.java (matches):  Update accordingly.
	(resolve):  Allow first parameter to be a String.
	(getBinding, rewrite):  Update and  re-organize.
	(pushBinding):  Remove and inline into push(Declaration).
	(popBinding):  Make private.

	* kawa/standard/define_alias.java (scanForDefinitions):  Use
	Translator's push method instead of pushBinding.
	* kawa/standard/define_syntax.java (scanForDefinitions):   Likewise.
	* kawa/standard/define_unit.java (scanForDefinitions):
	Remove call to pushBinding.  Call push on decl instead.

2003-04-12  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (finishModule):  Remove unused variables.
	
	* kawa/standard/define.java (scanForDefinitions):  Set PROCEDURE
	flag of Declaration.
	* kawa/standard/object.java (rewriteClassDef):  Set FIELD_OR_METHOD
	or PROCEDURE flags of Declaration as appropriate.
	* kawa/lang/Translator.java (rewrite):  Complain if variable
	reference to a class method.

	* kawa/standard/define.java (scanForDefinitions):  Use Translator's
	push method instead of pushBinding.
	* kawa/standard/require.java (scanForDefinitions):  Likewise.

	* kawa/repl.java (apply0, apply1, checkInitFile):  Don't use
	static fields from kawa.standard.Scheme.

	* kawa/repl.java (SocketRepl class):  Make public and rename to ...
	* kawa/TelnetRepl.java:  ... new class based on old SocketRepl.
	(serve):  New static method based on old kawa.serveTelnet method.
	* kawa/repl.java (serveTelnet):  Removed method.
	(processArgs)  Update to call TelnetRepl.serve.
	* kawa/Makefile.am (java_sources):  Add TelnetRepl.java.

2003-04-06  Per Bothner  <per@bothner.com>

	* kawa/lang/EqualPat.java (print):  Don't use SFormat.
	* kawa/lang/ListRepeatPat.java (print, match):  Likewise.
	* kawa/lang/PairPat.java (print):  Likewise.
	* kawa/lang/SyntaxRules.java (expand):  Likewise.

2003-04-04  Per Bothner  <per@bothner.com>

	* kawa/standard/define_class.java (scanForDefinitions):  Use getDefine.

2003-04-01  Per Bothner  <per@bothner.com>

	* kawa/standard/set_b.java (rewrite):  Handle Symbol assignee.
	Based on patch from Vladimir Tsichevski <wowa@jet.msk.su>.

2003-03-29  Jim White  <jim@pagesmiths.com>

	* build.xml:  Various fixes.

2003-03-24  Chris Dean  <ctdean@mercedsystems.com>

	* kawa/standard/load.java (loadRlative):  Fix typo to loadRelative.

2003-03-24  Per Bothner  <per@bothner.com>

	* kawa/standard/object.java (rewriteClassDef):  Allow names to be
	Symbol as well as String.
	* kawa/standard/define_class.java (scanForDefinitions):  Likewise.
	(rewriteForm):  Likewise.

	* kawa/lang/Translator.java (getBinding):  Follow aliases.
	Needed if Syntax is imported from some other module.

2003-03-21  Per Bothner  <per@bothner.com>

	* configure.in:  Set am__fastdepGCJ_TRUE in non-gcj case.
	Remove kawa_bin variable.
	* configure:  Re-generate using auoconf 2.57.
	* aclocal.m4:  Re-generate using aclocal 1.7.3.
	* */Makefile.in:  Re-generate using automake 1.7.3.

2003-03-06  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.7beta1.
	* build.xml (version.release):  Set to 1.7beta1.

2003-03-03  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java (relative):  New boolean field.
	(<init>):  Add constructor.
	(load, loadRelative):  New static fields.
	(loadSource, apply):  Take boolean parameter.
	(loadSource):  Handle URLs.  Resolve usng baseUri or baseUriDefault.
	(apply1, apply2):  Pass relative flag.
	(apply):  Set/restore base URI.
	* kawa/standard/Scheme.java:  Add load-relative and base-uri.
	* kawa/Shell.java (runFile):  Update for extra load.apply parameter.

2003-03-02  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (runFile):  Use Environment.getCurrent instead of
	Environment.user, which should probably be deprecated.

2003-01-29  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java:  Recognize 'gui package.

2003-01-26  Per Bothner  <per@bothner.com>

	* kawa/lang/Record.java (getField):  New static helper method.
	(get, set1):  Use it.
	Fixes bug reported 1/24 by Wen-Chun Ni <wcn@tbcommerce.com>.

	* kawa/lang/Record.java (makeRecordType):  Twice use Method's startCode
	method instead of deprecated init_param_slots.

2003-01-24  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java:  Define cut and cute.

	* kawa/lang/Lambda.java (rewrite):  Don't convert rest parameter
	to String if it is a Symbol.

	* kawa/lang/SyntaxRule.java (print_template_program):  Update
	commented-out debug helper routine.
	* kawa/lang/SyntaxRules.java (<init>):  Update call in debug code.

2003-01-03  Per Bothner  <per@bothner.com>

	* libtool.m4, ltmain.sh:  Copied from libtool (pre-1.5 CVS) version.
	* ltmain.sh:  Add definition of SED.
	* Make-rules (.o rule):  Remove --tag=GCJ - not needed by new libtool.
	* aclocal.m4:  Re-generated using aclocal 1.6.3.
	* configure:  Re-generate using autoconf 2.53.
	* **/Makefile.in:  Re-generate using automake 1.6.3.
	
	* config.guess, config.sub:  Update from ftp.gnu.org.

2003-01-02  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Use 3-operand form of
	define_field for unescaped-data.

2003-01-01  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Use 3-operand form of
	define_field if and only if field is in class written in Java.

2002-12-11  Per Bothner  <per@bothner.com>

	* kawa/standard/define_syntax.java (scanForDefinitions, rewriteForm):
	Handle Symbols as macro names - needed for Common Lisp.
	* kawa/standard/syntax_case.java (rewriteClauses):  Allow
	pattern names to be Objects - i.e. Symbols as well as Strings.
	(rewriteForm):  Lkewise allow literal identifiers to be Symbols.
	(class syntax_case_work):  Likewise - change field type to Object[].
	* kawa/lang/Syntax.java (name):  Change field from String to Object.
	(getName):  Change to handle either Symbol or String in name.
	(getSymbol, setname):  New methods.
	(<init>):  Change paramater type to Object, to allow Symbol.
	* kawa/lang/Macro.java (make):  Allow name to be Symbol or String.
	(<init>):  Likewise.
	* kawa/lang/SyntaxRules.java (translate_pattern):  Don't convert
	Symbol to String - instead use as is.  Needed for Common Lisp.

2002-11-23  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (define_field):  Moved to Interpreter.
	* kawa/standard/StaticFieldConstraint.java:  Moved to gnu.kawa.reflect.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/lang/Translator.java:  Explicitly import StaticFieldConstraint.

	* configure.in:  Make --with-collections the default.

002-11-20  Per Bothner  <bothner@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Turn an identifier with a
	colon and matching namespace into a Symbol.

2002-11-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Promise.java (print):  Don't try to print forced value,
	as this could cause a loop.

	* kawa/lang/Lambda.java (rewrite):  Parameter name can be Symbol.
	* kawa/lang/SyntaxRules.java (literal_identifiers):  Can now be Symbol.
	(<init>, translate_pattern, readExternal):  Update accordingly.
	(translate_pattern):  Handle Symbols.
	(expand):  Renamed hygiene names now use uninterned Symbol, instead of
	uninterned String, since Hashtable doesn't distinguish latter.
	* kawa/lang/Translator.java (environ):  Change type to Hashtable,
	because keys can now be Symbols, not just Strings.
	(<init>):  Change to match.
	(matches, getBinding, rewrite_pair, rewrite):  Re-write to handle
	new types for hygiene.
	(lookup(Object)):  Removed.
	(lookup, lookupGlobals, getBinding. push, pushBinding):
	Names can be either Symbols or Strings.
	(shadowStack):  No longer public.

2002-11-15  Per Bothner  <per@bothner.com>

	* kawa/standard/define_class.java:  Don't hardwire "define-class" name.

	* kawa/standard/define_autoload.java:  Handle Symbol using getName.
	* kawa/standard/let.java (rewrite):  Use name as is, without toString.
	* kawa/standard/try_catch.java (rewrite):  Likewise, allow Symbol.
	* kawa/standard/fluid_let.java (rewrite):  Likewise.
	* kawa/standard/letrec.java (rewrite):  Likewise.	
	Use Translation's matches method.

2002-11-05  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (read):  Call parseFile with new
	'immediate' argument set to false.

2002-10-28  Per Bothner  <bothner@bothner.com>

	Rename the Binding and BindingEnumerator classes in gnu.mapping
	to Symbol and SymbolEnumerator, respectively.
	
2002-10-28  Per Bothner  <per@bothner.com>

	The classes gnu.expr.Symbol and gnu.commonlisp.lang.Symbol were
	renamed to gnu.expr.Symbols and gnu.commonlisp.lang.Symbols.

2002-10-22  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Print file and line on IOException.
	If !interactive and caught unresumable exception, return.

2002-10-21  Per Bothner  <per@bothner.com>

	* kawa/MessageArea.java (doFocus):  Remove field - always true.
	(<init>):  Don't set focus.
	(isFocusTraversable):  Remove - now equivalent to super method.
	* kawa/GuiConsole.java (<init>):   Change new MessageArea to match.

2002-10-14  Francisco Vides Fernández <pvides@dedalo.ws>

	* kawa/GuiConsole.java (<init>):  Pass true for focus argument
	in Message constructor.

2002-10-20  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (scanForDefinitions):  Change to create
	an alias declaration as well as the imported field.  This is needed
	if the imported decl is re-exported or used in an exported macro.
	* kawa/standard/define_syntax.java (scanForDefinitions):  Set type.
	* kawa/lang/Translator.java (rewrite_pair):  Follow aliases
	before checking for macro.

	* kawa/lang/Macro.java (copying <init>):  Copy name as well.

	* kawa/standard/define_alias.java (rewrite):  Simplify.

2002-10-17  Per Bothner  <per@bothner.com>

	* kawa/standard/location.java (rewriteArg):  Removed.  No longer
	needed now that Translator.rewrite doesn't create PrimProcedures.
	(rewrite):  Replace rewriteArg cal by call to Translator.rewrite.
	* kawa/standard/define_alias.java (rewrite):  Likewise.

2002-09-28  Jim White  <jim@pagesmiths.com>

	* build.xml: Compile .scm files for xml-classes.
	Remove unneeded workaround in servlet-classes.

2002-09-27  Per Bothner  <per@bothner.com>

 	* kawa/lang/Translator.java (rewrite):  Only map Procedure to
	
2002-09-27  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Only map Procedure to
	field Declaration if Compilation.inlineOk.

2002-09-26  Per Bothner  <per@bothner.com>

	* kawa/standard/ScmEnv.java (get):  Follow aliases.
	* kawa/standard/require.java (scanForDefinitions):  Recognize aliases,
	as indicated by the type gnu.mapping.Location.

	* kawa/standard/map.java (applyN):  Handle for-each properly
	when arity is 1.

2002-09-24  Per Bothner  <per@bothner.com>

	* kawa/standard/define.java (scanForDefinitions):  If inlineOk is false,
	mark declaration as writeable, even if functional definition.
	* kawa/repl.java (processArgs):  Set compile.inlineOk to false
	if --no-inline or --inline=none is specified.

	* kawa/repl.java (printOptions):  Also mention --output-format.

	* kawa/repl.java (processArgs):  Update copyright year printed by --version.

2002-09-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewrite, rewriteBody):  Use 'matches'
	method of Translator to match against '::'.

	* kawa/standard/Scheme.java (initScheme):  Add define-record-type.

2002-08-22  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (expander):  Change type to Object.
	(getExpander):  Remove unused method.
	(expand):  Handle expander as evaluated Procedure, or
	an re-written S-expression.  If latter, re-write it.
	* kawa/standard/define_syntax.java (scanForDefinitions):  Set expander.
	(rewrite):  Re-write expander if it has been re-written yet.

2002-08-16  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  Always look for known
	functions, even if immediate.

2002-08-10  Jim White  <jim@pagesmiths.com>

	* build.xml:  Patch to compile HTTP.scm.

2002-08-04  Per Bothner  <per@bothner.com>

	* kawa/standard/{string_ci_equal_p.java, string_ci_greaterequal_p.java,
	string_ci_greaterthan_p.java, string_ci_lessequal_p.java,
	string_ci_lessthan_p.java, string_greaterequal_p.java,
	string_greaterthan_p.java, string_lessequal_p.java,
	string_lessthan_p.java}:  Removed - noew use kawa.lib.strings.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/vector_append.java (vectorAppend):  New static field.
	(<init>):  New constructor
	* kawa/standard/Scheme.java (initScheme):  Update accordingly.

2002-08-02  Per Bothner  <per@bothner.com>

	* kawa/standard/expt.java (expt):  New static methods.
	(expt)  New static final field.
	* kawa/standard/Scheme.java (initScheme):  Use define_field for "expt".

2002-07-29  Per Bothner  <per@bothner.com>

	* kawa/standard/prim_throw.java (primitiveThrow):  New static field.
	* kawa/standard/Scheme.java (initScheme):  Define "primitive-throw"
	using define_field, so it can be inlined.

2002-07-28  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (getNamedType):  Define <never-returns>.

2002-07-25  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair):  Remove some optimizations,
	and argument count checking.  They are now done in InlineCalls.

2002-07-24  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Update for gnu.expr changes.
	* kawa/standard/load.java (loadSource):  Likewise.
	* kawa/lang/CompileFile.java:  Likewise.
	(read):  Return Compilation instead of ModuleExp.
	(compile_to_file):  Catch compile-time exceptions.
	* kawa/lang/Eval.java (evalBody):  Updates.
	* kawa/lang/Translator.java:  Update Parser -> Compilation.
	Replace current_line etc by Compilation's getLine etc methods.
	(module, getModule):  Now in Compilation.
	* kawa/standard/Scheme.java (makeModuleExp):  Moved to LispInterpreter.

	* kawa/lang/Translator.java (matches):  New method.
	* kawa/standard/define.java (rewriteForm):  Use new matches method.
	* kawa/standard/let.java (write):  Likewise.

2002-07-21  Per Bothner  <per@bothner.com>

	* kawa/standard/map.java (inline):  Take extra ExpWalker parameter.

	* kawa/lang/Translator.java (rewrite_pair):  Check for dotted list.

2002-07-02  Per Bothner  <per@bothner.com>

	* kawa/standard/string_append.java (stringAppend$V):  Remove
	needless toString - which also make it null-safe.

	* kawa/standard/ScmEnv.java:  Remove unneeded (and harmful) import.

2002-06-26  Per Bothner  <per@bothner.com>

	* build.xml:  Update XMLParser.java -> XMLParserChar.java.
	
	* build.xml (lib-scm-2nd):  Add arrays.scm.
	(slib-scm):  Add srfi1.scm.

2002-06-13  Per Bothner  <per@bothner.com>

	* build.xml (java-classes):  Add gnu/kawa/util/.  Reported by
	Mirko.Luedde@Computer.Org.

2002-06-12  James P. White  <jim@pagesmiths.com>

	* build.xml (java-classes):  Add gnu/kawa/xml and gnu/xml/.

2002-06-12  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.99.
	* build.xml (version.release):  Set to 1.6.99.

	* Makefile.am (JAVADOC_PACKAGES):  Add gnu.kawa.xslt.

2002-06-11  Per Bothner  <per@bothner.com>

	* configure.in (--with-sax2):  New flag.
	(AC_OUTPUT):  Craete gnu/kawa/xslt/Makefile and gnu/kawa/sax/Makefile.
	* build.xml:  Support with-xax2 option.
	* build.properties:  Document with-ax2 flag.
	Build gnu/kawa/xslt/ and gnu/kawa/sax/ if appropriate.

	* kawa/repl.java (commandLineArgArray):  New variable.
	(setArgs):  Set commandLineArgArray.

	* build.xml: Generate Focus.java from gnu/kawa/xml/Focus.java.in.

2002-06-10  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java:  Define srfi-25 array functions.

2002-06-02  Per Bothner  <per@bothner.com>

	* kawa/standard/define_alias.java (scanForDefinitions):
	Call Translator's  pushBinding to make alias compiler-visible.

2002-05-29  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa-@VERSION@.jar):  Change rule so we hopefully don't
	pick up extreanous .class files.

2002-05-28  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (capturedIdentifiers, capturedFields
	templateIdentifiers, capturedDeclarations):  New fields.
	(make):  New static methods.
	(captureDecls, getUsedFieldsList):  New methods.
	* kawa/lang/SyntaxRule.java (template_identifiers, captured_decls):
	Removed fields.  Instead use capturedIdentifiers and
	capturedDeclarations from current Macro.
	(<init>):  Capture decls in SyntaxRules.<init>, not here.
	(execute)_template):  Removed.  Munging of tr.environ is now
	done in SyntaxRules.expand.
	* kawa/lang/SyntaxRules.java (calculate_maxVars, <init>):
	Take extra length parameter.
	(<init>):  Get capturedIdentifiers from current Macro, and set them.
	(expand):  Munge tr's environ to use macro-definition-time decls.
	* kawa/lang/Translator.java (currentMacroDefinition):  New field.
	(lookup. lookupGLobal):  New methods.
	(finishModule):  Only error if NOT_DEFINING and not IS_UNKNOWN.
	(pushDeclsStart):  New method.
	(popDecls):  Now takes no arguments.
	* kawa/standard/define_syntax.java:  Use new Macro.make method.
	Set/restore tr.currentMacroDefinition
	* kawa/standard/let_syntax.java:  Likewise.
	* kawa/standard/require.java (scanForDefinitions):  If the loaded value
	is a Macro, at end call its captureDecls method.

	* kawa/lang/AutoloadSyntax.java (rewriteForm):  Set currentSyntax.

2002-04-18  Per Bothner  <per@bothner.com>

	* kawa.repl (exitCounter):  New static field.
	(exitIncrement, exitDecrement):  New static methods.
	(main):  Call exitDecrement.
	* kawa/GuiConsole.java (numConsoles):  Removed static field.
	(<init>):  Call repl's exitIncrement instead of upping numConsoles.
	(close):  Instead of incrementing/testing numConsoles,
	call repl's exitDecrement.
	* kawa.repl (windowStarted):  Removed field.
	(processArgs):  Don't set windowStarted.
	(main):  Don't test windowStarted - I don't think it makes sense.
	
	* kawa/lang/Record.java (makeRecordType):  No longer need to
	catch java.io.IOException, since writeToArray now takes care of it.

2002-03-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewrite):  Check for mis-placed '::'.

	* kawa/standard/IfFeature.java:  New class, extends Syntax.
	* kawa/standard/Makefile.am (java_sources):  Add IfFeature.java.
	* kawa/standard/Scheme.java:  Standard procedures memq, memv, member,
	assq, assv, and assoc are now defined in kawa.lib.syntax.
	* kawa/standard/require.java:  Recognuze 'srfi-1 and 'list-lib.

2002-03-19  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Add gnu/jemacs/swing/Makefile.

2002-03-07  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair):  Use get, with a default,
	in case there is an existing Binding, but it is unbound.

	* configure.in (pathset, filesep):  New substitutions.
	* Make-rules (CLASSPATH_ENV): Use pathsep and filesep.

	* configure.in:  Add links for 3 gnu/xquery/testsuite xml data files.

2002-03-02  Per Bothner  <per@bothner.com>

	* .../*/Makefile.am, Makefile.in:  Updated to autmake-1.5d.
	Since SOURCES now gets over-written, move source list to EXTRA_DIST.
	Use automake include instead of autoconf substitution.
	Remove AUTOMAKE_OPTIONS, except in doc.
	Various related tweaks.
	* AUTHORS, INSTALL, depcomp:  New files, required by automake now
	that AUTOMAKE_OPTIONS is no longer foreign.
	* Make-rules:  Various updates, now that we use autoamke inclusion.
	(SED_REFERENCES_SUBS):  Moved from 3 three other Makefile.am's.
	* configure.in:  Various fixes/tweaks.

	* libtool.m4, ltmain.sh:  Updated to cvs libtool.
	* libtool.m4:  Don't add -DPIC compile flag if tag is GCJ.
	(ac_compile. ac_link):  Add definitions.
	* ltcf-c.sh, ltcf-cxx.sh, ltcf-gcj.sh, ltconfig:  Removed.

	* kawa/lang/CompileFile.java (read):  Add throws specifications since
	Interpreter's parseFile.has them.
	(compile_to_files):  Add catches.

	* kawa/standard/Scheme.java (eval):  Removed - now in Intrepreter.

	* kawa/standard/require.java (<clinit>):  HTTP is now in slib package.

2002-02-20  Per Bothner  <per@bothner.com>

	* config.sub, config.guess:  Updated from master versions.

2002-02-16  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.98.
	* build.xml:  Likewise.

	* build.xml:  Handle filtering of CallContext.java.in.  Build gnu/brl.

	* Makefile.am (+kawa-doc.tar.gz):  New rule.

2002-02-13  Per Bothner  <per@bothner.com>

	* Make-rules (scm-classes.stamp):  Use SCM_COMPILE_FLAGS.

	* kawa/lang/Translator.java (makeBody):  Take extra ScopeExp arg.
	If argument is a ModuleExp, wrap in append-values.

	* kawa/lang/Translator.java (lookup, resolve):  New methods.
	(getBinding, rewrite):  Using new methods reduces code duplication. 

	* kawa/repl.java:  Remove calls to CallContext.setMainContext.

	* Make-rules (DONT_EDIT_SUBS):  Moved from gnu/xml/Makefile.am.

2002-02-12  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main, getInterpreterFromFilenameExtension,
	getInterpreter):  Call CallContext.setMainContext.
	* kawa/Shell.java (run):  Call CallContext.getInstance.
	* kawa/standard/TracedProcedure.java (applyN):  Likewise.
	* kawa/standard/load.java (loadSource):  Likewise.
	* kawa/lang/Eval.java (evalBody, eval):  Call CallContext.getInstance.
	Set/restore CallContext's consumer.
	
	* kawa/standard/load.java (loadClassFile):  Explicitly check
	for Runable rather than just cast to ModuleBody.

2002-02-11  Per Bothner  <per@bothner.com>

	* configure.in:  Link testsuite/scribble.html.in to scribble.html.

2002-02-05  Per Bothner  <per@bothner.com>

	* configure.in: Add links to two more xml data-sets for xml tests.

2002-01-31  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  No longer define
	response-header - the programmer must first (require 'http) now.

2002-01-29  Per Bothner  <per@bothner.com>

	* read.java:  Since apply1 can now throw Throwable, don't need to
	wrap exception.  However, so call SyntaxException's new setHeader.
	Don't call ScmRead's statuc readObject, which creates a new ScmRead.

	* configure.in:  Also make link to gnu/xquery/testsuite/bib.xml.in.

	* gnu/brl:  New package - code imported from BRL.
	* configure.in (AC_OUTPUT):  Also generate gnu/brl/Makefile.

	* kawa/repl.java (getInterpreterFromFilenameExtension):  New static.
	(processArgs, main):  Use filename extension to select language.

	* kawa/standard/reequire:  Handle (require 'http).

	* kawa/standard/reequire (scanForDefinitions):  Coerce find call
	to void if we're not actually using it (to prevent it being
	printed when we're compiling with implicit values-append).

2002-01-23  Per Bothner  <per@bothner.com>

	* build.xml:  Add enable-xml flag, to build xml-related classes.
	* build.properties:  Add/document enable-xml.

	* configure.in (AC_OUTPUT):  Also make gnu/kawa/brl/Makefile.

	* kawa/Shell.java (run):  Call Lexer's setInteractive if TtyInPort.

	* kawa/standard/Scheme.java (initScheme):  Define values-append.
	Fix definition of unescaped-data.

	* kawa/lang/Translator.java (makeBody):  New method.
	(rewrite_body, finishModule):  Use makeBody.

2002-01-21  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java:  Also define 'unescaped-data'.

	* acinclude.m4:  New check-in.

2002-01-19  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (apply2):  Don't catch and re-throw.

2002-01-13  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Define response-header.
	* kawa/Shell.java (format):  New static table.
	(setDefaultFormat, getOutputConsumer):  New static methods.
	(run):  New overload taking an output Consumer instead of an OutPort.
	* kawa/repl.java (processArgs):  New method.
	New code to handle "\\" and "--output-format" or "--format".
	(main):  Use processArgs.
	* kawa/standard/load.java (loadSource):  Use getOutputConsumer.
	Wrap body in a beginDocument/endDocument pair.

2002-01-07  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (compile_to_files): Do mangleNameIfNeeded.

2001-12-24  James P. White  <jim@pagesmiths.com>

	* kawa/repl.java (main):  Need to increment iArg on -w.

2001-12-24  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite_pair):  Don't crash if we
	get a Procedure with a null name.

2001-11-27  Per Bothner  <per@bothner.com>

	* Makefile.am (JAVADOC_PACKAGES):  Add new packages.
	Add coment docuemnting javadoc procedure.

	* Makefile.am (dist-kawa-@VERSION@.jar):  Add configure options.
	(kawa-@VERSION@-src.zip, kawa-src.zip):  New rules.

2001-11-26  Per Bothner  <per@bothner.com>

	* build.xml (build.dir):  Change to basedir.
	(echo):  Also output dist.kawa.jar.  Avoids tabs.

2001-11-24  Per Bothner  <per@bothner.com>

	* build.xml, build.properties:  Update from Jim White.

	* Makefile.am:  Add more directories (conditionally) to JAR_DEPS.

	* kawa/standard/convert.java:  Moved to gnu.kawa.functions.Convert.
	* kawa/standard/Makefile.am:  Update accordingly
	* kawa/standard/Scheme.java (initScheme):  Likewise.

	* kawa/standard/Scheme.java (getTypeFor):  Map "java.lang.String"
	to Type.tostring_type, for convenience.

	* kawa/standard/{define_variable.java,let.java,let_syntax.java,
	letrec.java,load.java,module_name.java,require.java}:  Use 'name'
	rather than `name' in messages.
	
	* kawa/standard/map.java:  The makeGetField helper methods was moved
	from Expression to SlotGet.
	* kawa/lang/Lambda.java: makeCoercion moved from Expression to Convert.

2001-11-23  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewriteBody):  Call setReturnType.

	* kawa/lang/AutoloadSyntax.java, kawa/lang/Lambda.java,
	kawa/lang/Macro.java:  Change errors message to use 'name' not `name'.

2001-11-19  Per Bothner  <per@bothner.com>

	* kawa/standard/call_with_values.java (apply):  Use CallContext's
	getArgs method.  Fixes testsuite regression.

2001-11-18  Per Bothner  <per@bothner.com>

	Add support building Kawa using Ant, contributed by Jim White
	with some hacking by yours truly.
	* build.xml:  New file, with build rules for Ant,
	* build.properties:  New file, with comment-out settable properties.
	* Makefile.am (EXTRA_DIST):  Add build.xml and build.properties.
	* configure.in (AC_OUTPUT):  Also make gnu/kawa/ant/Makefile.

2001-11-18  Per Bothner  <per@bothner.com>

	* kawa/standard/define_namespace.java:  Moved to gnu/kawa/xml and
	renamed to DefineNamespace.java.
	* kawa/standard/Makefile,am, kawa/standard/Scheme.java: Update.

2001-11-12  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (initScheme):  Define current-error-port.

	* kawa/standard/define_namespace.java (scanForDefinitions):
	Use NamespaceEnv.NAMESPACE_PREFIX

2001-11-05  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (getNamedType):  The type <String>
	is now Type.tostring_type rather than Type.string_type.

	* kawa/standard/Scheme.java (initScheme):  Define let-values
	and let*-values.  [srfi-11]

2001-11-01  Per Bothner  <per@bothner.com>

	* kawa/standard/define_namespace.java:  New class; extends Syntax.
	* kawa/standard/Makefile.am (java_sources0:  Added define_nameapace..
	* kawa/standard/Scheme.java (initScheme):  Define define-namespace.

2001-10-20  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Use CallContext's runUntilDone, not run.
	(run, runFile):  Catch Throwable, not Exception.
	* kawa/lang/AutoloadProcedure.java, kawa/lang/Eval.java,
	kawa/standard/callcc.java, kawa/standard/TracedProcedure.java,
	kawa/standard/call_with_values.java, kawa/standard/map.java,
	kawa/standard/force.java, kawa/standard/call_with_output_string.java,
	kawa/standard/prim_throw.java, kawa/standard/throw_name.java,
	(apply* methods, eval* methods):  Now specify throws Throwable.
	* kawa/lang/Promise.java (force):  Likewise.
	* kawa/standard/{call_with_input_file.java, call_with_output_file.java,
	with_input_from_file.java, with_output_to_file.java,load.java):
	Likewise.  No longer need to catch exceptions.
	* kawa/standard/prim_throw.java (throw_it):  Specify throws Throwable.
	No longer need to wrap checked exceptions.
	* kawa/lang/Macro.java:  Catch Throwable, not Exception.
	* kawa/standard/constant_fold.java:  Likewise.
	* kawa/standard/Scheme.java (eval):  Catch and wrap Throwable.

	* kawa/lang/Record.java (get):  Take extra defaultValue parameter.
	* kawa/standard/ScmEnv.java (likewise):
	(addExtra):  New hook to add extra Environments to search.
	* kawa/standard/Scheme.java (<init>):  Use getNewEnvironment.
	(getNewEnvironment):   Use reflection to add NamespaceEnv.

2001-10-17  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Add gnu/kawa/xml/Makefile.
	* kawa/standard/Scheme.java:  Declare "attributes" procedure.
	* kawa/standard/ScmEnv.java (getChecked):  Look for "ns-alias:name".

2001-10-16  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.97.

	* configure.in (--without-java-references):  New flag.
	(WITH_JAVA_REFERENCES)  New automake conditional.

2001-10-11  Per Bothner  <per@bothner.com>

	* config.guess:  Import new version.

	* configure.in:  Set version to 1.6.96.

	* confgure.in:  New --enable-servlet flag.
	(ENABLE_SERVLET):  New automake conditional.
	(AC_OUTPUT):  Add gnu/kawa/servlet/Makefile.
	* gnu/kawa/Makefile.am (SUBDIRS):  Add servlet if ENABLE_SERVLET.
	* kawa.repl:  Handle --servlet option.
	
2001-10-05  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (getNamedType):  Update "abstract-string"
	for CharSequence -> CharSeq renaming.

2001-09-24  Per Bothner  <per@bothner.com>

	* kawa/standard/NumberCompare.java:  Moved to gnu.kawa.functions.
	* kawa/standard/divide_oper.java:  Ditto; renamed to DivideOp.
	* kawa/standard/multiply_oper.java:  Ditto; renamed to MultiplyOp.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/Scheme.java:  Likewise.

2001-09-21  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadProcedure.java (load):  If getFunction
	raises an UnboundSumbol, catch that silently.

	* kawa/standard/define.java (scanForDefinition):  For define-private,
	set PRIVATE_SPECIFIED explicitly in addition to default PRIVATE flag.
	* kawa/lang/Translator.java (finishModule):  Only complain about
	export and private mismatch if PRIVATE_SPECIFIED.

	* kawa/standard/require.java (scanForDefinition):  Look for instance
	declaration in current Environment.
	Make the instance declaration readable, so it won't becomes 'ignored'.
	Use getDefineto define imported fields..

2001-09-20  Per Bothner  <per@bothner.com>

	Add support for --help, based on a patch from
	Andreas Schlapbach  <schlpbch@kde.org>.
	* kawa/kawa.repl (printOptions):  New method.
	(main, bad_option):  Use printOptions.

2001-09-13  Per Bothner  <per@bothner.com>

	* configure.in:  Fix typo in help text for --with-gcj.
	Create tab.xml using AC_LINK_FILES rather than AC_OUTPUT.

	* kawa/standard/define.java (scanForDefinitions):  Remove test for
	usingTailCalls.

2001-08-30  Per Bothner  <per@bothner.com>

	* kawa/lang/Record.java (makeRecordType):  Use mangleIfNeeded.

2001-08-24  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (pushPositionOf, popPositionOf):
	New methods to make it easier to save and restore line numbers etc.
	(rewrite_with_position):  Use new methods.
	(exp2Type):  New method
	* kawa/lang/Lambda.java (rewrite):  Use new method.
	* kawa/standard/object.java (rewriteClassDef):  Likwise.

	* kawa/standard/thisRef.java:  New class, extends Syntax.
	* kawa/standard/Makefile.am (java_sources):  Add thisRef.java.
	* kawa/standard/Scheme.java (initScheme):  Change define for "this".

2001-08-23  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Add gnu/xquery/testsuite/tab.xml.
	
	* kawa/standard/object.java (rewriteClassDef):  New implementation to
	handle CLOS-style keyword-options arguments.
	* kawa/standard/require.java (scanForDefinitions):  Map implementation
	type to source type when setting type of declaration.

2001-08-17  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  Don't getInterpreter on --connect.
	Wait until processing other arguments.
	
	* kawa/standard/Scheme.java (demangleName):  Moved two methods
	to gnu/expr/Compilation.java.

	* kawa/standard/Scheme.java (initScheme):  Define define-class,
	define-simple-class. map-values, and children.
	* kawa/standard/define_class.java:  New working implementation.
	* kawa/standard/load.java (loadSource):  If getMainPrintValues(),
	then expression values are printed to standard output.
	* kawa/Shell.java (run):  Clear list of errors after SyntaxException.
	(runString):  If ModuleBody.getMainPrintValues(), print to outDefault.
	
	* kawa/standard/object.java (rewriteClassDef):  Take ClassExp.
	Allow super type to be non-constant.

2001-07-18  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.95.

	* Makefile.am (JAR_DEPS_XML):  Add gnu/xquery/lang/java-classes.stamp.
	* configure.in:  --with-awt defalts except if --with-gcj.
	(LIBKAWA):  Automake conditional renamed to WITH_GCJ.
	(WITH_AWT):  New automake conditional.
	(AC_OUTPUT):  Add gnu/xquery/*/Makefile.

	* kawa/Shell.java (run):  Use Interpreter's new getPropter method.
	Use Interpreter's new interp.getOutputConsumer method.
	Use Interpreter's new parse method.

	* kawa/lang/CompileFile.java (read):  Don't take Translator arg,
	instead allocate it locally, but take SOurceMessages arg.
	(apply2):  Update accordingly.
	* kawa/standard/load.java (loadSource):  Likewise.

	* kawa/standard/Scheme.java:  Extend LispInterpreter.
	(initScheme):  Add print-as-xml, make-element, make-attribute.
	Various procedures have been moved or now use define_field.
	* kawa/lang/Lambda.java (rewriteBody):  Update package of Consumer.
	* kawa/lang/SyntaxRule.java:  Use Scheme.writeFrmat, instead of
	semi-deprecated SFormat.print.

	* kawa/lang/Translator.java (immediate):  Field moved up to Parser.
	(scan_form):  Made public since called by LispInterpreter.
	(push, pop, pushDecls, popDecls):  Moved from Parser.
	
2001-06-19  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  Don't runCleanups at end if we succeeded
	in registerShutdownHook or started a window with -w.

2001-06-17  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java:  Handle symbol as Binding.
	* kawa/lang/Translator.java:  Handle symbol as Binding.
	* kawa/standard/define_autoload.java:  Likewise.
	* kawa/standard/fluid_let.java:  Likewise.
	* kawa/standard/let.java:  Likewise.
	* kawa/standard/prim_method.java:  Likewise.
	* kawa/standard.Scheme.java (getNamedType):  Handle clisp:xxx as
	well as elisp:xxx, and better error check.

	* configure.in:  Set version to 1.6.94.

	* configure.in (WITH_SWING):  New automake conditional.
	(AC_OUTPUT):  Add gnu/commonlisp/lisp/Makefile.
	* Make-rules (clisp-classes.stamp):  New rule.
	* Makefile.am:  Use automake conditionals.
	(kawa-@VERSION@-jar):  Depend on */*.stamp files.

	* Makefile.am (JAVADOC_PACKAGES):  Update list.
	(JAVADOC_DIR):  Change.
	(install-javadoc-html):  Use -sourcepath to get generated files.

2001-06-09  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.92.

	* configure.in (ENABLE_XML):  New automake conditional.

2001-06-04  Per Bothner  <per@bothner.com>

	No longer install the .class files, but install kawa.jar instead.
	* Make-rules (install-java-classes, install-data-am):  Removed.
	* Makefile.am (CLEANFILES):  Add *.jar.
	(kawa-@VERSION@.jar):  New only makes jar file, without new configure.
	(dist-kawa-@VERSION@.jar):  Renamed from old kawa-@VERSION@.jar.
	(install-jar):  New rule.
	(install-data-am):  New dependency - depend on install-jar.
	(all-redirect):  New dependency, on kawa-@VERSION@.jar.
	(distall):  Depend on dist-kawa-@VERSION@.jar, not plain kawa.jar.

	* kawa/Makefile.am (EXTRA_DIST):  Include $(java_WITH_AWT).

2001-06-03  Per Bothner  <per@bothner.com>

	* Make-rules ($(PACKAGE_FNAME).lo):  Link $^ rather than $? to get
	all the dependencies, not just the out-of-date ones.
	
	* kawa/standard/Scheme.java (writeFormat, displayFormat):  New fields.
	(getFormat): New method.
	(<init>):  Change procedures display and write.
	(print):  Removed method.

	* kawa/standard/require.java (find(Class,Environment)):  Don't run
	Runnable instance here (at compile-time).
	(find(String)):  Run it here instead (at run-time).
	(scanForDefinitions):  If no instance yet, but class is Runnable,
	return ApplyExp to find instance at run-time.

	* kawa.repl (main):  New --debug-print-expr option.
	Update copyright date printed by --version.
	Call WriterManager's registerShutdownHook.
	Call OutPort's runCleanups method in finalizer.

	* Shell.java (run):  Instead of printing results here, call evalModule
	with the standard output as the Consumer.

2001-05-16  Per Bothner  <per@bothner.com>

	* kawa/lang/SpecialType.java:  Moved to gnu.kawa.lispexpr.LangPrimType.
	* kawa/lang/Makefile.am (java_sources):  Remove SpecialType.java.
	* kawa/standard/Scheme.java:  Update to use LangPrimType instead
	of SpecialType.  Use statics of LangPrimType instead of Scheme.

2001-05-08  Per Bothner  <per@bothner.com>

	* configure.in:  Add AC_OBJEXT and AC_CANONICAL_HOST (otherwise
	make install tried to use libtool).
	Change --enable-gcc-compiled to --with-gcj.
	* libtool.m4, ltcf-c.sh, ltcf-cxx.sh, ltcf-gcj.sh, ltconfig, ltmain.sh:
	New files, part of libtool support.
	* Makefile.am (EXTRA_DIST):  Add new files.
	* Make-rules:  Various cleanups for libtool support.
	* */Makefile.am:  Various changes for libtool support etc.
	* kawa/Makefile.am (EXTR_DIST):  Add Version.java.in.
	* kawa/Shell.java:  Avoid removed PairWithPosition constructor.
	* kawa/lang/Eval.java (eval, evalBody):  New method overloads.
	(apply(Environment,CallContext)):  New method.
	* kawa/standard/load.java (loadClassFile):  No longer test that inst
	is a Procedure0 (it is now a CpsProcedure).
	* kawa/standard/require.java (find):  Don't check if value is a
	MdouleBody, since ModuleBody is now always Runnable.

2001-05-01  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.91.

2001-04-26  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.90.

	Change most Makefile.am back to worked with released automake.
	This means include of Make-rules must be handled by automake, which
	is less ideal, but automake snapshots are too buggy.
	* Make-rules:  Bunch of little changes.
	* Makefile.am (EXTRA_DIST): Add Make-rules.
	* configure.in:  Add AC_SUBST_FILE for Make-rules.

2001-04-23  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (getNamedType):  Add <readtable>.
	* kawa/standard/require.java:  Add readtable feature.

2001-04-22  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (readBody):  Removed method.
	* kawa/standard/Scheme.java (eval):  Re-write to use new static
	ReaderParens.readList instead of CompileFile.readBody.
	* kawa/standard/define_autoload.java (findAutoloadComments):
	Update call to LispReader's readNestedComment for new argument list.
	* kawa/standard/string2number.java (parse):  Use new
	LispReader.parseNumber method.

2001-04-11  Per Bothner  <per@bothner.com>

	* kawa/lang/Eval.java (eval):  If argument is PairWithPosition,
	use it to set position of temporary "body" PairWithPosition.
	(evalBody):  If body is PairWithPosition, set ModuleExp's filename.
	* kawa/standard/Scheme.java (initScheme):  Define <pair-with-position>.

2001-04-09  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (<clinit>):  Also handle require 'xml.

	* Make-rules (CLEANFILE):  Also remove $(OFILES_DIR)/$(PACKAGE_FNAME).o.
	* configure.in (AC_OUTPUT):  Replace gnu/kawa/xml by gnu/xml.
	* kawa/Makefile.am (SOURCES):  Removed - recent automake complains.
	(EXTRA_DIST):  Use this instead.
	* kawa/lang/Makefile.am (CLEANFILES):  Remove redundant macro.
	* kawa/lib/Makefile.am (CLEANFILES):  Likewise.

2001-04-07  Thomas Kirk  <tk@research.att.com>

	* kawa/standard/load.java(loadCompiled): Avoid leaking 
	zipfiles by calling new method ZipLoader.loadAllClasses, which
	reads all classes immediately so that zipfile can be closed, 

2001-03-22  Per Bothner  <per@bothner.com>

	* Make-rules:  Various tweaks.
	If compiling .class to native, no longer need to make classes.jar.
	(install-java-classes):  New rule.
	* Makefile.am (SUBDIRS):  Added new bin directory.
	(KAWA1_OFILES, kawa1$(exeext)):  Moved to bin/Makefile.am.
	* configure.in:  (AC_OUTPUT):  Add bin/Makefile.
	If --enable-gcj-compiled, default JAVA and JAVAC to gij and gcj.
	* bin:  New sub-directory.
	* kawa/kawa.c:  Moved to new bin directory.
	* kawa/Makefile.am:  Moved stuff to bin/Makefile.am.
 	
	* repl.java (checkInitFile):  Set home-directory variable *before*
	running init file.

	* Shell.java (run):  Fix logic for EOF testing,

2001-03-08  Per Bothner  <per@bothner.com>

	Many changes to handlenew gnu.lists package.
	* Make-rules (CLEANFILES):  New definition.
	* configure.in:  Handle --with-java-collection flag.

	* kawa/Shell.java, kawa/repl.java:
  	Import gnu.lists instead of gnu.kawa.util.
	* kawa/lang/{AutoloadSyntax.java,CompileFile.java,Eval.java,
	Lambda.java,ListPat.java,ListRepeatPat.java,Macro.java,PairPat.java,
	Quote.java,Record.java,RecordConstructor.java,Syntax.java,
	SyntaxRule.java,SyntaxRules.java,Translator.java,VarListPat.java}:
	Likewise.  Also, use LList.listLength instead of LList.length.
	* kawa/standard/{and_or.java,append.java,begin.java,
	call_with_output_string.java,cxr.java,define.java,define_alias.java,
	define_autoload.java,define_class.java,define_member_alias.java,
	define_syntax.java,define_unit.java,define_variable.java,export.java,
	fluid_let.java,let.java,let_syntax.java,letrec.java,load.java,
	location.java,map.java,module_extends.java,module_implements.java,
	module_name.java,module_static.java,object.java,prim_method.java,
	quasiquote.java,read_line.java,readchar.java,require.java,set_b.java,
	string2number.java,string_append.java,string_v.java,synchronizd.java,
	syntax_case.java,syntax_error.java,syntax_rules.java,try_catch.java,
	try_finally.java,vector_append.java}:
	Import gnu.lists instead of gnu.kawa.util.
	Update LList.length->listLength, elementAt->get, length->size.
	* kawa/standard/{exact_p.java,inexact_p.java,list_p.java,list_ref.java,
	.list_tail.java,list2string.java,number2string.java,string2list.java,
	vector2list.java}:  Removed - re-written in Scheme.
	* Makefile.am (java_JAVA):  Remove removed files.
	* Scheme.java (initScheme):  Update accordingly.
	(getNamedType):  Update paths for classes now in gnu.lists.

	* Scheme.java (define_field):  Mangle the procedure name.

	* missing:  Update to newer version.

2001-02-28  Per Bothner  <per@bothner.com>

	Support for compiling Kawa using Gcj.
	* Make-rules:  New file, to be include by each Makefile.am.
	* Makefile.am (JAVADOC_PACKAGES):  Add "recent" packages.
	(kawa1$(exeext)):  Make, using gcj, Kawa executable (Java-only part).
	M aclocal.m4
	* configure.in:  Add support for --enable-gjc-compiled flag.
	* .../Makefile.am:  Include Make-rules; handle --enable-gjc-compiled.

	* kawa/lang/Record.java:  Use fully-qualified java.lang.reflect.Field
	instead of import, as latter confuses Gcj.
	* kawa/standard/Scheme.java:  Use define_field for display.
	* kawa/standard/map.java:  Fix typo in comment.
	* kawa/standard/require.java (featureMap, SLIB_PREFIX): Static fields
	moved from gnu.kawa.slib.SLib.
	(map, mapFeature):  Methods moved from gnu.kawa.slib.SLib.
	(scanForDefinitions):  Uddate to use local mapFeature.

2001-02-27  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  Field dumpZipPrefix moved to ModuleExp.
	* kawa/standard/define_class.java: Comment out until we can fix it.

2001-02-16  Per Bothner  <per@bothner.com>

	* configure.in:  New --enable-xml flag.
	(XML_SELECTED):  New substitution macro.
	* gnu/kawa/Makefile.am (SUBDIR):  Add optional xml directory.
	* kawa/standard/Scheme.java (getNamedType):  Add <document>.

2000-12-13  Per Bothner  <per@bothner.com>

	* kawa/standard/map.java (inline):  Inline map as well as for-each.

	* kawa/standard/quasiquote.java (expand_pair):  Call LList.make
	rather than kawa.lib.lists.cons.
	(consType):  Removed static field.

	* kawa/standard/Scheme.java (initScheme):  Add "reverse!".
	The reverse function is now in kawa.lib.lists.
	* kawa/standard/reverse.java:  Removed.
	* kawa/standard/Makefile.am (java_JAVA):  Removed reverse.java.


2000-12-13  Emmanuel Castro <castro@lirmm.fr>

	* kawa/standard/Scheme.java (initScheme):  'error' is now in
	kawa.lib.misc, not kawa.lib.syntax.

2000-12-13  Per Bothner  <per@bothner.com>

	* kawa/standard/map.java (inline):  Swap order of then-clause and
	else-clause in generated code.  Fixes bug 'for-each does not compile
	in CVS tree' reported by Emmanuel Castro <castro@lirmm.fr>.

2000-12-11  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (map, forEach):  New fields.
	(<init>):  Initialize map and forEach fields.
	(initScheme):  Defie map, for-each using define_field.
	* kawa/standard/map.java:  Implement CanInline.
	(inline):  New methods, to implement CanInline.
	
2000-12-09  Per Bothner  <per@bothner.com>

	Patch from Matthias Radestock <matthias@lshift.net>:
	* kawa/lang/AutoloadProcedure.java (env):  New field.
	(<init>):  Extra Environment argument.
	(load):  Use env field instead of current Environment.
	* kawa/lang/AutoloadSyntax.java:  Likewise.
	* kawa/standard/define_autoload.java:  Pass Translator's global
	environment to AutoloadProcedure and AutoloadSyntax constructors.
	* kawa/standard/Scheme.java (define_proc, define_syntax):  Pass
	current environ to AutoloadProcedure and AutoloadSyntax constructors.

2000-12-02  Per Bothner  <per@bothner.com>

	* kawa/lang/Macro.java (getExpander):  New method.
	* kawa/lang/Translator.java (addGlobal):  Removed method.
	(getBinding):  Lookup using hygiene-resolved name.
	(pushBinding):  Do nothing if new value is name as old.
	
	* kawa/standard/define.java (scanForDefinitions):  Do pushBinding.
	* kawa/standard/define_unit.java:  Do pushBinding, not addGlobal.
	* kawa/standard/define_syntax.java:  Likewise.
	* kawa/standard/require.java (scanForDefinitions):  Likewise.
	Also if value is a Macro, call bind on it.

	* kawa/standard/open_output_file.java (openOutputFile):  New static.

2000-11-21  Matthias Radestock <matthias@lshift.net>

	* kawa/standard/load.java (apply): Removes an incorrect fall-through
	that results in files to be loaded twice.

	* kawa/standard/require.java (find): Fixes lookup of module class
	instances which resulted in multiple require's for the same module
	to loadExecute the module multiple times

2000-10-23  Per Bothner  <per@bothner.com>

	* kawa/lang/CompileFile.java (compile_to_files):  Strip off any file
	extension, not just ".scm" or ".el".

2000-08-31  Emmanuel Castro <castro@lirmm.fr>

	* kawa/standard/require (finf):  Fix typo in error message.

2000-10-13  Per Bothner  <per@bothner.com>

	* kawa/lang/Syntax.java:  No longer extend Declaration.
	(getName, setName):  New methods.
	(<init>):  Do nothing - since not a Declaration.
	* kawa/lang/Macro.java (bind):  New method.

	* kawa/lang/Record.java (put): Swap arguments in call to set1,
	due to change in setter conventions.
	* kawa/standard/cxr.java (set1):  Swap arguments for new convention.
	* kawa/standard/make.java (applyN):  Likewise.
	* kawa/standard/set_b.java (rewrite):  Likewise.

	* kawa/lang/Translator.java:  Significant changes to support that
	Syntax no longer extends Declaration, and that the introduction
	of StaticFieldConstraint (which could replace autoloading).

	* kawa/standard/call_with_values.java (apply):  Update for changes
	in CallContext.

	* kawa/standard/let_syntax.java (rewrite):  Update for Macro no
	longer inheriting from Declaration.
	* kawa/standard/define_syntax.java:  Likewise.

	* kawa/standard/let.java (let):  New static final field.

	* kawa/standard/car.java:  Replaced by car from kawa/lib/lists.scm.
	* kawa/standard/cdr.java:  Replaced by cdr from kawa/lib/lists.scm.
	* kawa/standard/plus_oper.java: Replaced by gnu.kawa.functions.AddOp.
	* kawa/standard/minus_oper.java: Replaced by gnu.kawa.functions.AddOp.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/Scheme.java:  Likewise.

2000-10-12  Per Bothner  <per@bothner.com>

	* kawa/standard/{ceiling.java,floor.java,round.java,truncate.java,
	ashift.java}:  Replaced by new procedures in kawa/lib/numbers.scm.
	* kawa/standard/Scheme.java:  Update accordingly.
	* kawa/standard/Makefile.am (java_JAVA):  Remove removed classes.

	* configure.in:  Set version to 1.6.71.
	(AC_OUTPUT):  Add gnu/kawa/functions/Makefile.

	* kawa/standard/apply.java:  Moved to gnu/kawa/functions/Apply.java.
	* kawa/standard/format.java:  Moved to gnu/kawa/functions/Format.java.
	* kawa/standard/ObjectFormat.java:  Moved to gnu/kawa/functions.
	* kawa/standard/TracedProcedure.java:  Add import for ObjectFormat.
	* kawa/standard/ParseFormat.java:  Moved to gnu/kawa/functions.
	* kawa/standard/LispFormat.java:  Moved to gnu/kawa/functions.
	* kawa/standard/ass.java:  Moved to gnu/kawa/functions/Assoc.java.
	* kawa/standard/eq_p.java:  Moved to gnu/kawa/functions/IsEq.java.
	* kawa/standard/equal_p.java: Moved to gnu/kawa/functions/IsEqual.java.
	* kawa/standard/eqv_p.java:  Moved to gnu/kawa/functions/IsEqv.java.
	* kawa/standard/list_v.java: Moved to gnu/kawa/functions/MakeList.java.
	* kawa/standard/mem.java:  Moved to gnu/kawa/functions/Member.java.
	* kawa/standard/setter.java:  Moved to gnu/kawa/functions/Setter.java.
	* kawa/standard/not.java (<init>(Interpreter,String)): New constructor.
	* kawa/standard/prim_method.java (rewrite):  More robust;
	diagnostic for missing class.
	* kawa/standard/convert.java (instance):  Sttaic field renamed ...
	(as):  ... new field, now allocated at <clinit>-time.
	(getInstance):  Always return the 'as' field.
	* kawa/standard/StaticFieldConstraint.java:  New class,
	extends ClassMemberConstraint.
	* kawa/standard/Scheme.java (define_field):  New methods.
	(instanceOf, not, isEq, isEqv, isEqual, memq, memv, member, assq,
	assv, assoc):  New static fields for standard Procedures.
	(initScheme):  Numerous updates.
	(parseFormat):  Removed static field.  (Use field in ParseFormat.)
	* kawa/standard/Makefile.am:  Numerous updates.

2000-8-17  Per Bothner  <per@bothner.com>

	* kawa/standard/apply.java (apply):  Update CallStack -> CallContext.
	* kawa/standard/call_with_values.java (apply):  Likewise.
	* kawa/standard/callcc.java (apply):  Likewise.

	* kawa/lang/Lambda.java (rewriteBody):  Handle ':: <TYPE> EXP ...'.
	Use new makeCoersion method in Expression.
	Support <sequence> result to use Consumer target.

2000-10-09  Per Bothner  <per@bothner.com>

	* kawa/standard/prim_method.java (rewrite):  Load reflectClass here;
	emit diagnostic message on failure.

2000-10-02  Per Bothner  <per@bothner.com>

	* kawa/standard/require.java (scanForDefinitions):  If imported field
	is a Binding, do setIndirectBinding(true).

2000-08-16  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  The --cps flag also sets usingTailCalls.
	
	* kawa/GuiConsole.java (<init>):  Set autoflush for default out
	and err Writers.  Fix from Emmanuel Castro <castro@lirmm.fr>.

2000-06-26  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (rewrite):  If separate name spaces,
	don't resolve regular name to procedure decl.

2000-06-24  Per Bothner  <per@bothner.com>
	
	* configure.in:  Set version to 1.6.70.

	* configure.in (AC_OUTPUT):  Add gnu/commonlisp/*.

	* kawa/lang/Lambda.java:  Mode a lot more generic.
	(optionalKeyword, restKeyword, keyKeyword):  New fields.
	(rewriteBody):  New method.
	* kawa/standard/define.java (lambda):  New field.
	* kawa/standard/object.java (lambda):  New field.
	* kawa/standard/define_class.java (objectSyntax):  New field.
	* kawa/standard/Scheme.java:  Update as appropriate.

2000-06-19  Per Bothner  <per@bothner.com>

	* Makefile.am (kawa.jar):  Fix dependency.
	(EXTRA_DIST): Add jar-manifest.

	* configure.in:  Set version to 1.6.68.
	(JEMACS_VERSION):  New variable.

	* Makefile.am:  Add rules to make jemacs.tar.
	(kawa-@VERSION@-compiled.jar):  Renamed to kawa-@VERSION@.jar.
	Do a full configure+make first.

	* gnu/kawa/util/Char.java:  Moved to gnu/text.
	Various references had to be updated, or import statements added.

	* kawa/repl.java:  Update copyright printed by --version.

	* kawa/standard/LispFormat.java (class LispIntegerFormat):
	Moved and renamed to gnu/text/IntegerFormat.java.
	* kawa/standard/ParseFormat.java:  Add mostly-working (except that
	precision is ignored) for %d %i %o %x and %X.

	* kawa/standard/{char_ci_equal_p.java,char_ci_greater_equal_p.java,
	char_ci_greater_p.java,char_ci_less_equal_p.java,char_ci_less_p.java,
	char_equal_p.java,char_greater_equal_p.java,char_greater_p.java,
	char_less_equal_p.java,char_less_p.java}:  Removed.  Subsumed by
	new procedures in kawa/lib/characters.scm.
	* kawa/standard/Makefile.am:  Update accordingly.
	* kawa/standard/Scheme.java:  Update accordingly.

2000-06-17  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadProcedure.java (getProperty): New method.

	* kawa/lang/AutoloadSyntax.java (load):  Don't re-set in Environment.

	* kawa/standard/Scheme.java (getTypeValue):  Use getTypeFor method
	of Interpreter.

	* kawa/standard/ParseFormat.java (asFormat):  New static method.
	* kawa/standard/format.java (formatToString):  New static method.
	* kawa/standard/instance.java:  Moved and renamed to
	gnu/kawa/reflect/InstanceOf.java.
	* kawa/standard/Makefile.am:  Updated accordingly.

	* kawa/standard/apply.java:  Extend for use by ELisp.
	(getArguments):  Make static, add new skip parameter.
	(apply, applyN):  Adjust accordingly.

	* kawa/standard/not.java (trueExp, falseExp):  New fields.
	(compile):  Use them.
	Also, pass interpreter to ConditionalTarget constructor.

2000-06-09  Per Bothner  <per@bothner.com>

	* Makefile.am (SUBDIRS):  Move testsuite before gnu, to "force" check
	to be run there before in gnu/jemacs/testsuite.M
	* configure.in (AC_OUTPUT):  Added gnu/jemacs/testsuite/Makefile.

	* kawa/lang/AutoloadProcedure.java:  Implement Externalizable.
	* kawa/lang/AutoloadSyntax.java:  Implement Externalizable.

	* kawa/lang/Syntax.java (<init>):  Don't bother setting TYPE_SPECIFIED.

	* kawa/lang/Translator.java (finishModule):  Handle case of no forms.

	* kawa/standard/define_autoload.java:  New class, extends Syntax.
	* kawa/standard/define_unit.java:  New class, extends Syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Update accordingly.
	* kawa/standard/Scheme.java (initScheme):  Add new syntaxes.
	* kawa/standard/define_syntax.java (rewriteForm):  Add a noteValue.
	* kawa/standard/define.java (makeConstant):  New field.
	Generaize to implement define-constant.
	* kawa/standard/require.java:  If immediate, just call
	ClassMemberConstraint.define.

	* kawa/standard/set_b.java (rewrite):  Complain if setting a constant.

2000-06-09  Bruce Lewis  <brlewis@alum.mit.edu>

	* kawa/standard/read_line.java (apply):  Fix off-by-one error in
	handling of '\r' followed by '\n'.

2000-05-28  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Added gnu/kawa/lispexpr/Makefile.
	* kawa/lang/CompileFile.java:  LispReader moved to gnu.kawa.lispexpr.
	* kawa/lang/ScmRead.java:  Moved to gnu.kawa.lispexpr.
	* kawa/lang/Makefile.am:  Updated accordingly.
	* kawa/standard/Scheme.java:  Update imports.
	* kawa/Shell.java:  LispReader moved to gnu.kawa.lispexpr.

	* kawa/lang/Translator.java (finishModule):  If SUPERTYPE_SPECIFIED,
	force declaration to be non-static.
	* kawa/standard/module_extends.java:  Set SUPERTYPE_SPECIFIED.
	* kawa/standard/module_implements.java:  Likewise.
	
	* kawa/standard/read.java: Use RuntimeException or WrappedException
	instead of semi-deprecated GenericException.
	* kawa/standard/call_with_input_file.java:  Likewise.
	* kawa/standard/call_with_output_file.java: Likewise.
	* kawa/standard/make.java: Likewise.
	* kawa/standard/scheme_env.java: Likewise.
	* kawa/standard/string2number.java: Likewise.
	* kawa/standard/with_input_from_file.java: Likewise.

2000-05-27  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  New --module-static flag.
	* kawa/lang/Syntax.java (<init>):  Set TYPE_SPECIFIED and IS_CONSTANT.
	* kawa/lang/Macro.java (setExpander):  New method.
	* kawa/lang/Lambda.java (rewrite):  Maybe set TYPE_SPECIFIED on param.
	* kawa/lang/Translator.java (finishModule):  Process static and
	export specification.

	* kawa/standard/module_static.java:  New class; extends Syntax.
	* kawa/standard/export.java:  New class; extends Syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Add new files.
	* kawa/standard/Scheme.java (initScheme):  Add module-static and
	module-export.

	* kawa/standard/Scheme.java (demangleName):  Fix to handle
	minor changes in Compilation.mangleName.

	* kawa/standard/define.java:  Handle optional type-specifier.
	* kawa/standard/define_alias.java:  If aliased expression is a simple
	name, don't call rewrite (which does setIndirectBinding).
	(scanForDefinitions):  Don't set decl type until rewrite.
	* kawa/standard/define_syntax.java:  If immediate, call Macro's
	setExpander method, re-using current Macro.
	* kawa/standard/let.java (rewrite): Set TYPE_SPECIFIED in Declaration.
	* kawa/standard/letrec.java:  Likewise.
	* kawa/standard/require.java (find):  Fix typo.
	(scanForDefinitions):  Note that Declaration is not simple.
	Note mustCompileHere.
	* kawa/standard/set_b.java:  Do followAliases.

2000-05-22  Per Bothner  <per@bothner.com>

	* confgure.in (AC_OUTPUT):  Add gnu/jemacs/lisp/Makefile.
	
	* kawa/lang/AnyPat.java:  No longer implement Compilable.
	* kawa/lang/EqualPat.java:  No longer implement Compilable.
	* kawa/lang/PairPat.java:  No longer implement Compilable.
	* kawa/lang/ListRepeatPat.java:  No longer implement Compilable.
	* kawa/lang/Macro.java:  No longer implement Compilable
	* kawa/lang/SyntaxRule.java:  No longer implement Compilable
	* kawa/lang/SyntaxRules.java:  No longer implement Compilable

	* kawa/lang/SpecialType.java:  Do method lookup here instead of
	expecting it in gnu.kawa.util.Char or gnu.math methods.

	* kawa/standard/Scheme.java (string2Type):  Use ArrayType.make.
	(<init>):  Set Interpreter.defaultInterpreter first.
	(getNamedType):  Add <procedure> as a synonym for <function>.
	(getTypeFor):  New method.
	(exp2Type):  Just call getTypeFor.

	* kawa/standard/define_syntax.java
	(typeMacro, makeMethod):  New static fields.
	(rewriteForm):  Check if syntax rule is Externalizable, rather
	than no-longer-used Compilable.  Use new makeMethod field.

2000-05-09  Per Bothner  <per@bothner.com>

	* kawa/lang/AutoloadProcedure.java:  Use new Environment puttFunction.
	* kawa/lang/AutoloadSyntax.java:  Use new Environment getFunction.

	* kawa/lang/AnyPat.java:  Implement java.io.Externalizable.
	* kawa/lang/EqualPat.java:  Likewise.
	* kawa/lang/ListRepeatPat.java:  Likewise.
	* kawa/lang/PairPat.java:  Likewise.
	* kawa/lang/Macro.java:  Likewise.
	* kawa/lang/SyntaxRule.java:  Likewise.
	* kawa/lang/SyntaxRules.java:  Likewise.

	* kawa/lang/Macro.java (scanForDefinitions):  Use new Parser methods
	to set line position.

	* kawa/lang/Translator.java (current_filename, current_line,
	current_column. messages):  Moved fields to superclass (Parser).
	(getMessages, setMessages, error):  Likewise moved methods.
	(setLine):  New methods.
	(scan_form):  Use new setLine method.
	* kawa/lang/SyntaxRules.java (<init>):  Likewise.

	* kawa/repl.java (setInterpreter):  Method removed.
	(getInterpreter):  Don't hard-wire in Scheme.
	(main):  Don't hard-wire in languages, instead ask Interpreter.

	* kawa/standard/Scheme.java (getNamedType):  Don't hard-wire
	"elisp:boolean".  Instead, handle "elisp:*".  Also, get an Elisp
	instance using reflection - in case it isn't available when compiling.

2000-04-22  Per Bothner  <per@bothner.com>

	* kawa/lang/SpecialType.java (interpreter):  New optional field.
	Call interpreter to handle conversion to/from boolean.
	* kawa/standard/eq_p.java (interpreter):  New field.  Used to
	do language-appropriate boolean result.
	* kawa/standard/equal_p.java:  Likewise.
	* kawa/standard/eqv_p.java:  Likewise.
	* kawa/standard/instance.java:  Likewise.
	* kawa/standard/not.java (getReturnType):  Get from interpreter.
	* kawa/standard/Scheme.java
	(booleanType):  Don't initialize in static constructor.
	(intType, floatType, etc):  Use new SpecialType constructor.
	(initSchee):  Pass this to eq_p, eqv_p, equal_p, instance constructors.
	(getNamedType):  Init boolean here, passing in Scheme.getInstance.
	Also, handle <elisp:boolean>.

2000-04-22  Per Bothner  <per@bothner.com>

	* kawa/lang/SpecialType.java (interpreter):  New optional field.
	Call interpreter to handle conversion to/from boolean.
	* kawa/standard/eq_p.java (interpreter):  New field.  Used to
	do language-appropriate boolean result.
	* kawa/standard/equal_p.java:  Likewise.
	* kawa/standard/eqv_p.java:  Likewise.
	* kawa/standard/instance.java:  Likewise.
	* kawa/standard/not.java (getReturnType):  Get from interpreter.
	* kawa/standard/Scheme.java
	(booleanType):  Don't initialize in static constructor.
	(intType, floatType, etc):  Use new SpecialType constructor.
	(initSchee):  Pass this to eq_p, eqv_p, equal_p, instance constructors.
	(getNamedType):  Init boolean here, passing in Scheme.getInstance.
	Also, handle <elisp:boolean>.

2000-04-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java:  No extends from gnu.expr.Parser.
	(current_scope):  Moved field to Parser.
	(parse):  New method, implements method from Parser.
	(currentLambda, currentScope, getInterpreter, mustCompileHere,
	push, pop, pushDecls, popDecls):  Moved methods to Parser.

	* kawa/lang/Translator.java (getBinding):  Also check inherited env.

2000-04-18  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.67.

2000-04-17  Per Bothner  <per@bothner.com>

	* kawa/lang/Record.java (getFieldFields):  Removed two methods.
	(equals):  Re-write to not use getFieldFields.

	* kawa/standard/Scheme.java (getNamedType):  Add <abstract-string>.

2000-04-12  Per Bothner  <per@bothner.com>

	* kawa/Telnet.java:  Merge contents of TelnetConnection.java.
	Implement Runnable instead of extending Thread.
	Make some constants (such as ECHO, DONT, etc) public.
	* kawa/TelnetConnection.java:  Removed.
	* kawa/TelnetInputStream.java:  Update accordingly.
	* kawa/TelnetOutputStream.java:  Likewise.
	* kawa/repl.java:  Likewise.
	* kawa/Makefile.am (java_JAVA):  Remove TelnetConnection.java.
	
	* kawa/lang/GetFieldProc.java:  Use gnu.bytecode.Field (now with
	sourceName and reflection cache) instead of java.lang.reflect.Field.
	* kawa/lang/SetFieldProc.java:  Likewise.
	* kawa/lang/RecordConstructor.java:  Likewise.
	* kawa/lang/Record.java (toString):  Likewise use extended Field.
	(makeRecordType):  Handle names that need to be mangled.

	* kawa/standard/location.java (rewrite):  If ReferenceExp, return it.
	* kawa/standard/define_alias.java (scanForDefinitions):  Put
	Declaration in pushed form.  Call Declarations's setAlias.
	(rewrite):  Don't create IndirectConstraint.

	* kawa/standard/Scheme.java (Scheme):  Initialize
	Interpreter.defaultInterpreter to this Scheme.

	* kawa/standard/number2string.java (apply, apply):  Create FString.

	* kawa/standard/Scheme.java (demangleName):  New static method.

	* kawa/standard/Scheme.java (getTypeValue):  Follow aliases.
	(getNamedType):  Remove emacs type aliases.  (Now in emacs.scm.)
	* kawa/standard/prim_method.java (exp2Type):  Use Scheme.getTypeValue.

2000-03-22  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.64.

2000-03-21  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (module):  Make non-public.
	(getModule):  New method.

	* kawa/standard/module_extends.java:  New class, extends Syntax.
	* kawa/standard/module_name.java:  New class, extends Syntax.
	* kawa/standard/module_implements.java:  New class, extends Syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Add new classes.
	* kawa/standard/Scheme.java (initScheme):  Define new syntax.

2000-03-17  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (run):  Kludge to work with ELisp.
	* kawa/lang/AutoloadProcedure.java (load):  Likewise.
	* kawa/lang/AutoloadSyntax.java (load):  Likewise.
	* kawa/lang/Translator.java (getInterpreter):  New field.
	(rewrite_pair, rewrite):  More kludges for ELisp.

	* kawa/lang/CompileFile.java (readBody, read):  Get correct lexer
	via the default Interpreter.
	(compile_to_files):  Know about .el file extension.

	* kawa/standard/NumberCompare.java:  New generalized compare class.
	Has appropriate mangled static fields and methods.
	* kawa/standard/{equal_oper.java,greater_oper.java,less_oper.java,
	greaterequal_oper.java,lessequal_oper.java}: Subsumed by NumberCompare.
	* kawa/standard/Makefile.am (java_JAVA):  Update class list.
	* kawa/standard/write.java:  Replaced by kawa/lib/port.scm.
	* kawa/standard/writechar.java:  Replaced by kawa/lib/port.scm.
	* kawa/standard/Scheme.java (initScheme):  Update accordingly.

	* kawa/standard/fluid_let.java:  Support ELisp `let' and `let*'.
	(start, defaultInit):  New fields, for Elisp support.
	* kawa/standard/load.java (loadSource):  Don't hard-wire Scheme.
	* kawa/standard/prim_method.java (rewrite):  Allow 'xx for method name.
	* kawa/standard/require.java:  Default package as compilationPrefix.

	* kawa/standard/string_append.java (stringAppend$V): New static method.
	* kawa/standard/number2string.java (format):  Renamed to apply.
	* kawa/standard/char_equal_p.java (apply):  New static method.

2000-03-06  Per Bothner  <per@bothner.com>

	* Makefile.am (makekawa.bat):  Add new scm sub-directories.
	* gnu/{jawa/slib,jemacs/buffer,jemacs/lang}/Makefile.{am,in}:
	Added list-sources target.

	* configure.in, configure (AC_OUTPUT):  Add gnu/slib/Makefile.
	* gnu/kawa/Makefile.am (SUBDIRS):  Add slib.

	* jar-manifest:  New file, used to build kawa-@VERSION@-compiled.jar.
	* Makefile.am (kawa-@VERSION@-compiled.jar):  Add manifest file.
	(install-javadoc-html):  Copy over COPYING.

	* kawa/lang/Translator.java (immediate):  New field.
	* kawa/Shell.java (run):  Set Translator's immediate field

	* kawa/lang/Translator.java (rerite_pair):  Call check_if_syntax.

	* kawa/lang/Translator.java (scan):  Save/restore line number info.
	* kawa/lang/CompileFile.java (compile_to_file):  Return if errors seen.

	* kawa/standard/eqv_p.java (apply):  Make static.
	
	* kawa/standard/require.java (allocate):  Rename to find.
	Add working implementation.

2000-03-02  Per Bothner  <per@bothner.com>

	* jawa/standard/prim_throw.java (getReturnType):
	Change to Type.neverReturnsType.

2000-02-29  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.65.

2000-02-27  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.64.

	* configure.in:  Support new flag --without-awt.
	* kawa/GuiConsole.java:  Addd default constructor.
	* kawa/repl.java (main):  Load GuiConsole using reflection.
	* kawa/Makefile.am:  Don't build GuiConsole etc if --without-awt.

	* Makefile.am:  Add rules for kawa-compiled.jar.

	* kawa/lang/Syntax.java:  Also implements Named.
	* kawa/standard/Scheme.java:  Use Procedure.getName instead of name.

2000-02-26  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme.java (getNamedType):  Add "frame".

2000-02-19  Per Bothner  <per@bothner.com>

	* kawa/Shell.java (runFile):  Catch SyntaxException, and do printAll.

	* kawa/standard/Scheme.java (initScheme):  Define `emacs'.

	* configure.in:  New substitution variable SWING_SELECTED.

2000-02-12  Per Bothner  <per@bothner.com>

	* kawa/standard/Scheme (initScheme):  Define "this" macro.
	(registerEnvironment):  Set Interpreter.defaultInterpreter

2000-02-11  Per Bothner  <per@bothner.com>

	* kawa/repl.java (main):  Recognize --applet flag.

	* kawa/standard/load.java (apply):  Now throws FileNotFoundException.
	(apply2):  Catch FileNotFoundException.
	(loadClassFile):  Do ClassMemberConstraint.defineAll.
	* kawa/Shell.java (runFile):  Use load.apply.

	* kawa/lang/Lambda.java (rewrite):  Using a Pattern is overkill.

	* kawa/lang/Translator.java (rewrite_pair):  Maybe setProcedureName.

	* kawa/standard/Scheme.java (registerCurrent):  New static method.

	* kawa/standard/define_variable.java:  New class; extends Syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Add define_variable.java.
	* kawa/standard/Scheme.java (initScheme):  Define "define-variable".

2000-02-02  Per Bothner  <per@bothner.com>

	* kawa/standard/define.java (scanForDefinitions):  Fix thinko.

2000-02-01  Per Bothner  <per@bothner.com>

	* kawa/repl.java (defaultInterpreter):  Static field moved
 	to Interpreter.  Updated various uses.
	* kawa/lang/Interpreter.java:  Moved gnu.expr.
	* kawa/GuiConsole.java:  Update import statement accordingly.
	* kawa/lang/Makefile.am (java_JAVA):  Removed Interpreter.java.

	* kawa/lang/Translator.java (getrBinding, rewrite_pair):
	Call Binding's getFunctionValue method.

	* kawa/standard/{char_ready_p.java,eqv_p.java,exact_p.java,
	inexact_p.java,integer_p.java,positive_p.java}:
  	Use Boolean.TRUE/Boolean.FALSE rather than Interpreter.boolObject.
	* kawa/standard/{string_ci_equal_p.java,string_ci_greaterequal_p.java,
	string_ci_greaterthan_p.java,string_ci_lessequal_p.java,
	string_ci_lessthan_p.java,string_greaterequal_p.java,
	string_greaterthan_p.java,string_lessequal_p.java;
	kawa/standard/string_lessthan_p.java}:  Likewise.
	(apply)  New static method.
	* kawa/standard/{write.java,writechar.java}:  Use Scheme.voidObject
	instead of Interpreter.voidObject.
	* kawa/standard/not.java (interpreter):  New field.
	(apply1):  Use interpreter.booleanObject.
	* kawa/standard/and_or.java (interpreter):  New field.
	(rewrite):  Use interpreter.booleanObject.

	* kawa/standard/Scheme.java:  Rename fields to Java conventions:
 	(null_environment):  Renamed to nullEnvironment.
 	(r4_environment):  Renamed to r4Environment.
 	(r5_environment):  Renamed to r5Environment.
 	(kawa_environment):  Renamed to kawaEnvironment.
	* kawa/standard/scheme_env.java (apply1):  Update accordingly.

2000-01-24  Per Bothner  <per@bothner.com>

	* kawa/lang/ScmRead.java: Add #!undefined->Interpreter.undefinedObject.

	* kawa/lang/PrimArrayGet.java:  Moved to gnu.kawa.reflect.ArrayGet.
	* kawa/lang/PrimArraySet.java:  Moved to gnu.kawa.reflect.ArraySet.
	* kawa/lang/PrimArrayNew.java:  Moved to gnu.kawa.reflect.ArrayNew.
	* kawa/lang/PrimArrayLength.java:Moved to gnu.kawa.reflect.ArrayLength.
	* kawa/lang/PrimGetStatic.java:  Moved to gnu.kawa.reflect.StaticGet.
	* kawa/lang/PrimSetStatic.java:  Moved to gnu.kawa.reflect.StaticSet.
	* kawa/lang/QueueReader.java:  Moved to gnu.text.
	* kawa/lang/Makefile.am (java_JAVA):  Update accordingly.
	* kawa/standard/syntax_case.java:  Update for new class names.
	* kawa/GuiConsole.java:  Update since QueueReader was moved.
	* kawa/MessageArea.java:  Likewise.

	* kawa/standard/Makefile.am (java_JAVA):  Remove moved files.
	* kawa/standard/Scheme.java (initScheme):  Various procedures are
	now defined in kawa/lib/vectors.scm and numbers.scm.
	* kawa/standard/{acos.java,asin.java,lognot.java,logop.java,
	logbit_p.java,logtest.java,logcount.java,bit_extract.java,
 	int_length.java close_input_port.java,null_env.java,user_env.java,
	make_vector,.java,vector_fill_b.java,cons.java,vector_v.java}:
 	No longer needed.

	* kawa/standard/load.java (apply):  Make static.

	* kawa/standard/quasiquote.java:  Call utility functions using inlined
	Invoke.makeInvokeStatic, rather than new ApplyExp (new QuoteExp ...).
	* kawa/standard/append.java (append$V):  New method.
	No longer implement Compilable.
	* kawa/standard/vector_append.java (apply$V):  New method.
	No longer implement Compilable.
	* kawa/standard/Scheme.java (initScheme):  Don't use removed statics.

2000-01-23  Per Bothner  <per@bothner.com>

	* kawa/standard/load.java:  Change methods to return void.
	(loadCompiled):  Call defineAll method in ClassMemberConstraint
 	to import public fields.
	* kawa/lang/AutoloadProcedure.java (load):  Likewise.
	* kawa/lang/AutoloadSyntax.java (load):  Likewise.

	* kawa/lang/Macro.java:  No longer use inherited value field.
	Now implement Compilable and Printable.
 	(transformer):  Removed field.
	(expander):  New Expression field.
	(print):  New method (to implement Printable).
	(makeLiteral, emit):  New methods (to implement Compilable).
	* kawa/standard/define_syntax.java:  Change for new Macro handling.
	* kawa/standard/let_syntax.java (rewrite):  Likewise - save
	tranbsformers in local array, not in Macro.transformer.

	* kawa/lang/Translator.java (push, pop):  Use pushBinding. popBinding.
	(push):  Do mustCompileHere() for all scopes except ModuleExp.

	* kawa/standard/call_with_values.java (callWithValues):  New static.

	* kawa/standard/close_input_port.java (apply1):  Use WrappedException.

	* kawa/standard/define.java (scanForDefinitions):  Re-structure.
	Sometimes do setCanWrite on decl when we don't want default inlining.
	In that case, set decl's value to null.

	* kawa/lang/NamedException.java (toString):  Trivial optimization.
	* kawa/lang/PairPat.java (match):  Stylistic simplification.

	* kawa/lang/Lambda.java (rewrite):  Set (default) type of #!rest arg.
	Allow #!rest arg to have a type.
	* kawa/standard/values_v.java:  Removed.
	* kawa/standard/Scheme.java (initScheme):  Don't declare it either.
	* kawa/standard/location.java (makeProcLocation$V):  New static method.
	(rewrite):  Call makeProcLocation$V instead of %makeProcLocation.
	* kawa/standard/makeProcLocation.java:  Removed.
	* kawa/standard/Scheme.java (initScheme):  Remove %makeProcLocation;
	now get `values' from kawa.lib.misc.
	* kawa/standard/Makefile.am (java_JAVA):  Update accordingly.

	* kawa/standard/format.java (format, formatToString):  Make static.
	(format$V):  New static method.

	* kawa/standard/list_v.java:  Implement Inlinable.
	(compile, getReturnType):  New methods.

1999-12-27  Per Bothner  <per@bothner.com>

	* kawa/lang/Lambda.java (rewrite):  Don't call setParameter.
	* kawa/lang/Syntax.java:  Two trivial cleanups.
	* kawa/lang/Translator.java (current_decl):  Rename to environ.
	(rewrite):  Handle non-Declaration in environ.
	(shadowStack):  New field.
	(pushBindund, popBinding):  New methods.
	* kawa/lang/SyntaxRule.java:  Use Translator's environ field.
	* kawa/standard/define_alias.java:  Likewise.

	* kawa/standard/require.java:  New class; extends Syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Add require.java.
	* kawa/standard/Scheme.java (initScheme):  Add require.

	* kawa/standard/define.java:  Use Declaration's new getName() method.
	* kawa/standard/define_member_alias.java:  Likewise.
	* kawa/standard/letrec.java:  Use Declaration instead of Variable.
	* kawa/standard/set_b.java:  Likewise.

1999-12-10  Per Bothner  <per@bothner.com>

	* gnu/kawa/util:  New package directory.
	* configure.in (AC_OUTPUT):  Add gnu/kawa/util/Makefile.
	* kawa/lang/Makefile.am (java_JAVA):  Remove classes moved
 	to gnu/kawa/util.
	* gnu/*:  Update for classes moved to new gnu.kawa.util (some renamed).
	* kawa/*:  Likewise.
	* gnu/kawa/Makefile.am (SUBDIRS):  Add util.
	* kawa/lang/ScmRead.java (readUniformVector):  New method.
	(readObject):  Use readUniformVector to read SRFI-4 uniform vectors.
 	(readCharacter):  Use new Char.nameToChar method.
	* kawa/standard/length.java:  Removed - replaced by Scheme code.
	* kawa/standard/Makefile.am (java_JAVA):  Update accordingly.
	* kawa/standard/Scheme (initScheme):  Add new SRFI-4 procedures.
	(getNamedType):  Add new type names for SRFI-4 uniform vectors.

1999-12-06  Per Bothner  <per@bothner.com>

	* Makefile.am, Makefile.in (JAVADOC_PACKAGES):  Add new packages.
	(JAVADOC_FLAGS):  Add flags to give javadoc enough memory.

	* kawa/lang/Lambda.java (rewrite):  Support NAME :: TYPE syntax.

	* kawa/standard/let.java (rewrite):  Trivial optimization.

	* kawa/standard/define_member_alias.java:  New Syntax class.
	* kawa/standard/Makefile.am (java_JAVA):  Add define_member_alias.java.
	* kawa/standard/Scheme.java (initScheme):  Define define-member-alias.
	 (getNamedType):  Define buffer and window.

1999-12-05  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.63.

1999-11-16  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.62, and made release.
	* COPYING:  New file.  Replaces removed doc/license.terms.
	* kawa/repl.java (main):  --version prints (short) copyright notice.

1999-11-15  Per Bothner  <per@bothner.com>

	* kawa/lang/Pair.java (emit):  Use new ClassType.getDeclaredField.
	* kawa/lang/Translator.java (rewrite_pair):  If Inlineable,
	don't try PrimProcedure.getMethodFor (yet).

M kawa/standard/TracedProcedure.java
	* kawa/standard/Scheme.java (string2Type):  Use ClassType.make.
 	(initScheme):  Update for gnu.kawa.reflect changes.
	* kawa/standard/static_field.java:  Remove;  subsumed by Invoke.
	* kawa/standard/Makefile.am (java_JAVA):  Update accordingly.

1999-11-04  Per Bothner  <per@bothner.com>

	* kawa/lang/Char.java (make):  Remove subsumed method.

	* kawa/lang/Translator.java (rewrite_pair):  Move code to look
	for matching static method to gnu.expr.PrimProcedure.getMethodFor.

	* kawa/lang/Translator.java (apply_rewrite):  Fix thinko,
	reported by Daniel Bonniot <d.bonniot@mail.dotcom.fr>.

	* kawa/standard/Scheme.java (initScheme):  Define open-output-string,
	get-output-string, string-output-port.

	* kawa/standard/call_with_output_string.java (apply1):
	Use new CharArrayOutPort class instead of CharArrayWriter.
	* kawa/standard/format.java (formatToString):  Likewise.

	* kawa/standard/plus_oper.java (apply$V):  New method.
	(apply(Object,Object)):  Removed, until we have better inlining.

1999-10-20  Bruce Lewis  <brlewis@alum.mit.edu>

	* kawa/lang/ScmRead.java: New method readDefault lets subclasses
	extend the behavior of the readObject methods.
	* kawa/standard/Scheme.java: Allow subclasses to use define_proc
	and define_syntax methods.

1999-10-25  Per Bothner  <per@bothner.com>

	* Makefile.am, Makefile.in (makekawa.bat):  Depend on configure.in.
	* configure.in, configure:  Set version to 1.6.61.

	* doc/kawa.texi:  Document `invoke'.
	* NEWS, TODO:  Updates.

	* kawa/lang/Syntax.java (scanForDefinitions):  New method.
	* kawa/lang/AutoloadSyntax.java (scanForDefinitions):  New method.
	* kawa/lang/Macro.java (scanForDefinitions):  New method.
	* kawa/lang/Translator.java
 	(rewrite_pair):  Handle varargs method (apply$V and NAME$V).
	(scan_form):  Rewr-ite to use new Syntax.scanForDefinitions.
	More logic specific to a syntax to the corresponding method.
	* kawa/standard/begin.java (scanForDefinitions):  New method.
	* kawa/standard/define.java (scanForDefinitions):  New method.
	* kawa/standard/define_alias.java (scanForDefinitions):  New method.
	* kawa/standard/define_syntax.java (scanForDefinitions):  New method.
	* kawa/standard/Scheme.java (defineSyntax, defineSyntaxPrivate,
	beginSyntax, defineAliasSyntax, defineSyntaxSyntax):  Remove fields.
	(initScheme):  Fix typo "kawa.lib.number" -> "kawa.lib.numbers".
	Add "open-input-string" (SRFI-6), "define-class", "invoke".

	* kawa/standard/object.java (rewriteClassDef):  New method.
	* kawa/standard/define_class.java:  New class.
	* kawa/standard/{Makefile.am,Makefile.in} (java_JAVA):  Update.

	* kawa/standard/read_line.java (apply):  Re-throw a WrappedException.

	* kawa/standard/make_future.java (apply1):  Future Procedure
	no longer is necessarily a Procedure1.

1999-10-13  Walter C. Pelissero <wcp@demon.db.de>

	* kawa/standard/TracedProcedure.java:  Catch RuntimeException,
	print to trace output, and re-throw.

1999-10-13  Per Bothner  <per@bothner.com>

	* kawa/standard/TracedProcedure.java:  Indent output.

1999-10-07  Per Bothner  <per@bothner.com>

	* kawa/standard/TracedProcedure.java:  Indent nested calls.

1999-10-07    	Walter C. Pelissero <wcp@demon.db.de>.

	* kawa/standard/Scheme.java:  Fix typo number -> numbers.

1999-10-04  Per Bothner  <per@bothner.com>

	* kawa/standard/make_future.java:  Future action is now Procedure,
	not necessarily Procedure0.
  	Fixes bug reported by Walter C. Pelissero <wcp@demon.db.de>.

1999-09-14  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.60.
	(AC_OUTPUT):  Add gnu/kawa/Makefile gnu/kawa/reflect/Makefile.
	
	* kawa/lang/Interpreter.java (coerceFromObject, coerceToObject):
	New methods.

	* kawa/standard/call_with_values.java: Update values() -> getValues().
	* kawa/standard/Scheme.java:  Likewise.

	* kawa/lang/InvokeStatic.java:  Moved to gnu/kawa/reflect.
	* kawa/standard/class_methods.java:  Replaced by
 	gnu/kawa/reflect/ClassMethods.java.
	* kawa/standard/field.java:  Replaced by gnu/kawa/reflect/SlotGet.java.
	* kawa/standard/Scheme.java:  Update for new or moved procedures.
	* kawa/lang/Makefile.am:  Update accordingly.
	* kawa/standard/Makefile.am:  Likewise.

	* kawa/standard/list_v.java (list$V):  New method.

1999-09-08  Per Bothner  <per@bothner.com>

	* kawa/lang/InvokeStatic.java:  Get rid of lots of crud by
	using kawa.standard.class_methods.
	
	* kawa/lang/CompileFile.java (read):  Set filename of ModuleExp.
	* kawa/lang/Translator.java (scan_form):  Copy line number info.
	* kawa/lang/Lambda.java (rewrite):  Set line number info on
	parameter Declarations.

	* kawa/standard/define.java (rewrite):  Replace by rewriteForm.

	* kawa/lang/{Pair.java,Vector.java}:  Update scmObjectType->typeObject.

1999-09-05  Per Bothner  <per@bothner.com>

	* kawa/lang/Translator.java (error):  New method.
	(syntaxError):  Use new method.
	(rewrite_pair):  If car is Syntax, then apply_rewrite.
	(scan_form);  New method, with code moved from scan_body.
	(finishModule):  New method.
	* kawa/lang/Interpreter.java (getName):  New method.
	* kawa/lang/CompileFile.java (read):  Now read each line, and
	does Translator.scan_form separate on each statement.
	(read, readBody):  No long throw SyntaxException.
	(compile_to_files):  Takes SourceMessages parameter;  returns void.
	* kawa/repl.java:  Use new compile_to_files interface.

	* Shell.java (run):  Skip whitespace in case read is called.

	* kawa/lang/Macro.java (expand):  Add quotes in error message.

	* kawa/lang/ScmRead.java (readNumber):  A quantity like 12in is
 	no longer a literal, but returns a form like (* 12 in$unit).
	(readString):  Use readEscape.
	* kawa/standard/ScmEnv.java:  Also handle UNITNAME$unit.

	* kawa/standard/location.java (rewrite):  Handle static bindings.

	* kawa/standard/Scheme.java:  Define read-line and define-private.
	(eval):  Update for new CompileFile.readBody interface.
	(makeModuleExp):  Use scan_body instead of lambda.rewrite.
	(getNamedType):  "java.lang.String" is no longer bound to
 	Type.string_type (though "String" still is).
	* kawa/standard/define_syntax.java (rewrite):  Handle the case when
	the macro "name" is a Declaration (created by Translator.scan_form).
	* kawa/standard/define.java:  Likewise.
	Also add support for define-private.

	* kawa/standard/read_line.java:  New class;  extends ProcedureN.
	* kawa/standard/Makefile.am (java_JAVA):  Add read_line.

	* kawa/lang/Sequence.java (toArray):  Use an Emueration.
	* kawa/lang/List.java (list1, list2, list3):  New convenience methods.
	* kawa/lang/FString.java:  Do two new constructors.
	
1999-08-26  Per Bothner  <per@bothner.com>

	* kawa/lang/Interpreter.java (getTypeFor):  New abstract method
	* kawa/standard/Scheme.java (getTypeFor):  New method.

	* kawa/lang/Syntax.java:  Now inherits from Declaration.
	* kawa/lang/AutoloadSyntax.java:  Replace each name() by getName().
	* kawa/standard/prim_method.java:  Likewise.
	* kawa/standard/Scheme.java (define_syntax):  New methods needed.

	* kawa/lang/Macro.java:  Merge in functionality of DefMacro.
	* kawa/lang/DefMacro.java:  Removed - subsumed by Macro.
	* kawa/lang/Makefile.am, Makefile.in (java_JAVA): Remove DefMacro.java.
	(<init>):  Re-do correspondingly.
	* kawa/lang/SyntaxRule.java (captured_decls):  New field.
	(<init>):  Save current visible local Declarations in captured_decls.
	(execute_template):  Map renamed symbol to captured decl, if any.
	* kawa/lang/Translator.java (getGlobalEnvironment):  New method.
	(push, pop):  Immediately return if Declaration's name is null.
	(getBinding):  If lexical binding is Syntax, return that.
	(rewrite_pair):  Simpler test if car is non-lexically bound to Syntax.
	If no lexical binding, don't call getBinding;  just check global env.
	(scan_body):  Handle define-alias.

	* kawa/standard/define.java (rewrite):  Re-organize.
	* kawa/standard/define_alias.java:  Now also handle non-top-level uses.
	* kawa/standard/define_syntax.java:  Replace DefMacro uses by Macro.
	* kawa/standard/let_syntax.java:  Now also handles letrec-syntax.

	* kawa/standard/class_methods.java:  New class; extends ProcedureN.
	* kawa/standard/Makefile.am (java_JAVA):  Add class_methods.java.
	* kawa/standard/Scheme.java:  Update accordingly.

1999-08-22  Per Bothner  <per@bothner.com>

	* kawa/lang/Quote (rewrite): Don't use Patterns.

	* kawa/lang/Sequence (toArray):  Allocate correct array type,
	as specified by Java2 Collections.

	* kawa/lang/PairWithPosition.java (<init>):  New constructor.

	* kawa/MessageArea.java:  Remove redundant import java.lang.*.

	* kawa/lang/AutoloadSyntax.java (rewrite):  Replace by rewriteForm.

	* kawa/lang/SyntaxRule.java (execute_template, both overloadings):
  	Take the input form as an extra argument.  Use this to copy line
 	position of input (if known) to expansion.

	* kawa/lang/Translator.java:  More general macro framework:
	A macro has an arbitrary expansion precedure (possibly using
	syntax-case), which is called with a SyntaxForm.
  	Also, some better line number handling and error message hooks.
	* kawa/lang/Syntax.java (rewriteForm):  New preferred method to
	override, instead of (still-available) rewrite.
	* kawa/lang/Macro.java (rewriteForm):  Method replaces rewrite.
	(expand):  Takes a complete form, not just the argument list.
	* kawa/lang/DefMacro.java:  Re-write - expander now takes a single
	SyntaxForm, rather than an array of forms.  Also, provide hook for
	not-yet-evaluated expression instead of expander Procedure.
	* kawa/lang/SyntaxRules.java:  Now inherit from Procedure1.
	(apply1):  New methods - calls expand.
 	(expand):  Update interface to take Pair.
	* kawa/standard/location.java (rewriteArg):  Update expand call.
	* kawa/lang/SyntaxForm.java:  New class.

	* kawa/lang/InvokeStatic:  New class.
	
	* kawa/lang/EqualPat.java (print):  Tweak the output.
	* kawa/lang/Pattern.java (typePattern, matchPatternMethod):
  	New static fields.
	* kawa/lang/ListRepeatPat.java:  Use Pattern.typePattern.
	* kawa/lang/PairPat.java:  Likewise.
	(match):  If input is SyntaxForm, match its contained form.

	* kawa/standard/syntax_case.java:  New Syntax class.
	* kawa/standard/syntax_rules.java:  New Syntax class.
	* kawa/standard/let_syntax.java:  New Syntax class.
	* kawa/standard/Scheme.java:  Define new macros.
	(exp2Type):  New method.
	* kawa/standard/define_syntax.java:  No-longer handles
	the syntax-rules part now that syntax-rules is stand-alone.
	* kawa/standard/Makefile.am:  Update for new classes.

	* kawa/standard/eq_p.java (compile):  New static method.
	* kawa/standard/eqv_p.java:  Make Inlineable.
 	(isEqv):  Rename to apply.

1999-08-08  Per Bothner  <per@bothner.com>

	* configure.in, configure (AC_OUTPUT):  Update for gnu.jemacs change.
	* kawa.repl (setInterpreter):  Update ELisp package prefix.

	* kawa/lang/ListPat.java:  New static match methods.
	* kawa/standard/ifp.java (rewrite):  Use static ListPat.match method.

1999-08-07  Per Bothner  <per@bothner.com>

	* kawa/lang/GetFieldProc.java (compile):  Don't inline if class was
 	loaded with an ArrayClassLoader.
	* kawa/lang/SetFieldProc.java (compile):  Likewise.
	* kawa/lang/Record.java (toString):  Don't print static fields.
	
1999-08-06  Per Bothner  <per@bothner.com>

	* configure.in (AC_OUTPUT):  Revert use of javatop macro.

	* kawa/lang/Sequence.java (elements):  New method.
	(SeqEnumeration):  New non-public class.
	* kawa/lang/List.java (elements):  New method.
	(ListEnumeration):  New non-public class.

	* kawa/lang/Interpreter.java (getNewEnvironment):  New method.
	* kawa/standard/Scheme.java (getNewEnvironment):  New method.
	* kawa/GuiConsole.java:  Separate Environment from Interpreter.
	* kawa/repl.java (main):  Use new GuiConsole constructor.

	* kawa/Shell.java (run):  No longer need to explicitly catch WrongType.
	Change confusing message for ClassCastException.
	* kawa/lang/Translator.java (rewrite_pair):  If directly calling
	an inlined PrimProcedure, set the name (for better error messages).
	* kawa/standard/car.java: Catch ClassCastException instead of
	using instanceof.
	* kawa/standard/cdr.java:  Likewise.

1999-08-03  Per Bothner  <per@bothner.com>

	* configure.in (AC_INIT):  Use doc/kawa.texi instead of kawa/repl.java.
	(AC_OUTPUT):  Use (normally undefined) javatop macro.
	* Makefile.am (JAVATOP):  New (normally undefined) macro.

1999-07-20  Per Bothner  <per@bothner.com>

	* kawa/Makefile.am, kawa/Makefile.in (BUILT_SOURCES, Version.java):
	Moved to ./Makefile.am, to make sure Version.java is built first.
	* Makefile.am, Makefile.in (makekawa.bat):  New rule.

1999-07-19  Per Bothner  <per@bothner.com>

	* configure.in:  Set version to 1.6.59.

	* kawa/standard/TracedProcedure.java:  New ProcedureN class.
	* kawa/standard/Makefile.am (java_JAVA):  Add TracedProcedure.java.
	* kawa/standard/ObjectFormat.java (format):  New overload.
	* kawa/standard/Scheme.java (initScheme):  Define call/cc (alias),
	system-tmpdir, make-temporary-file, trace, untrace.

1999-07-16  Per Bothner  <per@bothner.com>

	* kawa/GuiConsole.java (<init>):  Create a kawa.repl, not a kawa.Shell.
	* kawa/Shell.java:  No longer inherits from Procedure0.
	All methods are static;  most now take an explicit Environment
	(for top-level bindings) as well as Interpreter (current language).
	* kawa/repl.java:  Now extends Procedure0or1.
	(apply0, apply1):  New methods.
	(interp):  New instance field.
	(<init>):  New constructor.
	(defaultInterpreter):  New static field.
	(getInterpreter, setInterpreter):  New static methods.
	(main):  Options to select interpreter (language).
	(serveTelnet):  Take Interpreter argument.
	Create a new SocketRepl, instead of a new Shell.
	(SocketRepl):  New Procedure0 class.

	* kawa/lang/Sequence.java (toArray):  Implement two new methods.
	* kawa/lang/Pair.java (toArray):  Implement optimized versions.
	* kawa/lang/FString.java (toCharArray):  New method.

	* kawa/lang/Interpreter.java (getLexer):  New abstract method.
	* kawa/standard/Scheme.java (getInstance, getLexer):  New methods.
	(initScheme):  Declare "repl".  Change "emacs.read".
	* kawa/standard/load.java (loadSource):  Use Scheme.getInstance.

	* kawa/standard/convert.java (compile):  Use Target.pushValue.


1999-07-11  Per Bothner  <per@bothner.com>

	* kawa/lang/Char.java (charNameValues, charNames):  Add "bel" for ^G.

1999-06-30  Per Bothner  <per@bothner.com>

	* **/Makefile.in:  Re-generated.
	* **/Makefile.nt, **/Makefile.unix:  Remove - not used in years.
	* kawa/standard/ObjectFormat.java (format):  Optimize if no length
 	truncation is needed, especially if dst is CharArrayWriter.
	* kawa/standard/LispFormat.java (LispRealFormat):  New class.
	(LispFreshlineFormat):  New non-public ReportFormat class.
	(LispTabulateFormat.padChar):  New field.
	(LispTabulateFormat.format):  Re-write - now works.
	(LispFormat.<init>):  Working support for ~F, ~E, ~G, ~$, ~T, ~&.

1999-06-20  Per Bothner  <bothner@pacbell.net>

	* configure.in:  Add new --with-swing option.
	Also configure gnu/emacs/Makefile.
	
1999-04-25  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/object.java (rewrite):  Fields have unknown value.

1999-04-23  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/lang/Translator.java (errors):  Removed field.
	(messages):  New gnu.text.SourceMessages field.
	(syntaxError):  Don't print messages;  invoke messages.error instead.
	* kawa/lang/Eval.java (eval):  Create new SourceMessages.
	(evalBody):  Add and use new SourceMessages parameter.
	* kawa/lang/Lambda.java:  Update for new SourceMessages convention.
	* kawa/lang/ScmRead.java (<init>):  New overload taking SourceMessages.
	(readSymbol):  Handle `::' as a symbol, not a keyword.
	(readObject):  Handle [ ... ].
	* kawa/lang/CompileFile.java:  Use new SourceMessages conventions.
	* kawa/standard/Scheme.java:  Declare new precedure subtype?.
	(getNamedType):  Add character.
	(eval):  Catch SyntaxException.
	* kawa/standard/let.java:  Handle :: TYPE specifier.
	* kawa/standard/letrec.java:  Handle :: TYPE specifier.
	* kawa/standard/load.java:  Use new SourcesMessages class.
	* kawa/Shell.java (run):  New new SourceMessages conventions.
	* kawa/repl.java:  When compiling, catch SyntaxException.

	* kawa/lang/SyntaxRule.java (execute_template):  Move DEBUGGING comment
	* kawa/lang/SyntaxRules.java (expand):  ... to here.

1999-04-22  Per Bothner  <bothner@cygnus.com>

	* kawa/standard/object.scm (rewrite):  Do setClassMethod on $finit$.

1999-04-09  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/Translator.java (systemClassLoader):  New private field.
	(rewrite_pair):  Compare with systemClassLoader.

Wed Apr  7 21:52:19 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/lang/Translator.java (isLexical):  New method.
	(getBinding, rewrite):  Call isLexical.
	* kawa/standard/fluid_let.java:  New Syntax class.
	* kawa/standard/Makefile.am (java_JAVA):  Add fluid_let.java.
	* kawa/standard/Scheme.java:  fluid-let is now written in Java.
	* kawa/standard/let.java (pattern2):  Remove unused static field.
	* kawa/standard/location.java (rewrite):  Check that !isFluid().
	* kawa/standard/set_b.java (rewrite):  Check that decl is lexical.

Tue Mar 30 17:52:57 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/object.java (rewrite):  Call LambdaExp.setClassMethod.

Sat Mar 20 11:23:48 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* configure.in (AC_OUTPUT), configure:  Add gnu/elisp/Makefile.

	* kawa/lang/Macro.java:  New Syntax sub-class.
	* kawa/lang/Makefile.am (java_JAVA):  Add Macro.java.
	* kawa/lang/SpecialType.java:  Inherit from Macro rather than Syntax.
	(rewrite1):  Rename to expand (overrides) Macro.
	(rewrite):  Removed - now in Macro.
	* kawa/lang/DefMacro.java:  Inherit from Macro rather than Syntax.
	(rewrite):  Replace by Macro.expand method.
	* kawa/lang/Translator.java (getBinding):  Use gnu.expr.Binding.
	(scan_body): Scan for the more general Macro, rather than SyntaxRules.
	* kawa/lang/Record.java (get):  Renamed to getChecked.

	* kawa/standard/Scheme.java (voidType):  New static Type field.
	(getNamedType):  USe voidType.
	(initScheme):  Define define-alias and emacs:read.
	* kawa/standard/ScmEnv.java (getType):  New helper method.
	(ScmEnvConstraint):  New helper class.
	(<init>):  Set unboundConstraint to new ScmEnvConstraint.
	* kawa/standard/call_with_values.java (apply(CallStack)):  New method.
	* kawa/standard/location.java (rewriteArg):  New static method.
	(rewrite):  Handle macros and both global and local variables.
	* kawa/standard/constant_fold.java (checkConstant):  Just call
	get(Object) - which does not throw exception if undefined.
	
	* kawa/standard/define_alias.java:  New Syntax sub-class.
	* kawa/standard/Makefile.am (jav_JAVA):  Add define_alias.java.

Sun Mar  7 16:42:02 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/repl.java:  New flags --full-tailscalls and --no-full-tailcalls.
	* kawa/lang/AutoloadProcedure.java (load):  ModuleBody.run no longer
	takes any argument.
	* kawa/lang/AutoloadSyntax.java (load):  Likewise.
	* kawa/lang/Promise.java:  Change thunk from Procedure0 to Procedure.
	* kawa/lang/Record.java (typeFieldNames):  Skip static fields.
	* kawa/standard/Scheme.java (env_formal, moduleFormals):  Removed.
	* kawa/standard/apply.java:  Handle full tailcall-elimination.
	* kawa/standard/{let.java,letrec.java}:  Handle type specifiers.
	* kawa/standard/load.java:  ModuleBody.run no longer takes 

Tue Feb  9 11:39:20 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/{string2symbol,symbol2string}.java:  Replaced
	by Scheme code in ../lib/misc.scm.
	* kawa/standard/{sin,cos,tan}.java: Replaced by code in numbers.scm.
	* kawa/standard/Scheme.java:  Update to get new implementations.
	* kawa/standard/Makefile.am:  Updated for removed classes.

Mon Feb 22 22:19:00 1999  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version to 1.6.58.
	Update AM_EXEEXT -> AC_EXEEXT.  Move AC_PROG_CC before AC_EXEEXT.
	* Makefile.am (kawa-compiled.zip):  New rule.
	* **/Makefile.in:  Re-generate using automake 1.4.
	* aclocal.m4:  Re-generate using aclocal 1.4.
	* configure:  Re-generate using autoconf 2.13.

Fri Jan  1 22:13:41 1999  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* configure.in:  Set version to 1.6.57.
	* Makefile.am, Makefile.in (install-javadoc-html):  New rules.
	* kawa/Makefile.am (EXTRA_DIST):  Add  Version.java.in.

	* kawa/TelnetConnection.java:  New class - for telnet connection.
	* kawa/TelnetInputStream.java:  New class.
	* kawa/TelnetOutputStream.java:  New class.
	* kawa/Telnet.java:  New class - a mini-client for telnet.
	* kawa/kawa.c:  New front-end driver for Kawa.
	* kawa/Makefile.am:  Support building and installing kawa front-end.
	* kawa/Shell.java (socket):  New field.
	(apply0):  If socket field is non-NULL, close it on exit.
	* kawa/repl.java (serveTelnet):  New method.
	(main):  Support new flags --connect and --server.
	* configure.in:  Support new --enable-kawa-frontend flag.
	* */Makefile.in:  Re-generated.

Wed Dec 23 15:10:03 1998  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/object.java (rewrite):  Handle field initialization.
	Set fields declarations to both redaable and writable.

Tue Dec 15 18:35:44 1998  Per Bothner  <bothner@cygnus.com>

	Moved Kawa source repository to sourceware.cygnus.com.
	* config.guess, config.sub, install-sh, missing, mkinstalldirs:
	Copied over scripts shared by most GNU programs.
	* Makefile.am (config,guess, config.sub, install-sh, mkinstalldirs):
	Removed no-longer needed rules.

Tue Dec 15 10:31:38 1998  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/object.java:  Support field declarations,
	and put field declarations in scope of methods.
	
Tue Nov 24 23:05:36 1998  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* configure.in:  Set version to 1.6.56.

	* kawa/lang/PrimGetStatic.java (getReturnType):  New method.
	* kawa/lang/PrimSetStatic.java (getReturnType):  New method.
	* kawa/lang/PrimArrayNew.java (getReturnType):  New method.
	* kawa/lang/PrimArrayGet.java (getReturnType):  New method.
	* kawa/lang/PrimArraySet.java (getReturnType):  New method.
	* kawa/lang/PrimArrayLength.java (getReturnType):  New method.
	* kawa/lang/SetFieldProc.java (getReturnType):  New method.
	* kawa/standard/convert.java (getInstance):  New static method.
	* kawa/lang/GetFieldProc.java: (getReturnType):  New method.
	Use RuntimeException instead of GenericError.

	* kawa/lang/Lambda.java (rewrite):
	Syntatic sugar:  <TYPE> BODY --> (as <TYPE> BODY)

	* kawa/lang/Translator.java (mustCompileHere):  Make public.

	* kawa/standard/Scheme.java:  Use convert.getInstance().
	* kawa/standard/{convert.java,eq_p.java,instance.java,not.java,
	prim_throw.java} (getReturnType):  New methods.

	* kawa/standard/object.java:  New Syntax class.

	* kawa/standard/field.java:  New Procedure2 class.
	* kawa/standard/static_field.java:  New Procedure2 class.
	* kawa/standard/Scheme.java:  Defined new procedures and syntax.
	* kawa/standard/Makefile.am (java_JAVA):  Added new classes.

Sun Nov 15 19:18:20 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/standard/ScmEnv.java:  New Environment class.
	* kawa/standard/Makefile.{am,in} (java_JAVA):  Add ScmEnv.java.
	* kawa/standard/Scheme.java (builtin):  Create new ScmEnv.
	* kawa/lang/Record.java:  Inherit from NameMap, not Procedure1.
	* Makefile.am, Makefile.in:  Work-around for automake (dist) problem.

Sat Oct 17 14:16:05 1998  Per Bothner  <bothner@Magnus.Cygnus.COM>

	* kawa/standard/synchronizd.java:  New Syntax.
	* kawa/standard/Makefile.{am,in} (java_JAVA):  Add synchronizd.java.
	* kawa/standard/Makefile.in
	* kawa/standard/Scheme.java:  Define synchronized syntax.

	* kawa/standard/not.java (compile):  Use new emitNot interface.
	* kawa/lang/SpecialType.java (emitCoerceToObject):  Update emitConvert.

Fri Sep 11 22:29:26 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/repl.java (main):  Handle new --debug-dump-zip option.

	* kawa/lang/CalledContinuation.java:  Make fields public.
	* kawa/lang/Continuation.java (callcc):  Replaced by callcc.apply.
	* kawa/standard/callcc.java (apply):  New static method.

	* kawa/lang/Lambda.java:  Don't add argsArray yet.
	Handle parameter type specification.
	* kawa/lang/PrimProcedure.java:  Moved to gnu.expr.
	* kawa/lang/Makefile.in:  Update accordingly.
	* kawa/lang/SpecialType.java (charValue):  New method.

	* kawa/standard/Scheme.java (getNamedType, string2Type):
	Moved here from PrimProcedure.
	* kawa/standard/prim_method.java:  Updated for moved methods.

	* kawa/standard/{car,cdr,cons,make_vector,callcc}.java:
	Add static apply methods.
	* kawa/standard/letrec.java (rewrite):  Initial value is now null,
	because that is compatible with stricter typing scheme.
	* kawa/lang/Translator.java (rewrite_body):  Ditto for internal define.
	* kawa/standard/{setcar_b,setcdr_b}.java:  Removed, now in lists.scm.
	* kawa/standard/{string_ref,string_set_b}.java:  Replaced.
	* kawa/standard/Makefile.am:  Update accordingly.

Sat Aug 29 20:50:05 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/standard/{plus_oper,minus_oper,multiply_oper,greater_oper}.java:
	Add static apply methods, to allow compiling direct calls.
	* kawa/lang/*.java:  Do ClassType.make instead of new ClassType.
	* kawa/lang/AutoloadProcedure.java (getLoaded, numArgs):  New methods.
	* kawa/lang/PrimProcedure.java (<init>):  Set right opcode from method.
	* kawa/lang/Translator.java (rewrite_pair): Directly call static apply.

Sat Aug 29 09:12:55 1998  Per Bothner  <bothner@cygnus.com>

	* **/Makefile.in, configure, aclocal.m4:  Re-generated.
	* kawa/Makefile.am (Version.java):  Depend on configure.in.

1998-08-28  Per Bothner  <bothner@cygnus.com>

	* configure.in (AC_CONFIG_AUX_DIR):  Removed.
	Set version to 1.6.55.
	* install-sh, mkinstalldirs:  Removed, now gotten from .. .

	* kawa/lang/Translator.java (resolve):  Remove.
	* kawa.standard/location.java:  New Syntax.
	* kawa/standard/Makefile.am, kawa/standard/Scheme.java:  Update.
	* kawa/standard/{define.java,set_b}.java:  Translator.resolve is now gone.

Mon Aug  3 13:21:22 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/FString.java (hashCode):  Fix typo:  32 -> 31.

Fri Jul 24 16:05:10 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/standard/makeProcLocation.java:  New helper class.
	* kawa/standard/Makefile.am (java_JAVA):  Add makeProcLocation.java.
	* kawa/standard/Scheme.java:  Define location and %makeProcLocation.

	* kawa/lang/FString.java (hashCode):  New method.
	* kawa/lang/ScmRead.java (readSymbol):  Allow :KEY as well as KEY:.

Tue Jul 21 23:19:35 1998  Per Bothner  <bothner@cygnus.com>

	* gnu/mapping, gnu/expr:  New packages.
	* kawa/lang:  Moved many classes from here to gnu.mapping or gnu.expr.
	* kawa/{,lang,standard}:  Update import statements.
	* configure.in (AC_OUTPUT):  Add gnu/{mapping,expr}/Makefile.
	* Makefile.am (install-html):  Simplify to call gnu/Makefile.
	* kawa/lang/SchemeLoader.java:
	Moved to gnu/bytecode/ArrayClassLoader.java.
	* kawa/standard/Scheme (makeModuleExp):  New function.
	* kawa/standard:  Some functions moved to kawa.lib.
	
	* configure.in:  Set version to 1.6.54.

Sun Jun 28 23:07:49 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version to 1.6.53.
	(AC_OUTPUT):  Add gnu/text/Makefile.

	* kawa/lang/ApplyExp.java (compile):  Fix incorrect implementation
	of tail-recursion.  Use CodeAttr.emitTailCall.
	* kawa/lang/LambdaExp.java (start_label):  Removed - no longer needed.
	* kawa/lang/Compilation.java (addClass):  Don't set lexp.start_label.

	* kawa/lang/Char.java:  Add some extra named characters.
	(toScmReadableString):  New method.  May emit octal form.
	(print):  Use toScmReadableString.
	* kawa/lang/FString.java (makeUpperCase, makeLowerCase,
	makeCapitalize):  New methods.

	* kawa/lang/Special.java (dfault):  New static.
	* kawa/lang/Keyword.java (searchForKeyword):  If no match, return
	Special.dfault, not null, to allow #!null as a default.
	* kawa/lang/Compilation.java (addClass):  Update for new default
	return value of searchForKeyword (Special.dfault).
	
	* kawa/lang/LambdaExp.java (<init>):  Set file name.
	* kawa/lang/{Lexer.java, LineBufferedReader.java, SourceError.java,
	SyntaxException.java}:  Moved to gnu.text package.
	* kawa/Shell.java, kawa/lang/{CompileFile,InPort,Interpreter}.java,
	kawa/standard/read.java:  Update because of moved classes.
	* kawa/lang/{Makefile.am/Makefile.in}:  Update accordingly.
	* kawa/lang/PairWithPosition.java (<init>):  Use LineBufferedReader.
	* kawa/lang/ScmRead.java (readCharacter):  Support octal notation.
	(readSpecial):  Read #!default as Special.dfault.
	Add some casts to (InPort) to get readState.  Yuck.

	* kawa/standard/LispFormat.java:  New class - Common Lisp-style format.
	* kawa/standard/ObjectFormat.java:  New - plain Object formatting.
	* kawa/standard/ParseFormat.java:  New Procedure1.
	* kawa/standard/Makefile.am, Makefile.in:  Update for new classes.
	* kawa/standard/Scheme.java:  Update for new procedures.

Sun May 24 13:13:52 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version to 1.6.52.

Thu May 21 21:38:24 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/Lexer.java:  New class (extends Reader).
	* kawa/lang/ScmRead.java:  New class (extends Lexer).
	* kawa/lang/SourceError.java:  New class.
	* kawa/lang/SyntaxException.java:  New class (extends Exception).
	* kawa/lang/ReadError.java:  No longer used.
	* kawa/lang/EofReadError.java:  No longer used.
	* kawa/lang/InPort.java:  Scheme reader methods now in ScmRead,
	* kawa/lang/Interpreter.java (read):  New throws SyntaxException.
	* kawa/lang/Makefile.am:  Update for new and removed classes.
	* kawa/standard/read.java:  Update for new reader.
	* kawa/standard/string2number.java (parse):  Update for new reader.
	Optimize - don't convert <string> to <String> to char[].
	* Shell.java:  Changes for new Lexer framework.

	* */Makefile.in:  Update for automake 1.3.

	* kawa/lang/LambdaExp.java (<init>):  Handle #!null as default arg.

	* kawa/lang/CompileFile.java (readBody):  New method.
	* kawa/lang/Eval.java (eval):  Re-organize methods.
 	(evalBody):  New method.  Save and restore current Environment.
	* kawa/lang/ModuleExp.java (eval_module):  Rename to evalModule.
	* kawa/standard/Scheme.java (eval):  Use Eval.readBody.

	* kawa/lang/PrimProcedure.java (getNamedType): Add <record>, <type>,
	and <class-type>.
	* kawa/lang/Record.java (makeRecordType):  Return ClassType, not Class.
	(typeFieldNames):  New overload taking ClassType.
	* kawa/lang/RecordConstructor.java (numArgs):  New method.
	(applyN):  Throw WrongArguments if wrong number of arguments.
	(getname):  New method.
	(<init>):  New constructor takes ClassType (overloaded with Class).
	* kawa/lang/SetFieldProc.java (<init>):  Add overload taking ClassType.
	* kawa/lang/GetFieldProc.java:  Likewise.

Tue Apr 28 21:58:49 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/Makefile.am: Change AUTOMAKE_OPTIONS to cygnus.

Mon Apr 27 00:03:51 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/LambdaExp.java (declareThis):  New method.
	Make some fields public (for EcmaScript).

	* kawa/lang/SysInPort.java (fill): Work-around for NTEmacs shell mode.
	* kawa/lang/TtyInPort.java (tie):  Make protected.

	* kawa/lang/InPort.java (readSchemeReal):  Cleaner (and more
 	portable I hope) handling of inexact zero denominator.

Tue Apr 14 10:09:17 1998  Patrick Barta <patr@welchlink.welch.jhu.edu>

	* kawa/lang/InPort.java (readSchemeReal):  Simplification that
	avoids javac (on NT) problem.

Sat Apr  4 17:53:18 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version number to 1.6.51.
	
	* kawa/lang/Char.java (toString):  New method.

	* kawa/lang/ConditionalTarget.java:  New Target class.
	* kawa/lang/Compilation.java (compileConstant):
	Handle ConditionalTarget.
	* kawa/lang/QuoteExp.java (voidExp, trueExp):  New statics.
	* kawa/lang/IfExp.java (compile):  Re-write to use ConditionalTarget.

	* kawa/lang/TryExp.java (compile):  Let CodeAttr handle saving result.

	* kawa/lang/Future.java (<init>):  Initialize in, out, and err fields.
	(waitForResult):  Simplify exception handling.

	* */Makefile.am:  Re-write to compile all out-of-date *.java at once.

	Changes for gnu.ecmascript:
	* kawa/lang/LineBufferedReader.java (pos, limit, buffer):  Make public.
	* kawa/lang/InPort.java (readOptionalExponent):  Make public.
	* kawa/lang/EofReadError.java (<init>):  Make public.
	* kawa/lang/Compilation.java (trueConstant, falseConstant):  Likewise.

	* kawa/standard/{eq_p, not}.java:  Inline; handle ConditionalTarget.
	* kawa/standard/Scheme.java (initScheme):  Get 'and from kawa.lib.
	Added port-line, port-column, and set-port-line! (from Guile).

	* kawa/repl.java (main):  Allow multiple source files after -C flag.

	* kawa/Version.java.in:  Use VERSION instead of @VERSION@ as template.
	* kawa/Makefile.am (Version.java):  New generated at build time.
	(EXTRA_DIST):  Also distribute generated Version.java.
	* configure.in (AC_OUTPUT):  Remove kawa/Version.java.
	
Fri Mar 13 22:11:59 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/Target.java:  New abstract class - represents the
 	destination for the value of an Expression.
	* kawa/lang/{StackTarget.java,TailTarget.java,IgnoreTarget.java}:
	New classes that extend Target.
	* kawa/lang/Makefile.am:  Update for new target classes.
	* kawa/lang/Expression.java (compile):  Take Target instead of flags.
	(IGNORED, LAST):  Removed flags.
	(compile_with_linenumber): Renamed to compileWithPosition; take Target.
	* kawa/lang/Compilation.java (compileConstant):  New overload.
	* kawa/lang/{ApplyExp.java,BeginExp.java,CatchClause.java,
	Compilation.java,ErrorExp.java,GetFieldProc.java,IfExp.java,
	Inlineable.java,LambdaExp.java,LetExp.java,PrimArrayGet.java,
	PrimArrayLength.java,PrimArrayNew.java,PrimArraySet.java,
	PrimGetStatic.java,PrimProcedure.java,PrimSetStatic.java,QuoteExp.java,
	ReferenceExp.java,SetApplyExp.java,SetExp.java,SetFieldProc.java,
	TryExp.java} (compile):  Update to take a Target.
	* kawa/standard/{convert.java,instance.java,prim_throw.java}: Likewise.

Wed Mar 11 17:00:00 1998  Per Bothner  <bothner@cygnus.com>

	Kawa version 1.6 released.

Tue Mar 10 20:01:37 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/ApplyExp.java (getFunction):  New method.
	* kawa/lang/PrimArrayNew.java (compile):  Fix compile target type bug.
	* kawa/lang/PrimProcedure.java (applyN):  Use coerced args values.
	* kawa/lang/PrimArraySet.java (compile):  Convert value.

	* kawa/standard/Scheme.java (getTypeValue):  New static method.
	(initScheme):  Add "constant-fold", "system", and more.  Minor fixes.
	* kawa/standard/Makefile.am:  Update.
	* kawa/standard/constant_fold.java:  New Syntax.
	* kawa/standard/{convert.java,instance.java}:  Use Scheme.getTypeValue.
	Various small fixes and improvements.

Mon Mar  9 17:53:33 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/SysInPort.java:  New TtyInPort class.
	* kawa/lang/InPort.java (systemInPort, defaultInPort):  Replace inp.
	(systemInPort):  Is now a SysInPort, instead of TtyInPort.
	* kawa/lang/Makefile.am:  Update accordingly.

	* kawa/lang/PairWithPosition.java:  Line and column nums are 1-origin.

	* kawa/lang/PrimProcedure.java (compile):  Renamed for gnu.bytecode.

	* kawa/lang/ReferenceExp.java (getName, getBinding):  New methods.
	* kawa/lang/PrimArraySet.java (apply3):  Convert value.
	* kawa/lang/SetFieldProc.java (apply2):  Add type convertion.

Tue Mar  3 11:51:08 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in (AC_OUTPUT):  Generate kawa/Version.java.
	* kawa/{Makefile.am,kawa/Makefile.in}: Update to generate Version.java.
	* kawa/repl.java (main):  Handle --version and --main.
	Moving definition of symbol-read-case to Scheme.java.
	* kawa/Version.java.in:  New template used to generate Version.java.
	* kawa/lang/Compilation.java (generateMain, generateMainDefault):  New.
	(addClass):  Generate main method if generateMain is true.
	* kawa/lang/ModuleBody.java (runAsMain):  New method.

	* kawa/lang/{ApplyExp.java,Compilation.java,Literal.java,
	ReferenceExp.java,SetApplyExp.java,SetExp.java,SyntaxRules.java,
	Vector.java}:  Update for moved gnu.bytecode methods.

	* kawa/lang/{GetFieldProc.java,SetFieldProc.java}:  Rewrite to
	work with ClassType (not just Class) and implement Inlineable.
	* kawa/lang/{PrimGetStatic.java,PrimSetStatic.java}:  New Procedures.
	* kawa/lang/{PrimArrayGet.java,PrimArrayLength.java,
	PrimArrayNew.java,PrimArraySet.java}:  New Inlineable Procedures.
	* kawa/lang/{Makefile.am,Makefile.in}:  Update for new classes.
	* kawa/standard/Scheme.java:  Add new methods from kawa.lib.reflection.

	* kawa/lang/LineBufferedReader.java (fill):  Fix minor think-o.
	* kawa/lang/TtyInPort.java (fill):  Likewise.

Tue Feb 24 18:32:21 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/Keyword.java (getName):  New method.

	* kawa/lang/HasSetter.java:  New interface.
	* kawa/lang/Procedure.java (getSetter, set0, set1, setN):  New methods.
	* kawa/lang/Compilation.java:  Make various static values public. 
	* kawa/lang/SetApplyExp.java:  New Expression class.
	* kawa/lang/Setter.java:  New class, extends ProcedureN.
	* kawa/lang/Setter0.java:  New. A 0-argument (not counting RHS) Setter.
	* kawa/lang/Setter1.java:  New. A 1-argument (not counting RHS) Setter.
	* kawa/lang/Makefile.am:  Update for new classes.
	* kawa/lang/AutoloadProcedure.java (getSetter):  New method.
	* kawa/standard/set_b.java (rewrite):  Handle (set! (f . args) v).

	* kawa/lang/Record.java (apply):  Added, since we extend Procedure1.
	(set1):  Method added, as implementation of interface HasSetter.
	(print):  Method added, overrides Procedure.print.
	* kawa/lang/Named.java (sym_name):  Change from public to protected.

	* kawa/lang/Translator.java (rewrite):  Don't check for <TYPE> here.
	* kawa/lang/ReferenceExp.java (lookup):  New method, checks for
 	<TYPE>, but only if otherwise not defined.
	(eval, compile):  Use lookup to handle "<NAME>".

	* kawa/standard/car.java (set1):  New, to implement HasSetter.
	* kawa/standard/cdr.java (set1):  New, to implement HasSetter.
	* kawa/standard/cxr.java (set1):  New, to implement HasSetter.
	* kawa/standard/setter.java:  New Procedure1 class.
	* kawa/standard/make.java:  New ProcedureN class.
	* kawa/standard/Makefile.am, kawa/standard/Scheme.java:  Update.

Thu Feb 19 18:36:18 1998  Per Bothner  <bothner@cygnus.com>

	* Makefile.am, Makefile.in (kawa-@VERSION@-compiled.zip):  Build
	archive from .class files in ".", not installed ones.

	* kawa/lang/InPort.java:  New constructors controlling char conversion.
	(convertToReader, openFile):  New static methods. 
	(readChar, readString):  Always convert CR and CRLF to LF.
	* kawa/lang/TtyInPort.java:  Always convert CR and CRLF to LF.
	* kawa/standard/open_input_file.java:  Simplify - logic
	for selection char encoding is now in InPort.openFile.
	* kawa/lang/CompileFile.java (read):  Use new InPort.openFile method.
	* kawa/Shell.java (runFile):  Likewise.
	* kawa/standard/call_with_input_file.java (apply2):  Likewise.
	* kawa/standard/with_input_from_file.java:  Likewise.
	* kawa/standard/load.java (loadSource, apply2):  Likewise.

Wed Feb 18 22:12:13 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/standard/open_input_file.java:  If binary file, do setBuffer.
	Do setConvertCR(true) for text files.
	* kawa/lang/LineBufferedReader.java:  Fix so line and column numbers
	will be correct for CRLF is seen, even if !getConvertCR().
	* kawa/lang/InPort.java (skipWhitespaceAndComments):  '\r'
	terminates comments starting with ';'.
	* kawa/lang/FString.java (open):  Return plain InPort (to match
	call-with-input-string in kawa.lib).
	* kawa/lang/CharArrayInPort.java (read):  Remove bad optimization.

	* kawa/lang/PrimProcedure.java:  Remove second <float> definition.

Mon Feb 16 16:01:37 1998  Per Bothner  <bothner@cygnus.com>

	* Makefile.am (EXTRA_DIST):  Add Debian source package files.

	* kawa/standard/{call_with_input_string.java,input_port_p.java,
	kawa/standard/output_port_p.java}:  Replaced by functions in kawa/lib.
	* kawa/standard/{Scheme.java,Makefile.am}:  Update accordingly.
	
	* kawa/lang/PrimProcedure.java (string2Type):  Check that name is
	valid Java class name only for not-yet-defined types.
	(getNamedType):  Add input-port and output-port.
	* kawa/lang/Translator.java (rewrite):  Don't call
	PrimProcedure.string2Type here - now handled by string2Type.
	* kawa/standard/prim_method.java (exp2Type):  Likewise.

	* kawa/lang/LineBufferedReader.java:  Re-write for increased
	performance, some extra features, and maybe some bug-fixes.
	(getConvertCR, setBuffer, skip_quick, unread_quick):  New methods.
	(fill):  New overrideable method, subsubmes readHook.
	(readHook):  Removed.
	* kawa/lang/InPort.java:  Efficiency improvements.
 	(readDigits):  New method.
	* kawa/lang/TtyInPort.java (fill):  New method, replaces readHook.
	* kawa/lang/{CharArrayInPort.java,NullReader.java}:  New classes.
	* kawa/lang/{Makefile.am,Makefile.in} (OBJ):  Update for new classes.
	* kawa/lang/FString.java (open):  New method.
	* kawa/standard/string2number.java (parse):  Use CharArrayInPort.
	* kawa/standard/Scheme.java (eval): Likewise.
	* kawa/Shell.java (runString):  Likewise.

	* kawa/standard/{convert.java,instance.java}:  Fix error messages.

Sun Feb  8 15:01:42 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in (VERSION):  Set to 1.6.

Fri Feb  6 17:17:17 1998  Per Bothner  <bothner@cygnus.com>

	* */Makefile.am, */Makefile.in (javadir):  Change from $(prefix)/java
	to $(datadir)/java.  More compatible with GNU standards and Linux FHS.
	* kawa/Makefile.am (kawa#(BAT)):  Update KAWALIB location accordingly.
	* kawa/Makefile.am (CLEANFILES):  Use *.class instead of $(OBJ).

	* kawa/standard/Scheme.java:  Add scheme-window procedure.
	* kawa/repl.java (main):  Add -w flag (creates new GuiConsole).

Tue Feb  3 12:57:50 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in, configure:  Set version to 1.5.95.

	* kawa/GuiConsole.java (close):  Make non-private.
	(Works around javac bug in some JDK versions.)
	* kawa/Shell.java:  Better handling of WrongArguments.
	* kawa/repl.java (main):  If compilation throws exception, print stack.
	
	* kawa/standard/{abs,angle,complex_p.denominator,exp,imag_part,log,
	magnitude,make_polar,make_rectangular,number_p,numerator,quantity_p,
	quotient,rational_p,real_p,real_part,remainder,zero_p}.java:
	Replaced by functions in lib.
	* kawa/standard.Scheme.java:  Many functions moved to kawa.lib.numbers.
	* kawa/standard/Makefile.{am,in}:  Update for removed files.
	* kawa/lang/PrimProcedure.java (getNamedType):  Add more logical names.

	* kawa/standard/convert.java: New Procedure2 implements "as".
	* kawa/standard/instance.java: New Procedure2 implements "instance?".
	* kawa.standard/{char_p,vector_p}.java:  Replaced by Scheme functions.
	* kawa/standard/Scheme.java:  Update for new or moved procedures.
	(byteType ... charType): New Scheme-specific SpecialType Types.
	* kawa/standard/Makefile.am:  Update accordingly.
	
	* kawa/lang/{AnyPat,ApplyExp,Char,Compilation,EqualPat,FString,IfExp,
	Keyword,LambdaExp,Literal,ListRepeatPat,Pair,PairPat,PrimProcedure,
	Record,ReferenceExp,SetExp,Special,SyntaxRule,SyntaxRules,Vector}.java:
	Update calls to gnu.bytecode methods (from compile_xxx to emitXxx).
	* kawa/lang/Char.java:  Use Scheme.charType.
	* kawa/lang/ApplyExp.java (compile):  Split off to new static function.
	* kawa/lang/CompileFile.java (read):  Check if unmatched ')' follows.
	* kawa/lang/InPort.java (readListBody):  Fix line-num off-by-one error.
	* kawa/lang/ReadError.java (construct_message):  Likewise.
	
	* kawa/lang/QuoteExp.java (getValue):  New final method.
	* kawa/lang/Translator.java (rewrite_pair):  If functions is an
	Inlineable Procedure, check that the number of args is ok.
	(rewrite):  Use string2Type instead of getNamedType.
	* kawa/lang/SpecialType.java:  New class - extends PrimType.
	* kawa/lang/Makefile.am:  Added SpecialType.class.
	* kawa/lang/Expression.java (compile(Compilation,int,Type)):  No
	longer need special handling here for char and boolean primtive types.
	* kawa/lang/Named.java (getName):  Make non-final.
	* kawa/lang/PrimProcedure.java (applyN):  Make work.
	(getNamedType):  Use new Scheme SpecialType objects.
	(getname):  new overriding method.
	(compile):  Can simplify, because of new SpecialType objects.
	
	* kawa/lang/WrongArguments.java (getMessage, constructor):  New.
	(checkArgCount):  New static method.
	Inherit from IllegalArgumentException, not RuntimeException.
	* kawa/lang/Procedure.java (numArgs):  New virtual method.
	(minArgs, maxArgs):  New final methods.
	(checkArgCount):  New static method.
	* kawa/lang/{Procedure0,Procedure0or1,Procedure1,Procedure1or2,
	Procedure2,Procedure3,Procedure4}.java
	(numArgs):  Add overriding method.
	(applyX):  Remove unneeded throws specifications.
	(applyX):  Use new WrongArguments constructor.
	* kawa/lang/Compilation.java:  If compiling to a ProcedureN class,
	emit numArgs method, and call to cehckArgs.

Tue Jan 27 12:02:33 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in (VERSION):  Set to 1.5.94.

Mon Jan 26 16:38:14 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/CatchClause.java:  Fixes to get things working.
	(getNext, setNext, getBody, setBody): New methods.
	* kawa/lang/TryExp.java:  More fixes.
	(getCatchClauses, setCatchClauses):  New.
	* kawa/standard/prim_throw.java:  New class implements primitive-throw.
	* kawa/standard/throw_name.java:  New Procedure implements throw.
	* kawa/standard/try_catch.java: new syntax, implements try-catch.
	* kawa/standard/error.java:  Removed class.

	* kawa/lang/Named.java (getName):  New method.

	* kawa/standard/Scheme.java (define_proc):  New method overload.
	(initScheme):  Add new methods.  Give name() to old ones.
	* kawa/{lang,standard}/Makefile.am:  Update for new/removed classes.
	
	* kawa/lang/Inlineable.java:  New interface.
	* kawa/lang/PrimApplyExp.java:  Removed - subsumed by PrimProcedure.
	* kawa/lang/PrimProcedure.java:  Implement Inlineable.
 	(compile):  New method, taken from PrimApplyExp.compile.
	* kawa/lang/ApplyExp.java (getArgs):  New method.
	(compile): If a quoted Inlineable function, call its compile method.
	* kawa/lang/Translator.java (rewrite_pair):  Check if func name is
	bound to an Inlineable proc;  if so, wrap it in a QuoteExp.
	But we no longer need to handle PrimProcedure specially.
	* kawa/standard/prim_method.java (exp2Type):  New method.
	(rewrite):  Use exp2Type.
	* kawa/lang/NamedException.java:  New class.

	* kawa/lang/PrimProcedure.java (getnamedType):  Don't put
	predefined <TYPENAME>s in types;  let rewrite handle it.
	* kawa/lang/Translator.java (rewrite):  Handle generate <TYPENAME>.

	* kawa/lang/InPort.java (readListBody):  Allow "(. x)", so change
	return type to Object instead of List.
	* kawa/lang/ModuleExp.java (constructor):  Update for readListBody.
	* kawa/lang/CompileFile.java (read):  Likewise.
	
	* kawa/lang/{WrongArguments.java,WrongType.java,UnboundSymbol.java,
	GenericError.java}:  Inherit from RuntimeException.

Sat Jan 24 14:31:52 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/MessageArea.java (endMark, length, out_stream):  New fields.
	(enter):  Don't pass KeyEvent, or do consume here.
	Better handling of various edits, including multi-line paste.
	(write):  New method, body taken from TextAreaWriter.
	(deleteOldText):  New method.
	(textValueChanged):  New listener method.
	* kawa/GuiConsole.java (constructor):  Create GuiInPort, not TtyInPort.
 	(actionPerformed):  Use MessageArea.deleteOldText.
	* kawa/GuiInPort.java:  New class.
	* kawa/TextAreaWriter.java (write(String)):  Call MessageArea.write.
	(write):  Add cast from int to char. (Patch from Albert Ting.)
	* kawa/Makefile.am, kawa/Makefile.in (OBJ):  Add GuiInPort.class.

Tue Jan 20 10:28:24 1998  Alternator Petrofsky  <albatros@wco.com>

	* kawa/lang/InPort.java (readState):  Changed to StringBuffer.
	isDelimiter, readNestedComment, readVector): New functions
	(skipWhitespaceAndComments): Handle nested comments.
	(readListBody): Update.  Use isDelimiter after dot.

Wed Jan 21 12:37:10 1998  Per Bothner  <bothner@cygnus.com>

	General cleanup of how Environments work, especially how they
	interact with Interpreters (i.e. Scheme) and Futures.
	* kawa/lang/Environment.java (global):  New static.
	(getCurrent, setCurrrent):  If current thread is not a Future,
 	get/set global, rather than Scheme.env.
	* kawa/lang/Future.java:  New constuctor, with given Environment.
	* kawa/lang/Interpreter.java (environ):  Make protected.
	(getEnvironment, setEnvironment):  New methods.
	(define, lookup):  Moved here from kawa/standard/Scheme.java.
	* kawa/standard/Scheme.java (builtin):  New static method.
 	(curEnvironment, setEnvironment, makeEnvironment):  Removed.
	(env):  Removed static field.
	(initcheme):  Use environ, in place of env.
	(constructor):  Re-write more cleanly.
	* kawa/standard/user_env.java:  Use Environment.user().
	* kawa/Shell.java (apply):  Set and restore current Environment.
	* kawa/repl.java (main):  Fix for new Scheme interface.
	* kawa/GuiConsole.java (constructor):  Add new Scheme environment
	to Future (instead of creating a new one).
	(main):  Update for new ENvironment conventions.	

	* kawa/{Makefile.am,Makefile.in} (SECONDARY_OBJS):
	Remove GuiConsole$$_MenuAction.class.
	* kawa/TextAreaWriter.java (write(String)):  New method.
	Insert at outputMark if writing to a MessageArea.
	* kawa/MessageArea.java (append):  Remove.
	(enter):  Nicer behavior.
	* kawa/GuiConsole.java:  More menu actions.  Various improvements.
	
Mon Jan 19 14:44:09 1998  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version to 1.5.93.

	* kawa/lang/Compilation.java (mangleClassName):  Renamed to mangleName.
	* kawa/lang/LambdaExp.java:  Update.
	* kawa/lang/Declaration.java (constructor):  Set Variable.name to
	mangled name (with mangleName), while Declaration.sym is source name.

	* kawa/Shell.java:  Extend Procedure0, so it can be passed to Future.
	Add contsructur, various fields, and make methods non-static.
	Remove code now in Scheme (read and print methods).
	(run, runString)  Take Interpreter arguemnts, not Environment.
	* kawa/repl.java:  Update for new Shell.run interfaces.
	* kawa/{TextAreaWriter.java,GuiConsole.java,MessageArea.java}:
	New classes, for making a Frame with a repl.
	* kawa/Makefile.am:  Add new classes.
	
	* kawa/standard/load.java (loadSource):  Update for new Shell.run.

	* kawa/lang/Interpreter.java (read, print):  New abstract methods.
	* kawa/standard/Scheme.java (read, print):  New methods.
	(Scheme):  Support multiple instances and environments.
	(initScheme):  New method, created from Scheme constructor.
	Add port-char-encoding, copy-file, input-port-read-state.

	* kawa/lang/Expression.java (eval):  Make non-abstract.  Throw error.
	* kawa/lang/LetExp.java (eval):  Remove.

	* kawa/lang/LineBufferedReader.java (convertCR)  New field.
	(setConvertCR):  New method.
	(read):  Only squash CR and CRLF to LF if convertCR.
	* kawa/standard/{open_input_file.java,open_output_file.java}:
	Use port-char-encoding to select char conversion and text vs binary.

	* kawa/lang/OutPort.java (outDefault, setOutDefault, errDefault,
	setErrDefault):  Get/set thread-local port (in current Future).
	* kawa/lang/InPort.java (inDefault, setInDefault):  Likewise.

	* kawa/lang/QueueReader.java:  New class.

	* kawa/lang/TryExp.java:  Add code to implement try-catch.
	* kawa/lang/CatchClause.java:  New class, for try-catch catch clause.
	* kawa/lang/Makefile.am:  Add QueueReader and CatchClause.

	* kawa/lang/PrimProcedure.java (toString):  Added.
	(member):  New field.
	(applyN):  Implement (partially) using reflection.

Thu Jan 15 13:03:02 1998  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/InPort.java (readState):  New field.
	(getReadState):  New method.  (Used by input-port-read-state.)
	(readList, readSchemeObject):  Set and restore readState.

Sat Jan 10 13:42:48 1998  Alcibiades Petrofsky <albatros@wco.com>

	* kawa/lang/Continuation.java:  Support multi-value continuation.

	Support full R4RS number syntax, including polar, plus infinity/NaN.
	* kawa/lang/InPort.java (readSchemeComplex):  New method.
 	(readSchemeNumber, readSchemeReal):  Re-write.
	* kawa/standard/string2number.java:  Update.

Sun Dec 14 22:42:44 1997  Per Bothner  <bothner@cygnus.com>

	* configure.in:  Set version to 1.5.92.
	* kawa/repl.java:  Define new variable symbol-read-case.
	* kawa/lang/InPort.java (getReadCase):  New function.
	(readSymbol):  Check value of getReadCase.
	* kawa/langEnvironment.java (user):  Now just returns value of current.
	
Sun Dec 14 16:12:19 1997  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/*.java:  More updates for gnu.bytecode changes.
	* kawa/lang/Compilation.java (addClass):  Fix type of "this".
	* kawa/lang/Environment.java (current):  Renamed to getCurrent.
	(setCurrent):  New method.
	Various fixes to support per-thread environments.
	* kawa/lang/ModuleExp.java (eval_module):  Set and restore
	current Environment if we must compile.

	* kawa/lang/Expression.java (getType):  New method.
	* kawa/lang/TryExp.java:  New class, for try-finally expressions.
	* kawa/lang/Makefile.am:  Add TryExp.

	* kawa/standard/Scheme.java (setEnvironment):  New method.
	(Scheme):  Define dynamic-wind and fluid-let.
	* kawa/standard/try_finally.java:  New class which extends Syntax.
	* kawa/standard/Makefile.am:  Added try_finally.

	* kawa/standard/load.java (loadCompiled):  Update ZipLoaded constuctor.

Thu Nov 27 21:42:08 1997  Per Bothner  <bothner@cygnus.com>

	* kawa/lang/*.java:  Update for gnu.bytecode changes.
	(Mostly change Method.compile_xxx to CodeAttr.emitXxx.)
	* kawa/repl.java (checkInitFile):  Fix thinko (sense of test).
	On non-Unix-like system, read kawarc.scm instead of .kawarc.scm.

Wed Nov 12 22:25:56 1997  Per Bothner  <bothner@cygnus.com>

